/*==============================================================*/
/* DBMS name:      PostgreSQL 8                                 */
/* Created on:     06/10/2009 15:34:47                          */
/*==============================================================*/

set search_path = dbsisppi,pg_catalog;

create sequence SQ_ABRANAGREGA_COSEQABRANAGREG;

create sequence SQ_ABRANGCIAA_COSEQABRANGCIAA;

create sequence SQ_ABRANGCIAH_COSEQABRANGCIAH;

create sequence SQ_ABRANGEUTI_COSEQABRANGEUTI;

create sequence SQ_ACAO_COSEQACAO;

create sequence SQ_AGREGADO_COSEQAGREGADO;

create sequence SQ_ALTACOMPAMB_COSEQALTCOMPAMB;

create sequence SQ_ALTCOMAMBMOD_COSEQALTCOMMOD;

create sequence SQ_ALTCOMFORFI_COSEQALTCOMFOFI;

create sequence SQ_AREAATUACAO_COSEQAREAATUACA;

create sequence SQ_AREAESTRAT_COSEQAREAESTRAT;

create sequence SQ_CARDAPIO_COSEQCARDAPIO;

create sequence SQ_CONFIGPOPUL_COSEQCONFIGPOPU;

create sequence SQ_CONFMEDALTCOM_COSEQCONMEALC;

create sequence SQ_CONSPERCINTH_COSEQCONSPERC;

create sequence SQ_CONTBASMUN_COSEQCONTBASMUN;

create sequence SQ_DESTAQUE_COSEQDESTAQUE;

create sequence SQ_DISTRIBUICAO_COSEQDISTRIB;

create sequence SQ_DISTRITOPPI_COSEQDISTRITO;

create sequence SQ_DUVIDA_COSEQDUVIDA;

create sequence SQ_ENCAMINAGREGA_COSEQENCAAGRE;

create sequence SQ_ENCAMINHADORA_COSEQENCAMINA;

create sequence SQ_ENCAMINHADORH_COSEQENCAMINH;

create sequence SQ_ENCAMINUTI_COSEQENCAMINHUTI;

create sequence SQ_ESPECEXECA_COSEQESPECEXECA;

create sequence SQ_ESPECEXECH_COSEQESPECEXECH;

create sequence SQ_ESPECEXECUTI_COSEQESPEXEUTI;

create sequence SQ_ESPEXECHMUN_COSEQESPEXEHMUN;

create sequence SQ_ESTRUTREGIO_COSEQESTRUREGIO;

create sequence SQ_EXECAGREGA_COSEQEXECAGREGAD;

create sequence SQ_IBGE_COSEQIBGE;

create sequence SQ_INFORMACAO_COSEQINFORMACAO;

create sequence SQ_LEITOESPECH_COSEQLEITESPECH;

create sequence SQ_LEITOESPHMUN_COSEQLEIESPHMU;

create sequence SQ_LEITOUTIH_COSEQLEITOUTIH;

create sequence SQ_LIMITEFINAN_COSEQLIMITEFINA;

create sequence SQ_MODALIDADE_COSEQMODALIDADE;

create sequence SQ_NIVELREGIO_COSEQNIVELREGION;

create sequence SQ_PARALTCOMPA_COSEQPARALTCOMA;

create sequence SQ_PARAMBOLSA_COSEQPARAMBOLSA;

create sequence SQ_POPULCALC_COSEQPOPULCALC;

create sequence SQ_PPICOMPETENCIA_COSEQPPICOMP;

create sequence SQ_PPI_COSEQPPI;

create sequence SQ_PROCNAOSUS_COSEQPROCNAOSUS;

create sequence SQ_PROGRAMACAO_COSEQPROGACAO;

create sequence SQ_PROGRAMPOPUL_COSEQPROGPOPUL;

create sequence SQ_RECURESPEC_COSEQRECURSESPEC;

create sequence SQ_REGIONALIZACAO_COSEQREGIONA;

create sequence SQ_TEMA_COSEQTEMA;

create sequence SQ_TIPOESTIMATIVA_COSEQTIPOEST;

create sequence SQ_TIPOPOPULACAO_COSEQTPPOPUL;

create sequence SQ_TIPOREGIONA_COSEQTIPOREGION;

create sequence SQ_TIPOUTI_COSEQTIPOUTI;

create sequence SQ_TPRECURSESPEC_COSEQTPRECESP;

/*==============================================================*/
/* Table: RL_ACAO_PROCEDIMENTO                                  */
/*==============================================================*/
create table RL_ACAO_PROCEDIMENTO (
   CO_ACAO              NUMERIC(28)          not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_OCUPACAO          VARCHAR(6)           not null,
   constraint PK_ACAO_PROCEDIMENTO primary key (CO_ACAO, CO_PROCEDIMENTO, CO_OCUPACAO)
);

comment on table RL_ACAO_PROCEDIMENTO is
'Tabela relacional entre aes e procedimentos.';

comment on column RL_ACAO_PROCEDIMENTO.CO_ACAO is
'Cdigo seqencial da TB_ACAO - Chave estrangeira.';

comment on column RL_ACAO_PROCEDIMENTO.CO_PROCEDIMENTO is
'Cdigo seqencial da TB_PROCEDIMENTO - Chave primria.';

comment on column RL_ACAO_PROCEDIMENTO.CO_OCUPACAO is
'Cdigo da Ocupao';

/*==============================================================*/
/* Index: IN_RLACAOPROCEDIMENTO_COACAO                          */
/*==============================================================*/
create  index IN_RLACAOPROCEDIMENTO_COACAO on RL_ACAO_PROCEDIMENTO (
(substr(co_acao, 8,6))
);

/*==============================================================*/
/* Table: RL_ACAO_PROCEDIMENTONAOSUS                            */
/*==============================================================*/
create table RL_ACAO_PROCEDIMENTONAOSUS (
   CO_PROCEDIMENTO_NAO_SUS NUMERIC(28)          not null,
   CO_ACAO              NUMERIC(28)          not null,
   constraint PK_ACAO_PROCEDIMENTONAOSUS primary key (CO_PROCEDIMENTO_NAO_SUS, CO_ACAO)
);

comment on table RL_ACAO_PROCEDIMENTONAOSUS is
'Tabela relacional entre TB_ACAO e TB_PROCEDIMENTO_NAO_SUS.';

comment on column RL_ACAO_PROCEDIMENTONAOSUS.CO_PROCEDIMENTO_NAO_SUS is
'Cdigo do Procedimento no-SUS - Chave primria';

comment on column RL_ACAO_PROCEDIMENTONAOSUS.CO_ACAO is
'Cdigo seqencial da TB_ACAO - Chave estrangeira.';

/*==============================================================*/
/* Table: RL_AGREGADO_PROCEDIMENTO                              */
/*==============================================================*/
create table RL_AGREGADO_PROCEDIMENTO (
   CO_AGREGADO          NUMERIC(28)          not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_OCUPACAO          VARCHAR(6)           not null,
   constraint PK_AGREGADO_PROCEDIMENTO primary key (CO_AGREGADO, CO_PROCEDIMENTO, CO_OCUPACAO)
);

comment on table RL_AGREGADO_PROCEDIMENTO is
'Tabela relacional entre agregados e procedimentos.';

comment on column RL_AGREGADO_PROCEDIMENTO.CO_AGREGADO is
'Cdigo do agregado, onde os procedimentos sero agregados.';

comment on column RL_AGREGADO_PROCEDIMENTO.CO_PROCEDIMENTO is
'Cdigo seqencial da TB_PROCEDIMENTO - Chave primria.';

comment on column RL_AGREGADO_PROCEDIMENTO.CO_OCUPACAO is
'Cdigo da ocupao';

/*==============================================================*/
/* Index: IN_AGREGPROC_COPROCOCUPAAGREG                         */
/*==============================================================*/
create  index IN_AGREGPROC_COPROCOCUPAAGREG on RL_AGREGADO_PROCEDIMENTO (
CO_PROCEDIMENTO,
CO_OCUPACAO,
CO_AGREGADO
);

/*==============================================================*/
/* Table: RL_ALTACOMPAMBMODAL_PROCEDIMEN                        */
/*==============================================================*/
create table RL_ALTACOMPAMBMODAL_PROCEDIMEN (
   CO_ALTA_COMP_AMB_MOD NUMERIC(28)          not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_PPI               NUMERIC(28)          not null,
   VL_DIVISOR_ONCOLOGIA_TRS NUMERIC(8,2)         null,
   VL_DIVISOR_TRS       NUMERIC(8,2)         null,
   constraint PK_ALTACOMPAMBMODAL_PROCEDIMEN primary key (CO_ALTA_COMP_AMB_MOD, CO_PROCEDIMENTO, CO_PPI)
);

comment on table RL_ALTACOMPAMBMODAL_PROCEDIMEN is
'Tabela relacional entre modalidade de alta complexidade e procedimentos ambulatoriais.';

comment on column RL_ALTACOMPAMBMODAL_PROCEDIMEN.CO_ALTA_COMP_AMB_MOD is
'Cdigo de modalidades das altas complexidades.';

comment on column RL_ALTACOMPAMBMODAL_PROCEDIMEN.CO_PROCEDIMENTO is
'Cdigo do procedimento - Chave primria';

comment on column RL_ALTACOMPAMBMODAL_PROCEDIMEN.CO_PPI is
'Cdigo da PPI principal';

comment on column RL_ALTACOMPAMBMODAL_PROCEDIMEN.VL_DIVISOR_ONCOLOGIA_TRS is
'Quantia utilizada para encontrar o valor do procedimento aprovado, de acordo com a produo. Para procedimentos de oncologia e TRS.';

comment on column RL_ALTACOMPAMBMODAL_PROCEDIMEN.VL_DIVISOR_TRS is
'Quantia utilizada para encontrar o valor do procedimento aprovado, de acordo com a produo. Para procedimentos de TRS.';

/*==============================================================*/
/* Index: IN_ALTACOMPAMBMODAL_PROCEDIMEN                        */
/*==============================================================*/
create  index IN_ALTACOMPAMBMODAL_PROCEDIMEN on RL_ALTACOMPAMBMODAL_PROCEDIMEN (
CO_ALTA_COMP_AMB_MOD,
CO_PPI,
CO_PROCEDIMENTO
);

/*==============================================================*/
/* Table: RL_ALTACOMPAMB_MODALIDADE                             */
/*==============================================================*/
create table RL_ALTACOMPAMB_MODALIDADE (
   CO_SEQ_ALTA_COMP_AMB_MOD NUMERIC(28)          not null,
   CO_ALTA_COMP_AMB     NUMERIC(8)           null,
   CO_MODALIDADE        NUMERIC(8)           null,
   ST_ESTADUAL          VARCHAR(1)           null,
   ST_MUNICIPAL         VARCHAR(1)           null,
   constraint PK_ALTACOMPAMB_MODALIDADE primary key (CO_SEQ_ALTA_COMP_AMB_MOD)
);

comment on table RL_ALTACOMPAMB_MODALIDADE is
'Tabela relacional entre alta complexidade ambulatorial e modalidade.';

comment on column RL_ALTACOMPAMB_MODALIDADE.CO_SEQ_ALTA_COMP_AMB_MOD is
'Cdigo da alta complexidade ambulatorial e modalidade';

comment on column RL_ALTACOMPAMB_MODALIDADE.CO_ALTA_COMP_AMB is
'Cdigo das descries da alta complexidade.';

comment on column RL_ALTACOMPAMB_MODALIDADE.CO_MODALIDADE is
'Cdigo da modalidade de um servio';

comment on column RL_ALTACOMPAMB_MODALIDADE.ST_ESTADUAL is
'Status que informa se o servio ser apresentado no mdulo estadual';

comment on column RL_ALTACOMPAMB_MODALIDADE.ST_MUNICIPAL is
'Status que informa se o servio ser apresentado no mdulo municipal';

/*==============================================================*/
/* Table: RL_AREAALOCACAO_FINANCIAMENPPI                        */
/*==============================================================*/
create table RL_AREAALOCACAO_FINANCIAMENPPI (
   CO_AREA_ALOCACAO     NUMERIC(4)           not null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   ST_ESFERA_ESTADUAL   VARCHAR(1)           null,
   CO_TIPO_VALOR        NUMERIC(4)           null,
   ST_PROGRAMAVEL       VARCHAR(1)           null,
   ST_ALTERA_VALOR_MUNIC VARCHAR(1)           null,
   ST_GERA_LIMITE       VARCHAR(1)           null,
   ST_ESFERA_MUNICIPAL  VARCHAR(1)           null,
   constraint PK_AREAALOCACAOFINANCIAMENPPI primary key (CO_AREA_ALOCACAO, CO_FINANCIAMENTO, CO_PPI)
);

comment on table RL_AREAALOCACAO_FINANCIAMENPPI is
'Tabela Relacional de configurao das reas de Alocao em relao as formas de financiamentos ativas';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.CO_AREA_ALOCACAO is
'Cdigo de identificao da rea de Alocao';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.CO_PPI is
'Cdigo da PPI principal';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.ST_ESFERA_ESTADUAL is
'Status que diz se certa rea de Alocao em relao a forma de financiamento est disponvel para determinada esfera.
ex :
R - REGIONAL
E - ESTADUAL
M - MUNICIPAL';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.CO_TIPO_VALOR is
'Tipo "Domnio".
Cdigo do tipo de valor a ser apresentado dependendo de cada
configurao feita (rea de Alocao x Forma de Financiamento)
1 - VALOR ZERADO - PAB / VS
2 - VALOR PER CAPITA - AGREGADOS
3 - VALOR FIXO - INCENTIVO / RESERVA TCNICA
4 - VALOR FIXO - ABRANGNCIA';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.ST_PROGRAMAVEL is
'Status que diz se os parmetros podero ser programados ou no.
S - SIM
N - NO';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.ST_ALTERA_VALOR_MUNIC is
'Status que diz se um valor pode ser alterado ou no no mdulo Municipal.
S - SIM
N - NO';

comment on column RL_AREAALOCACAO_FINANCIAMENPPI.ST_GERA_LIMITE is
'Status que diz se os parmetros do limite sero calculados ou no.
S - SIM
N - NO';

/*==============================================================*/
/* Table: RL_ESTAB_SERV_CLASS_PPI                               */
/*==============================================================*/
create table RL_ESTAB_SERV_CLASS_PPI (
   CO_UNIDADE           VARCHAR(31)          null,
   CO_SERVICO           VARCHAR(3)           null,
   CO_CLASSIFICACAO     VARCHAR(3)           null,
   CO_AMBULATORIAL_SUS  VARCHAR(1)           null,
   CO_HOSPITALAR_SUS    VARCHAR(1)           null
);

comment on table RL_ESTAB_SERV_CLASS_PPI is
'Tabela relacional dos estabelecimentos de sade com seus servios e respectivas classificaes';

comment on column RL_ESTAB_SERV_CLASS_PPI.CO_UNIDADE is
'Cdigo formado pela juno do cdigo do municpio com o cdigo CNES';

comment on column RL_ESTAB_SERV_CLASS_PPI.CO_SERVICO is
'Cdigo do servio do estabelecimento';

comment on column RL_ESTAB_SERV_CLASS_PPI.CO_CLASSIFICACAO is
'Cdigo da classificao do estabelecimento';

comment on column RL_ESTAB_SERV_CLASS_PPI.CO_AMBULATORIAL_SUS is
'Cdigo que identifica se o estabelecimento  vinculado ao SUS ou no, na parte ambulatorial';

comment on column RL_ESTAB_SERV_CLASS_PPI.CO_HOSPITALAR_SUS is
'Cdigo que identifica se o estabelecimento  vinculado ao SUS ou no, na parte hospitalar';

/*==============================================================*/
/* Table: RL_ESTAB_SIPAC_PPI                                    */
/*==============================================================*/
create table RL_ESTAB_SIPAC_PPI (
   CO_UNIDADE           VARCHAR(31)          null,
   CO_SUBGRUPO_HABILITACAO VARCHAR(4)           null,
   QT_LEITO             NUMERIC(8)           null,
   CO_CNES              VARCHAR(7)           null
);

comment on table RL_ESTAB_SIPAC_PPI is
'Tabela relacional entre os estabelecimentos e suas habilitaes';

comment on column RL_ESTAB_SIPAC_PPI.CO_UNIDADE is
'Cdigo formado pela juno do cdigo do municpio com o cdigo CNES';

comment on column RL_ESTAB_SIPAC_PPI.CO_SUBGRUPO_HABILITACAO is
'Cdigo de subgrupo de habilitao de um estabelecimento de sade';

comment on column RL_ESTAB_SIPAC_PPI.QT_LEITO is
'Nmero de leitos de um estabelecimento de sade habilitado';

comment on column RL_ESTAB_SIPAC_PPI.CO_CNES is
'Cdigo que representa o estabelecimento de sade';

/*==============================================================*/
/* Table: RL_FORMAFINAN_PPI_PROGRAMACUTI                        */
/*==============================================================*/
create table RL_FORMAFINAN_PPI_PROGRAMACUTI (
   CO_FINANCIAMENTO_PROG VARCHAR(2)           not null,
   CO_FINANCIAMENTO_PROD VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   TP_IDENTIFICADOR     VARCHAR(1)           not null,
   constraint PK_FORMAFINAN_PPI_PROGRAMACUTI primary key (CO_FINANCIAMENTO_PROG, CO_FINANCIAMENTO_PROD, CO_PPI, TP_IDENTIFICADOR)
);

comment on table RL_FORMAFINAN_PPI_PROGRAMACUTI is
'Tabela utilizada para buscar a programao da UTI. Essa programao  efetuada na tela de TB_LEITO_UTI_H.';

comment on column RL_FORMAFINAN_PPI_PROGRAMACUTI.CO_FINANCIAMENTO_PROG is
'Cdigo da forma de financiamento da programao que representa trs formas na produo.';

comment on column RL_FORMAFINAN_PPI_PROGRAMACUTI.CO_FINANCIAMENTO_PROD is
'Cdigo da forma de financiamento que vai unir trs formas em uma nica';

comment on column RL_FORMAFINAN_PPI_PROGRAMACUTI.CO_PPI is
'Cdigo da PPI principal';

comment on column RL_FORMAFINAN_PPI_PROGRAMACUTI.TP_IDENTIFICADOR is
'Identifica o tipo: 1- UTI, 2- UCI';

/*==============================================================*/
/* Table: RL_NIVELREGIONALIZACAO_MUNICI                         */
/*==============================================================*/
create table RL_NIVELREGIONALIZACAO_MUNICI (
   CO_NIVEL_REGIONALIZACAO NUMERIC(4)           not null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   constraint PK_NIVELREGIONALIZACAO_MUNICI primary key (CO_NIVEL_REGIONALIZACAO, CO_MUNICIPIO_IBGE)
);

comment on table RL_NIVELREGIONALIZACAO_MUNICI is
'Tabela relacional entre nveis de regionalizao e municpios';

comment on column RL_NIVELREGIONALIZACAO_MUNICI.CO_NIVEL_REGIONALIZACAO is
'Cdigo seqencial da tabela TB_NIVEL_REGIONALIZACAO - Chave Primria.';

comment on column RL_NIVELREGIONALIZACAO_MUNICI.CO_MUNICIPIO_IBGE is
'Cdigo seqencial  da tabela TB_MUNICIPIO - Chave primria.';

/*==============================================================*/
/* Table: RL_PROCEDIMENTOSIH_LEITOPPI                           */
/*==============================================================*/
create table RL_PROCEDIMENTOSIH_LEITOPPI (
   CO_LEITO             VARCHAR(2)           not null,
   CO_ESPECIALIDADE     VARCHAR(2)           not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   NU_IDADE_INICIAL     VARCHAR(3)           null,
   NU_IDADE_FINAL       VARCHAR(3)           null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   CO_PPI               NUMERIC(28)          null,
   constraint PK_PROCEDIMENTOSIH_LEITOPPI primary key (CO_LEITO, CO_ESPECIALIDADE, CO_PROCEDIMENTO)
);

comment on table RL_PROCEDIMENTOSIH_LEITOPPI is
'Tabela relacional entre procedimentos H e especialidade do leito.';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.CO_LEITO is
'Cdigo do leito de um estabelecimento';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.CO_ESPECIALIDADE is
'Cdigo da especialidade';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.CO_PROCEDIMENTO is
'Cdigo do procedimento - Chave primria';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.NU_IDADE_INICIAL is
'Idade mnima em que o procedimento poder ser realizado no paciente';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.NU_IDADE_FINAL is
'Idade mxima em que o procedimento poder ser realizado no paciente';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento dos procedimentos';

comment on column RL_PROCEDIMENTOSIH_LEITOPPI.CO_PPI is
'Cdigo da PPI - Pactuao Programada Integrada.';

/*==============================================================*/
/* Table: RL_PROCEDIMENTO_SIA_SIH                               */
/*==============================================================*/
create table RL_PROCEDIMENTO_SIA_SIH (
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_PROCEDIMENTO_SIA_SIH VARCHAR(8)           not null,
   TP_PROCEDIMENTO      VARCHAR(1)           not null,
   constraint PK_PROCEDIMENTO_SIA_SIH primary key (CO_PROCEDIMENTO, CO_PROCEDIMENTO_SIA_SIH, TP_PROCEDIMENTO)
);

comment on table RL_PROCEDIMENTO_SIA_SIH is
'Tabela relacional entre os novos procedimentos da tabela unificada e os procedimentos antigos.';

comment on column RL_PROCEDIMENTO_SIA_SIH.CO_PROCEDIMENTO is
'Cdigo do procedimento unificado.';

comment on column RL_PROCEDIMENTO_SIA_SIH.CO_PROCEDIMENTO_SIA_SIH is
'Cdigo dos Procedimentos Hospitalar e Ambulatorial antigos.';

comment on column RL_PROCEDIMENTO_SIA_SIH.TP_PROCEDIMENTO is
'Tipo do procedimento: A - Ambulatorial H - Hospitalar';

/*==============================================================*/
/* Table: RL_PROCEDIMENTO_UTI_UCI                               */
/*==============================================================*/
create table RL_PROCEDIMENTO_UTI_UCI (
   CO_PROCEDIMENTO_ATO_PROF VARCHAR(10)          not null,
   CO_TIPO_LEITO        VARCHAR(2)           not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   constraint PK_PROCEDIMENTOUTIUCI primary key (CO_PROCEDIMENTO_ATO_PROF, CO_TIPO_LEITO, CO_PROCEDIMENTO)
);

comment on table RL_PROCEDIMENTO_UTI_UCI is
'Tabela relacional entre os procedimentos (antigos - atos profissionais) de UTI e UCI de acordo com seus tipos de leitos';

comment on column RL_PROCEDIMENTO_UTI_UCI.CO_PROCEDIMENTO_ATO_PROF is
'Cdigo do procedimento hospitalar na forma de ato profissional de acordo com o arquivo "SP"';

comment on column RL_PROCEDIMENTO_UTI_UCI.CO_TIPO_LEITO is
'Cdigo do tipo de leito da tabela unificada';

comment on column RL_PROCEDIMENTO_UTI_UCI.CO_PROCEDIMENTO is
'Cdigo do procedimento da tabela unificada';

/*==============================================================*/
/* Table: RL_PROC_AMB_CBO_SIA_SIH                               */
/*==============================================================*/
create table RL_PROC_AMB_CBO_SIA_SIH (
   CO_PROCEDIMENTO_SIA_SIH VARCHAR(7)           not null,
   CO_OCUPACAO          VARCHAR(6)           not null,
   constraint PK_PROCAMBCBOSIASIH primary key (CO_PROCEDIMENTO_SIA_SIH, CO_OCUPACAO)
);

comment on table RL_PROC_AMB_CBO_SIA_SIH is
'Tabela para compor o DE-PARA da produo ambulatorial para procedimentos antigos do SIA / SIH que tero CBO.';

comment on column RL_PROC_AMB_CBO_SIA_SIH.CO_PROCEDIMENTO_SIA_SIH is
'Cdigo do procedimento antigo';

comment on column RL_PROC_AMB_CBO_SIA_SIH.CO_OCUPACAO is
'Cdigo que identifica a classificao das ocupaes definidas pela CBO-2002';

/*==============================================================*/
/* Index: IN_PROCAMBCBOSIASIH_PROCSIASIH                        */
/*==============================================================*/
create  index IN_PROCAMBCBOSIASIH_PROCSIASIH on RL_PROC_AMB_CBO_SIA_SIH (
CO_PROCEDIMENTO_SIA_SIH
);

/*==============================================================*/
/* Table: TB_ABRANGENCIA_A                                      */
/*==============================================================*/
create table TB_ABRANGENCIA_A (
   CO_SEQ_ABRANGENCIA_A NUMERIC(28)          not null,
   CO_PARAM_ALTA_COMP_A NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   VL_PERC              NUMERIC(16,10)       null,
   QT_FISICO_DISTRIBUIDO NUMERIC(16,10)       null,
   constraint PK_ABRANGENCIA_A primary key (CO_SEQ_ABRANGENCIA_A)
);

comment on table TB_ABRANGENCIA_A is
'Tabela com os municpios executores e encaminhadores do que foi programado na TB_PARAMETRIZACAO_ALTA_COMP_A.
Todos os campos so programados por servios de alta complexidade ambulatorial e por forma de financiamento PPI.';

comment on column TB_ABRANGENCIA_A.CO_SEQ_ABRANGENCIA_A is
'Cdigo que contm todas as esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, 
a sequence de cada tabela de todos os nveis.';

comment on column TB_ABRANGENCIA_A.CO_PARAM_ALTA_COMP_A is
'Cdigo dos parmetros da alta complexidade ambulatorial';

comment on column TB_ABRANGENCIA_A.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO.';

comment on column TB_ABRANGENCIA_A.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO.';

comment on column TB_ABRANGENCIA_A.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ABRANGENCIA_A.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ABRANGENCIA_A.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ABRANGENCIA_A.QT_FISICO_DISTRIBUIDO is
'Quantidade de recurso de atendimento por municpio';

/*==============================================================*/
/* Index: IN_ABRANGA_COPARALTACOCOMUNMOV                        */
/*==============================================================*/
create  index IN_ABRANGA_COPARALTACOCOMUNMOV on TB_ABRANGENCIA_A (
CO_PARAM_ALTA_COMP_A,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Index: IN_ABRANGA_COPARALTCOMACOMURES                        */
/*==============================================================*/
create  index IN_ABRANGA_COPARALTCOMACOMURES on TB_ABRANGENCIA_A (
CO_PARAM_ALTA_COMP_A,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ABRANGENCIA_AGREGADO                               */
/*==============================================================*/
create table TB_ABRANGENCIA_AGREGADO (
   CO_SEQ_ABRANGENCIA_AGREGADO NUMERIC(28)          not null,
   CO_AGREGADO          NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   VL_PERC              NUMERIC(16,10)       null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   CO_PPI               NUMERIC(28)          null,
   QT_FISICO_DISTRIBUIDO NUMERIC(16,10)       null,
   constraint PK_ABRANGENCIAAGREGADO primary key (CO_SEQ_ABRANGENCIA_AGREGADO)
);

comment on table TB_ABRANGENCIA_AGREGADO is
'Tabela com os municpios executores e encaminhadores do que foi programado nos Agregados.';

comment on column TB_ABRANGENCIA_AGREGADO.CO_SEQ_ABRANGENCIA_AGREGADO is
'Cdigo que contm todas as esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo,
a sequence de cada tabela de todos os nveis.';

comment on column TB_ABRANGENCIA_AGREGADO.CO_AGREGADO is
'Cdigo dos parmetros dos Agregados';

comment on column TB_ABRANGENCIA_AGREGADO.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO.';

comment on column TB_ABRANGENCIA_AGREGADO.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO.';

comment on column TB_ABRANGENCIA_AGREGADO.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ABRANGENCIA_AGREGADO.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ABRANGENCIA_AGREGADO.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ABRANGENCIA_AGREGADO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_ABRANGENCIA_AGREGADO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_ABRANGENCIA_AGREGADO.QT_FISICO_DISTRIBUIDO is
'Quantidade de recurso de atendimento por municpio';

/*==============================================================*/
/* Index: IN_ABRANAGRE_COAGREGCOMUNMOV                          */
/*==============================================================*/
create  index IN_ABRANAGRE_COAGREGCOMUNMOV on TB_ABRANGENCIA_AGREGADO (
CO_AGREGADO,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Index: IN_ABRANGA_COAGREGADOCOMURES                          */
/*==============================================================*/
create  index IN_ABRANGA_COAGREGADOCOMURES on TB_ABRANGENCIA_AGREGADO (
CO_AGREGADO,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ABRANGENCIA_H                                      */
/*==============================================================*/
create table TB_ABRANGENCIA_H (
   CO_SEQ_ABRANGENCIA_H NUMERIC(28)          not null,
   CO_LEITO_ESPEC_H     NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   VL_PERC              NUMERIC(16,10)       null,
   QT_FISICO_DISTRIBUIDO NUMERIC(16,10)       null,
   constraint PK_ABRANGENCIA_H primary key (CO_SEQ_ABRANGENCIA_H)
);

comment on table TB_ABRANGENCIA_H is
'Tabela com os municpios executores e encaminhadores do que foi programado na TB_PARAMETRIZACAO_ALTA_COMP_A.
Todos os campos so programados por tipo de leito, especialidade, forma de financiamento, complexidade, PPI e municpio executor.';

comment on column TB_ABRANGENCIA_H.CO_SEQ_ABRANGENCIA_H is
'Cdigo que contm todas as esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, 
a sequence de cada tabela de todos os nveis.';

comment on column TB_ABRANGENCIA_H.CO_LEITO_ESPEC_H is
'Cdigo dos parmetros da alta complexidade hospitalar';

comment on column TB_ABRANGENCIA_H.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO';

comment on column TB_ABRANGENCIA_H.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO.';

comment on column TB_ABRANGENCIA_H.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ABRANGENCIA_H.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ABRANGENCIA_H.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ABRANGENCIA_H.QT_FISICO_DISTRIBUIDO is
'Quantidade de recurso de atendimento por municpio';

/*==============================================================*/
/* Index: IN_ABRANGEH_COLEIESPMUNIC                             */
/*==============================================================*/
create  index IN_ABRANGEH_COLEIESPMUNIC on TB_ABRANGENCIA_H (
CO_LEITO_ESPEC_H,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Index: IN_ABRANGH_COLEIESPHCOMUNRES                          */
/*==============================================================*/
create  index IN_ABRANGH_COLEIESPHCOMUNRES on TB_ABRANGENCIA_H (
CO_LEITO_ESPEC_H,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ABRANGENCIA_UTI                                    */
/*==============================================================*/
create table TB_ABRANGENCIA_UTI (
   CO_SEQ_ABRANGENCIA_UTI NUMERIC(28)          not null,
   CO_LEITO_UTI_H       NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   VL_PERC              NUMERIC(16,10)       null,
   QT_FISICO_DISTRIBUIDO NUMERIC(16,10)       null,
   constraint PK_ABRANGENCIA_UTI primary key (CO_SEQ_ABRANGENCIA_UTI)
);

comment on table TB_ABRANGENCIA_UTI is
'Tabela com os municpios executores e encaminhadores do que foi programado na TB_LEITO_ESPEC_UTI.
 Todos os campos so programados por tipo de UTI, forma de financiamento, PPI e muncpio executor.';

comment on column TB_ABRANGENCIA_UTI.CO_SEQ_ABRANGENCIA_UTI is
'Cdigo das esferas Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, 
a sequence de cada tabela de todos os nveis.';

comment on column TB_ABRANGENCIA_UTI.CO_LEITO_UTI_H is
'Cdigo das esferas Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, 
a sequence de cada tabela de todos os nveis.';

comment on column TB_ABRANGENCIA_UTI.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO';

comment on column TB_ABRANGENCIA_UTI.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave estrangeira da tabela DBGERAL_TB_MUNICIPIO';

comment on column TB_ABRANGENCIA_UTI.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ABRANGENCIA_UTI.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ABRANGENCIA_UTI.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ABRANGENCIA_UTI.QT_FISICO_DISTRIBUIDO is
'Quantidade de recurso de atendimento por municpio';

/*==============================================================*/
/* Index: IN_ABRANGEUTI_COLEUTICOMUNMOV                         */
/*==============================================================*/
create  index IN_ABRANGEUTI_COLEUTICOMUNMOV on TB_ABRANGENCIA_UTI (
CO_LEITO_UTI_H,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Index: IN_ABRANGUTI_COMUNRESCOLEIUTIH                        */
/*==============================================================*/
create  index IN_ABRANGUTI_COMUNRESCOLEIUTIH on TB_ABRANGENCIA_UTI (
CO_MUNICIPIO_IBGE_RES,
CO_LEITO_UTI_H
);

/*==============================================================*/
/* Table: TB_ACAO                                               */
/*==============================================================*/
create table TB_ACAO (
   CO_SEQ_ACAO          NUMERIC(28)          not null,
   NO_ACAO              VARCHAR(150)         null,
   NU_CONCENTRACAO      NUMERIC(18,10)       null,
   NU_PERCENT_ACAO      NUMERIC(16,8)        null,
   ST_CONTABILIZA       VARCHAR(1)           null,
   CO_AREA_ESTRATEGICA  NUMERIC(28)          null,
   CO_AREA_ATUACAO      NUMERIC(28)          null,
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          null,
   CO_PPI               NUMERIC(28)          null,
   ST_NIVEL_ACAO        VARCHAR(1)           null,
   NU_ORDENACAO         NUMERIC(10)          null,
   ST_INDICE_AGRUPAMENTO VARCHAR(1)           null,
   constraint PK_ACAO primary key (CO_SEQ_ACAO)
);

comment on table TB_ACAO is
'Tabela de aes das reas estratgicas e das reas de atuao.';

comment on column TB_ACAO.CO_SEQ_ACAO is
'Cdigo seqencial da TB_ACAO - Chave primria';

comment on column TB_ACAO.NO_ACAO is
'Nome da ao.';

comment on column TB_ACAO.NU_CONCENTRACAO is
'Percentual da concentrao';

comment on column TB_ACAO.NU_PERCENT_ACAO is
'Percentual da ao a ser executada';

comment on column TB_ACAO.ST_CONTABILIZA is
'Status que indica se a ao ser contabilizada ou no';

comment on column TB_ACAO.CO_AREA_ESTRATEGICA is
'Cdigo seqencial - Chave primria.';

comment on column TB_ACAO.CO_AREA_ATUACAO is
'Cdigo seqencial - Chave primria.';

comment on column TB_ACAO.CO_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao.';

comment on column TB_ACAO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_ACAO.ST_NIVEL_ACAO is
'Nvel de agregao, informa em qual nvel se encontra a ao, sendo 1=grupo, 2=subgrupo, 3=forma de organizao.';

comment on column TB_ACAO.NU_ORDENACAO is
'Este campo ser utilizado para ordenar a descrio de uma ao (no_acao).';

comment on column TB_ACAO.ST_INDICE_AGRUPAMENTO is
'Na configurao de aes  necessrio informar se uma ao vai ter ndice de agrupamento: S - Sim , N - No';

/*==============================================================*/
/* Index: IN_ACAO_COAREAESTSTNIVELATUA                          */
/*==============================================================*/
create  index IN_ACAO_COAREAESTSTNIVELATUA on TB_ACAO (
CO_AREA_ATUACAO,
ST_NIVEL_ACAO
);

/*==============================================================*/
/* Index: IN_ACAO_COARESTRCOARATUSTNIVAC                        */
/*==============================================================*/
create  index IN_ACAO_COARESTRCOARATUSTNIVAC on TB_ACAO (
CO_AREA_ESTRATEGICA,
CO_AREA_ATUACAO,
ST_NIVEL_ACAO
);

/*==============================================================*/
/* Index: IN_ACAO_COCONFIGPOPULACAO                             */
/*==============================================================*/
create  index IN_ACAO_COCONFIGPOPULACAO on TB_ACAO (
CO_CONFIGURACAO_POPULACAO
);

/*==============================================================*/
/* Index: IN_ACAO_CONFIPOPACAOARESTNUORD                        */
/*==============================================================*/
create  index IN_ACAO_CONFIPOPACAOARESTNUORD on TB_ACAO (
CO_CONFIGURACAO_POPULACAO,
CO_SEQ_ACAO,
CO_AREA_ESTRATEGICA,
CO_AREA_ATUACAO,
NU_ORDENACAO
);

/*==============================================================*/
/* Index: IN_ACAO_COSEQACAO                                     */
/*==============================================================*/
create  index IN_ACAO_COSEQACAO on TB_ACAO (
(substr(co_seq_acao, 8,6))
);

/*==============================================================*/
/* Table: TB_AGREGADO                                           */
/*==============================================================*/
create table TB_AGREGADO (
   CO_SEQ_AGREGADO      NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          null,
   DS_AGREGADO          VARCHAR(250)         null,
   ST_NIVEL_AGREGACAO   VARCHAR(1)           null,
   ST_ABRANGENCIA       VARCHAR(1)           null,
   constraint PK_AGREGADO primary key (CO_SEQ_AGREGADO)
);

comment on table TB_AGREGADO is
'Tabela que agregar os procedimentos ambulatoriais.';

comment on column TB_AGREGADO.CO_SEQ_AGREGADO is
'Cdigo seqencial da tabela TB_AGREGADO';

comment on column TB_AGREGADO.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_AGREGADO.DS_AGREGADO is
'Nome dado a um agregado';

comment on column TB_AGREGADO.ST_NIVEL_AGREGACAO is
'Representa o nvel de agregao para grupo,sub-grupo, forma de organizao e procedimento de um agregado. ex:
1 - agregar (Grupo),
2 - agregar (Grupo,Sub-Grupo),
3 - agregar (Grupo,Sub-Grupo,Forma de Organizao),
4 - agregar (Grupo,Sub-Grupo,Forma de Organizao,Procedimento).';

comment on column TB_AGREGADO.ST_ABRANGENCIA is
'Indica se o agregado vai realizar abrangncia: S - Sim ou N - No.';

/*==============================================================*/
/* Table: TB_ALTA_COMPLEXIDADE_AMB                              */
/*==============================================================*/
create table TB_ALTA_COMPLEXIDADE_AMB (
   CO_SEQ_ALTA_COMP_AMB NUMERIC(8)           not null,
   DS_ALTA_COMP_AMB     VARCHAR(100)         null,
   constraint PK_ALTA_COMPLEXIDADE_AMB primary key (CO_SEQ_ALTA_COMP_AMB)
);

comment on table TB_ALTA_COMPLEXIDADE_AMB is
'Tabela com as descries dos servios de alta complexidade ambulatorial.';

comment on column TB_ALTA_COMPLEXIDADE_AMB.CO_SEQ_ALTA_COMP_AMB is
'Cdigo da alta complexidade ambulatorial';

comment on column TB_ALTA_COMPLEXIDADE_AMB.DS_ALTA_COMP_AMB is
'Nome da alta complexidade ambulatorial';

/*==============================================================*/
/* Table: TB_AREA_ALOCACAO                                      */
/*==============================================================*/
create table TB_AREA_ALOCACAO (
   CO_AREA_ALOCACAO     NUMERIC(4)           not null,
   NO_AREA_ALOCACAO     VARCHAR(100)         null,
   constraint PK_AREAALOCACAO primary key (CO_AREA_ALOCACAO)
);

comment on table TB_AREA_ALOCACAO is
'Descrio das reas de alocaes utilizadas pelo SISPPI';

comment on column TB_AREA_ALOCACAO.CO_AREA_ALOCACAO is
'Cdigo de identificao da rea de Alocao';

/*==============================================================*/
/* Table: TB_AREA_ATUACAO                                       */
/*==============================================================*/
create table TB_AREA_ATUACAO (
   CO_SEQ_AREA_ATUACAO  NUMERIC(28)          not null,
   CO_AREA_ESTRATEGICA  NUMERIC(28)          null,
   CO_AREA_ATUACAO_PAI  NUMERIC(28)          null,
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          null,
   NO_AREA_ATUACAO      VARCHAR(150)         null,
   NU_ORDENACAO         NUMERIC(10)          null,
   ST_NIVEL             VARCHAR(2)           null,
   constraint PK_AREA_ATUACAO primary key (CO_SEQ_AREA_ATUACAO)
);

comment on table TB_AREA_ATUACAO is
'Tabela com as reas de atuao das reas estratgicas.';

comment on column TB_AREA_ATUACAO.CO_SEQ_AREA_ATUACAO is
'Cdigo seqencial - Chave primria';

comment on column TB_AREA_ATUACAO.CO_AREA_ESTRATEGICA is
'Cdigo seqencial da TB_AREA_ESTRATEGICA - Chave estrangeira.';

comment on column TB_AREA_ATUACAO.CO_AREA_ATUACAO_PAI is
'Cdigo seqencial da TB_AREA_ATUACAO - Chave estrangeira.';

comment on column TB_AREA_ATUACAO.CO_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao.';

comment on column TB_AREA_ATUACAO.NO_AREA_ATUACAO is
'Nome da rea de atuao';

comment on column TB_AREA_ATUACAO.NU_ORDENACAO is
'Este campo ser utilizado para ordenar a descrio de uma rea de atuao (no_area_atuacao).';

comment on column TB_AREA_ATUACAO.ST_NIVEL is
'Uma rea de atuao pode ter vrias reas de atuao filhas. O nvel representa se uma rea de atuao tem uma, duas ou mais reas de atuao pai.';

/*==============================================================*/
/* Index: IN_AREAATUA_CONFPOPAREESTNUORD                        */
/*==============================================================*/
create  index IN_AREAATUA_CONFPOPAREESTNUORD on TB_AREA_ATUACAO (
CO_CONFIGURACAO_POPULACAO,
CO_AREA_ESTRATEGICA,
CO_SEQ_AREA_ATUACAO,
NU_ORDENACAO
);

/*==============================================================*/
/* Table: TB_AREA_ESTRATEGICA                                   */
/*==============================================================*/
create table TB_AREA_ESTRATEGICA (
   CO_SEQ_AREA_ESTRATEGICA NUMERIC(28)          not null,
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          null,
   NO_AREA_ESTRATEGICA  VARCHAR(150)         null,
   CO_PPI               NUMERIC(28)          null,
   NU_ORDENACAO         NUMERIC(10)          null,
   constraint PK_AREA_ESTRATEGICA primary key (CO_SEQ_AREA_ESTRATEGICA)
);

comment on table TB_AREA_ESTRATEGICA is
'Tabela da rea estratgica do governo.';

comment on column TB_AREA_ESTRATEGICA.CO_SEQ_AREA_ESTRATEGICA is
'Cdigo seqencial - Chave primria';

comment on column TB_AREA_ESTRATEGICA.CO_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao.';

comment on column TB_AREA_ESTRATEGICA.NO_AREA_ESTRATEGICA is
'Nome da rea estratgica';

comment on column TB_AREA_ESTRATEGICA.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_AREA_ESTRATEGICA.NU_ORDENACAO is
'Este campo ser utilizado para ordenar a descrio de uma rea estratgica (no_area_estrategica).';

/*==============================================================*/
/* Index: IN_AREAEST_CONFIGPOPCOPPINUORD                        */
/*==============================================================*/
create  index IN_AREAEST_CONFIGPOPCOPPINUORD on TB_AREA_ESTRATEGICA (
CO_CONFIGURACAO_POPULACAO,
CO_PPI,
NU_ORDENACAO
);

/*==============================================================*/
/* Table: TB_ARQUIVO_IMPORTADO                                  */
/*==============================================================*/
create table TB_ARQUIVO_IMPORTADO (
   NO_ARQUIVO_IMPORTADO VARCHAR(80)          not null,
   DT_INICIAL           DATE                 null,
   DT_FINAL             DATE                 null,
   DS_COMPETENCIA       VARCHAR(6)           null,
   SG_UF                VARCHAR(2)           null,
   DS_IMPORTACAO        VARCHAR(120)         null,
   ST_REPLICADO_ANALISADA VARCHAR(1)           null,
   constraint PK_ARQUIVO_IMPORTADO primary key (NO_ARQUIVO_IMPORTADO)
);

comment on table TB_ARQUIVO_IMPORTADO is
'Tabela de controle dos arquivos que sero importados para a base de dados do sistema SISPPI.';

comment on column TB_ARQUIVO_IMPORTADO.NO_ARQUIVO_IMPORTADO is
'Nome do arquivo que foi importado';

comment on column TB_ARQUIVO_IMPORTADO.DT_INICIAL is
'Data de incio da importao do arquivo';

comment on column TB_ARQUIVO_IMPORTADO.DT_FINAL is
'Data final da importao do arquivo';

comment on column TB_ARQUIVO_IMPORTADO.DS_COMPETENCIA is
'Ano ou ms ao qual o arquivo importado se refere';

comment on column TB_ARQUIVO_IMPORTADO.SG_UF is
'Sigla da Unidade Federativa';

comment on column TB_ARQUIVO_IMPORTADO.DS_IMPORTACAO is
'Descrio do arquivo importado. Ano do arquivo UF';

comment on column TB_ARQUIVO_IMPORTADO.ST_REPLICADO_ANALISADA is
'Status que indica se a produo bruta foi replicada para a base analisada. S - Sim N - No';

/*==============================================================*/
/* Table: TB_BASE_GERADA_SIA                                    */
/*==============================================================*/
create table TB_BASE_GERADA_SIA (
   CO_PPI               NUMERIC(28)          null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(14,2)        null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_OCUPACAO          VARCHAR(6)           null,
   CO_HABILITACAO       VARCHAR(4)           null,
   TP_REGISTRO          VARCHAR(1)           null
);

comment on table TB_BASE_GERADA_SIA is
'Tabela com a base de produo SIA para programao.';

comment on column TB_BASE_GERADA_SIA.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_BASE_GERADA_SIA.CO_PROCEDIMENTO is
'Cdigo do Procedimento - Chave primria';

comment on column TB_BASE_GERADA_SIA.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIA.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIA.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados.';

comment on column TB_BASE_GERADA_SIA.VL_PROCEDIMENTO_APROVADO is
'Valor dos procedimentos aprovados.';

comment on column TB_BASE_GERADA_SIA.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos SIA';

comment on column TB_BASE_GERADA_SIA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_BASE_GERADA_SIA.CO_OCUPACAO is
'Cdigo que identifica a classificao das ocupaes definidas pela CBO-2002';

comment on column TB_BASE_GERADA_SIA.CO_HABILITACAO is
'Cdigo da habilitao de um estabelecimento de sade';

comment on column TB_BASE_GERADA_SIA.TP_REGISTRO is
'Tipo do registro: A - APAC, B  BPA';

/*==============================================================*/
/* Index: IN_BASE_GERADA_SIA                                    */
/*==============================================================*/
create  index IN_BASE_GERADA_SIA on TB_BASE_GERADA_SIA (
CO_PROCEDIMENTO,
CO_PPI
);

/*==============================================================*/
/* Index: IN_BASEGERADASIA_PROCFINMUNPPI                        */
/*==============================================================*/
create  index IN_BASEGERADASIA_PROCFINMUNPPI on TB_BASE_GERADA_SIA (
CO_PROCEDIMENTO,
CO_FINANCIAMENTO,
CO_MUNICIPIO_IBGE_MOV,
CO_MUNICIPIO_IBGE_RES,
CO_PPI
);

/*==============================================================*/
/* Table: TB_BASE_GERADA_SIH                                    */
/*==============================================================*/
create table TB_BASE_GERADA_SIH (
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   CO_PPI               NUMERIC(28)          null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_LEITO             VARCHAR(2)           null,
   CO_ESPECIALIDADE     VARCHAR(2)           not null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(14,2)        null
);

comment on table TB_BASE_GERADA_SIH is
'Tabela com a base de produo SIH para programao.';

comment on column TB_BASE_GERADA_SIH.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIH.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIH.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_BASE_GERADA_SIH.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_BASE_GERADA_SIH.TP_COMPLEXIDADE is
'Cdigo da complexidade SIA e SIH';

comment on column TB_BASE_GERADA_SIH.CO_LEITO is
'Cdigo da especialidade CNES';

comment on column TB_BASE_GERADA_SIH.CO_ESPECIALIDADE is
'Cdigo do leito CNES';

comment on column TB_BASE_GERADA_SIH.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados.';

comment on column TB_BASE_GERADA_SIH.VL_PROCEDIMENTO_APROVADO is
'Valor dos procedimentos aprovados.';

/*==============================================================*/
/* Index: IN_BASEGERSIH_ESPLEIFINCOMPPPI                        */
/*==============================================================*/
create  index IN_BASEGERSIH_ESPLEIFINCOMPPPI on TB_BASE_GERADA_SIH (
CO_ESPECIALIDADE,
CO_LEITO,
CO_FINANCIAMENTO,
TP_COMPLEXIDADE,
CO_PPI
);

/*==============================================================*/
/* Table: TB_BASE_GERADA_SIH_UTI                                */
/*==============================================================*/
create table TB_BASE_GERADA_SIH_UTI (
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   QT_FISICO_UTI        NUMERIC(10,2)        null,
   VL_UTI               NUMERIC(10,2)        null,
   CO_PPI               NUMERIC(28)          null,
   TP_IDENTIFICADOR     VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_TIPO_LEITO        VARCHAR(2)           null
);

comment on table TB_BASE_GERADA_SIH_UTI is
'Tabela com a produo de UTIs consolidadas.';

comment on column TB_BASE_GERADA_SIH_UTI.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIH_UTI.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_BASE_GERADA_SIH_UTI.QT_FISICO_UTI is
'Quantidade de produo que envolveu UTI hospitalar.';

comment on column TB_BASE_GERADA_SIH_UTI.VL_UTI is
'Valor da UTI hospitalar.';

comment on column TB_BASE_GERADA_SIH_UTI.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_BASE_GERADA_SIH_UTI.TP_IDENTIFICADOR is
'Identifica o tipo: 1- UTI , 2- UCI';

comment on column TB_BASE_GERADA_SIH_UTI.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_BASE_GERADA_SIH_UTI.CO_TIPO_LEITO is
'Cdigo do tipo de leito da tabela unificada';

/*==============================================================*/
/* Table: TB_CALCULO_BANDA_PARAMETRICA                          */
/*==============================================================*/
create table TB_CALCULO_BANDA_PARAMETRICA (
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   CO_AGREGADO          NUMERIC(28)          not null,
   CO_UF_IBGE_ORIGEM    VARCHAR(2)           not null,
   CO_UF_IBGE_INDIVIDUAL VARCHAR(2)           not null,
   VL_LIMITE            NUMERIC(16,12)       null,
   constraint PK_CALCULO_BANDA_PARAMETRICA primary key (CO_FINANCIAMENTO, CO_PPI, CO_AGREGADO, CO_UF_IBGE_ORIGEM, CO_UF_IBGE_INDIVIDUAL)
);

comment on table TB_CALCULO_BANDA_PARAMETRICA is
' o resultado de um clculo estatstico, mostrando os limites inferiores e superiores de produo de um determinado estado em relao ao Brasil.';

comment on column TB_CALCULO_BANDA_PARAMETRICA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento de um procedimento SIA ou SIH';

comment on column TB_CALCULO_BANDA_PARAMETRICA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CALCULO_BANDA_PARAMETRICA.CO_AGREGADO is
'Cdigo de agregado de procedimentos SIA (CO_GRUPO + CO_SUBGRUPO)';

comment on column TB_CALCULO_BANDA_PARAMETRICA.CO_UF_IBGE_ORIGEM is
'Estado que est sendo comparado em relao ao Brasil inteiro';

comment on column TB_CALCULO_BANDA_PARAMETRICA.CO_UF_IBGE_INDIVIDUAL is
'Cada estado do Brasil em relao ao estado de origem';

comment on column TB_CALCULO_BANDA_PARAMETRICA.VL_LIMITE is
'Limite superior ou inferior de produo.';

/*==============================================================*/
/* Table: TB_CAPACIDADE_INSTALADA_SIH                           */
/*==============================================================*/
create table TB_CAPACIDADE_INSTALADA_SIH (
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_LEITO             VARCHAR(2)           null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_ESPECIALIDADE     VARCHAR(1)           not null,
   TX_OCUPACAO_LEITO    NUMERIC(10,2)        null,
   QT_TEMPO_MEDIO_PERMANENCIA NUMERIC(8)           null,
   CO_PPI               NUMERIC(28)          null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_HABILITACAO       VARCHAR(4)           not null
);

comment on table TB_CAPACIDADE_INSTALADA_SIH is
'Tabela de nmero de leitos e capacidade de atendimento de cada leito.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_LEITO is
'Cdigo da especialidade CNES.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.TP_COMPLEXIDADE is
'Cdigo da complexidade SIA e SIH.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_ESPECIALIDADE is
'Cdigo do leito CNES.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.TX_OCUPACAO_LEITO is
'Nmero de pacientes, no perodo de competncia, dividido pelo nmero de leitos/dia vezes 100.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.QT_TEMPO_MEDIO_PERMANENCIA is
'Tempo mdio de permanncia de um paciente em um leito.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_PPI is
'Cdigo da PPI - Pactuao Programada Integrada.';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_CAPACIDADE_INSTALADA_SIH.CO_HABILITACAO is
'Cdigo da habilitao';

/*==============================================================*/
/* Table: TB_CARDAPIO                                           */
/*==============================================================*/
create table TB_CARDAPIO (
   CO_SEQ_CARDAPIO      NUMERIC(28)          not null,
   DT_COMPETENCIA_CARDAPIO VARCHAR(6)           not null,
   DT_COMP_INICIAL_FIS_AMB VARCHAR(6)           null,
   DT_COMP_FINAL_FIS_AMB VARCHAR(6)           null,
   DT_COMP_INICIAL_FIS_HOSP VARCHAR(6)           null,
   DT_COMP_FINAL_FIS_HOSP VARCHAR(6)           null,
   NU_ANO_POPULACAO_1   VARCHAR(4)           null,
   NU_ANO_POPULACAO_2   VARCHAR(4)           null,
   NU_ANO_POPULACAO_3   VARCHAR(4)           null,
   ST_ATIVO             VARCHAR(1)           null,
   DT_COMP_PROC_UNIFICADO VARCHAR(6)           null,
   DT_COMP_INICIAL_FINANC_HOSP VARCHAR(6)           null,
   DT_COMP_FINAL_FINANC_HOSP VARCHAR(6)           null,
   constraint PK_CARDAPIO primary key (CO_SEQ_CARDAPIO)
);

comment on table TB_CARDAPIO is
'Tabela de competncias para o Estado escolher a sua faixa de produo.';

comment on column TB_CARDAPIO.CO_SEQ_CARDAPIO is
'Cdigo do cardpio.';

comment on column TB_CARDAPIO.DT_COMPETENCIA_CARDAPIO is
'Data em que o cardpio foi gerado, no formato ANO/MS (200601).';

comment on column TB_CARDAPIO.DT_COMP_INICIAL_FIS_AMB is
'Data inicial da produo fsico-ambulatorial, no formato ANO/MS (200601).';

comment on column TB_CARDAPIO.DT_COMP_FINAL_FIS_AMB is
'Data final da produo fsico-ambulatorial, no formato ANO/MS (200601).';

comment on column TB_CARDAPIO.DT_COMP_INICIAL_FIS_HOSP is
'Data inicial da produo fsico-hospitalar, no formato ANO/MS (200601).';

comment on column TB_CARDAPIO.DT_COMP_FINAL_FIS_HOSP is
'Data final da produo fsico-hospitalar, no formato ANO/MS (200601).';

comment on column TB_CARDAPIO.NU_ANO_POPULACAO_1 is
'Ano da populao selecionada 1.';

comment on column TB_CARDAPIO.NU_ANO_POPULACAO_2 is
'Ano da populao selecionada 2.';

comment on column TB_CARDAPIO.NU_ANO_POPULACAO_3 is
'Ano da populao selecionada 3.';

comment on column TB_CARDAPIO.ST_ATIVO is
'Status para saber se o cardpio ser acessado pelos gestores estaduais ou no
S - Ativo, N - No Ativo';

comment on column TB_CARDAPIO.DT_COMP_PROC_UNIFICADO is
'Data da competncia vigente da Tabela de Procedimentos Unificada';

comment on column TB_CARDAPIO.DT_COMP_INICIAL_FINANC_HOSP is
'Data inicial da produo financeiro-hospitalar, no formato ANO/MS (200601), para calcular o valor mdio';

comment on column TB_CARDAPIO.DT_COMP_FINAL_FINANC_HOSP is
'Data final da produo financeiro-hospitalar, no formato ANO/MS (200601), para calcular o valor mdio';

/*==============================================================*/
/* Table: TB_CBO_SIMPLIFICADA                                   */
/*==============================================================*/
create table TB_CBO_SIMPLIFICADA (
   CO_CBO_SIMPLIFICADA  VARCHAR(4)           not null,
   CO_PPI               NUMERIC(28)          not null,
   NO_CBO_SIMPLIFICADA  VARCHAR(100)         null,
   constraint PK_CBO_SIMPLIFICADA primary key (CO_CBO_SIMPLIFICADA, CO_PPI)
);

comment on table TB_CBO_SIMPLIFICADA is
'Contm os nomes dos CBOs agrupados';

comment on column TB_CBO_SIMPLIFICADA.CO_CBO_SIMPLIFICADA is
'Cdigo da ocupao';

comment on column TB_CBO_SIMPLIFICADA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CBO_SIMPLIFICADA.NO_CBO_SIMPLIFICADA is
'Descrio do agrupamento de vrios CBOs';

/*==============================================================*/
/* Table: TB_COMPLEXIDADE_DEPARA                                */
/*==============================================================*/
create table TB_COMPLEXIDADE_DEPARA (
   CO_SEQ_COMPLEXIDADE  NUMERIC(8)           not null,
   NO_COMPLEXIDADE      VARCHAR(60)          null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   constraint PK_COMPLEXIDADEDEPARA primary key (CO_SEQ_COMPLEXIDADE)
);

comment on table TB_COMPLEXIDADE_DEPARA is
'Tabela de complexidade sia e sih.
Servir como tabela de apoio para os procedimentos que no tiverem DE_PARA (excludos)';

comment on column TB_COMPLEXIDADE_DEPARA.CO_SEQ_COMPLEXIDADE is
'Cdigo da comlexidade de um procedimento';

comment on column TB_COMPLEXIDADE_DEPARA.NO_COMPLEXIDADE is
'Nome da complexidade';

comment on column TB_COMPLEXIDADE_DEPARA.TP_COMPLEXIDADE is
'Cdigo da complexidade  - Tabela Unificada';

/*==============================================================*/
/* Table: TB_COMPLEXIDADE_PPI                                   */
/*==============================================================*/
create table TB_COMPLEXIDADE_PPI (
   TP_COMPLEXIDADE      VARCHAR(1)           not null,
   CO_PPI               NUMERIC(28)          not null,
   NO_COMPLEXIDADE      VARCHAR(100)         null,
   ST_COMPLEXIDADE_SIH  VARCHAR(1)           null,
   SG_COMPLEXIDADE      VARCHAR(40)          null,
   constraint PK_COMPLEXIDADE_PPI primary key (TP_COMPLEXIDADE, CO_PPI)
);

comment on table TB_COMPLEXIDADE_PPI is
'Tabela de complexidade SIA e SIH.';

comment on column TB_COMPLEXIDADE_PPI.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos SIA';

comment on column TB_COMPLEXIDADE_PPI.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_COMPLEXIDADE_PPI.NO_COMPLEXIDADE is
'Nome da complexidade SIA e SIH';

comment on column TB_COMPLEXIDADE_PPI.ST_COMPLEXIDADE_SIH is
'Identifica se a complexidade  somente do SIH: S - sim, N - no';

comment on column TB_COMPLEXIDADE_PPI.SG_COMPLEXIDADE is
'Sigla da complexidade.
Ex.:
AB - Ateno Bsica
MC - Mdia Complexidade
AC - Alta Complexidade';

/*==============================================================*/
/* Table: TB_CONFIGPOP_FAIXA_ETARIA                             */
/*==============================================================*/
create table TB_CONFIGPOP_FAIXA_ETARIA (
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          not null,
   TP_SEXO              VARCHAR(1)           not null,
   DS_FAIXA_ETARIA      VARCHAR(4)           not null,
   constraint PK_CONFIGPOP_FAIXA_ETARIA primary key (CO_CONFIGURACAO_POPULACAO, TP_SEXO, DS_FAIXA_ETARIA)
);

comment on table TB_CONFIGPOP_FAIXA_ETARIA is
'Tabela que conter todas as faixas etrias configuradas pelos gestores federais e estaduais para os estados e municpios.';

comment on column TB_CONFIGPOP_FAIXA_ETARIA.CO_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao';

comment on column TB_CONFIGPOP_FAIXA_ETARIA.TP_SEXO is
'Tipo do sexo - masculino / feminino';

comment on column TB_CONFIGPOP_FAIXA_ETARIA.DS_FAIXA_ETARIA is
'Descrio da faixa etria da populao.';

/*==============================================================*/
/* Index: IN_CONFPOPFAIXETAR_COCONFIGPOP                        */
/*==============================================================*/
create  index IN_CONFPOPFAIXETAR_COCONFIGPOP on TB_CONFIGPOP_FAIXA_ETARIA (
(substr(co_configuracao_populacao, 8,6))
);

/*==============================================================*/
/* Table: TB_CONFIGURACAO_ACESSO                                */
/*==============================================================*/
create table TB_CONFIGURACAO_ACESSO (
   TP_ESFERA_GERAL      VARCHAR(1)           null,
   CO_UF_IBGE           VARCHAR(2)           null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           null,
   CO_NIVEL_REGIONALIZACAO NUMERIC(4)           null,
   CO_DISTRITO          VARCHAR(9)           null,
   DS_VERSAO_BD         VARCHAR(40)          null,
   DS_VERSAO_APLICACAO  VARCHAR(100)         null
);

comment on table TB_CONFIGURACAO_ACESSO is
'Tabela que contm a configurao do sistema';

comment on column TB_CONFIGURACAO_ACESSO.TP_ESFERA_GERAL is
'Tipo da Esfera';

comment on column TB_CONFIGURACAO_ACESSO.CO_UF_IBGE is
'Cdigo da UF';

comment on column TB_CONFIGURACAO_ACESSO.CO_MUNICIPIO_IBGE is
'Cdigo do Municpio';

comment on column TB_CONFIGURACAO_ACESSO.CO_NIVEL_REGIONALIZACAO is
'Cdigo da Regio';

comment on column TB_CONFIGURACAO_ACESSO.CO_DISTRITO is
'Cdigo do Distrito';

comment on column TB_CONFIGURACAO_ACESSO.DS_VERSAO_BD is
'Armazena a verso do banco de dados.';

comment on column TB_CONFIGURACAO_ACESSO.DS_VERSAO_APLICACAO is
'Armazena a verso do aplicativo.';

/*==============================================================*/
/* Table: TB_CONFIGURACAO_MEDIA_ALTA_COM                        */
/*==============================================================*/
create table TB_CONFIGURACAO_MEDIA_ALTA_COM (
   CO_SEQ_CONFIG_M_ALTA_COMP_H NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          null,
   ST_PERC_INTER_PARAMETRO_M VARCHAR(1)           null,
   ST_PERC_INTER_ALTERACAO_M VARCHAR(1)           null,
   ST_PERC_PART_PARAMETRO_M VARCHAR(1)           null,
   ST_PERC_PART_ALTERACAO_M VARCHAR(1)           null,
   ST_VL_MEDIO_PARAMETRO_M VARCHAR(1)           null,
   ST_VL_MEDIO_ALTERACAO_M VARCHAR(1)           null,
   ST_PERC_INTER_PARAMETRO_A VARCHAR(1)           null,
   ST_PERC_INTER_ALTERACAO_A VARCHAR(1)           null,
   ST_CARGA             VARCHAR(1)           null,
   constraint PK_CONFIGURACAO_MEDIA_ALTA_COM primary key (CO_SEQ_CONFIG_M_ALTA_COMP_H)
);

comment on table TB_CONFIGURACAO_MEDIA_ALTA_COM is
'Tabela de configuraes bsicas para a alta complexidade hospitalar.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.CO_SEQ_CONFIG_M_ALTA_COMP_H is
'Cdigo da configurao da mdia e alta complexidade';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_INTER_PARAMETRO_M is
'Status do percentual de internao mdia da populao: parmetro CIB ou por municpio.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_INTER_ALTERACAO_M is
'Status do percentual de internao mdia da populao: alterao por mdulo estadual ou todos os mdulos.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_PART_PARAMETRO_M is
'Status do percentual de internao mdia entre clnicas: parmetro CIB ou por municpio.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_PART_ALTERACAO_M is
'Status do percentual de internao mdia entre clnicas - mdia complexidade: alterao por mdulo estadual ou todos os mdulos.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_VL_MEDIO_PARAMETRO_M is
'Status do valor mdio por clnica - mdia complexidade: parmetro CIB ou por municpio.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_VL_MEDIO_ALTERACAO_M is
'Status do valor mdio por clnica: alterao por mdulo estadual ou todos os mdulos.';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_INTER_PARAMETRO_A is
'Status do percentual entre clnicas de internao - alta complexidade: parmetro CIB ou por municpio';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_PERC_INTER_ALTERACAO_A is
'Status do percentual entre clnicas de internao - alta complexidade: alterao por mdulo estadual ou todos os mdulos';

comment on column TB_CONFIGURACAO_MEDIA_ALTA_COM.ST_CARGA is
'Verifica se foi realizada a carga completa no sistema para fazer programao (S- Sim , N- No) S - com carga, N - sem carga';

/*==============================================================*/
/* Table: TB_CONFIGURACAO_POPULACAO                             */
/*==============================================================*/
create table TB_CONFIGURACAO_POPULACAO (
   CO_SEQ_CONFIGURACAO_POPULACAO NUMERIC(28)          not null,
   CO_TIPO_POPULACAO    NUMERIC(2)           null,
   CO_TIPO_ESTIMATIVA   NUMERIC(2)           null,
   CO_CONFIGURACAO_POPULACAO_PAI NUMERIC(28)          null,
   DS_POPULACAO         VARCHAR(200)         null,
   NU_PERCENT_ESTIMATIVA NUMERIC(10,2)        null,
   DS_COBERTURA         VARCHAR(200)         null,
   NU_PERCENT_POPULACAO NUMERIC(10,2)        null,
   QT_POPULACAO         NUMERIC(8)           null,
   CO_PPI               NUMERIC(28)          null,
   constraint PK_CONFIGURACAO_POPULACAO primary key (CO_SEQ_CONFIGURACAO_POPULACAO)
);

comment on table TB_CONFIGURACAO_POPULACAO is
'Configurao da populao gerada pelo IBGE e pelo TCU.';

comment on column TB_CONFIGURACAO_POPULACAO.CO_SEQ_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao';

comment on column TB_CONFIGURACAO_POPULACAO.CO_TIPO_POPULACAO is
'Cdigo do tipo da populao';

comment on column TB_CONFIGURACAO_POPULACAO.CO_TIPO_ESTIMATIVA is
'Cdigo do tipo de estimativa da populao';

comment on column TB_CONFIGURACAO_POPULACAO.CO_CONFIGURACAO_POPULACAO_PAI is
'Cdigo da parametrizao da populao (auto-relacionamento)';

comment on column TB_CONFIGURACAO_POPULACAO.DS_POPULACAO is
'Descrio de uma populao';

comment on column TB_CONFIGURACAO_POPULACAO.NU_PERCENT_ESTIMATIVA is
'Percentual da estimativa';

comment on column TB_CONFIGURACAO_POPULACAO.DS_COBERTURA is
'Descrio da cobertura em que uma ao incidir sobre a populao';

comment on column TB_CONFIGURACAO_POPULACAO.NU_PERCENT_POPULACAO is
'Percentual da populao';

comment on column TB_CONFIGURACAO_POPULACAO.QT_POPULACAO is
'Quantidade de uma populao pertencente a uma faixa etria';

comment on column TB_CONFIGURACAO_POPULACAO.CO_PPI is
'Cdigo da PPI principal';

/*==============================================================*/
/* Index: IN_CONFIGPOPUL_COSEQCONFIGPOP                         */
/*==============================================================*/
create  index IN_CONFIGPOPUL_COSEQCONFIGPOP on TB_CONFIGURACAO_POPULACAO (
(substr(co_seq_configuracao_populacao, 8,6))
);

/*==============================================================*/
/* Index: IN_CONFPOP_CONFPOPPAICOPPI                            */
/*==============================================================*/
create  index IN_CONFPOP_CONFPOPPAICOPPI on TB_CONFIGURACAO_POPULACAO (
CO_CONFIGURACAO_POPULACAO_PAI,
CO_PPI
);

/*==============================================================*/
/* Table: TB_CONFIGURAR_PPI_ESTADUAL                            */
/*==============================================================*/
create table TB_CONFIGURAR_PPI_ESTADUAL (
   ST_PROC_NAO_SUS      VARCHAR(1)           null,
   ST_MEDIA_COMPLEX_AMB VARCHAR(1)           null,
   ST_MEDIA_COMPLEX_HOSP VARCHAR(1)           null,
   ST_ALTA_COMPLEX_AMB  VARCHAR(1)           null,
   ST_ALTA_COMPLEX_HOSP VARCHAR(1)           null,
   ST_ATENCAO_BASICA    VARCHAR(1)           null,
   ST_HOSPITALAR        VARCHAR(1)           null,
   ST_AMBULATORIAL      VARCHAR(1)           null,
   CO_PPI               NUMERIC(28)          not null,
   ST_PARAMETRIZACAO_PREENCHIDA VARCHAR(1)           null,
   constraint PK_CONFIGURARPPIESTADUAL primary key (CO_PPI)
);

comment on table TB_CONFIGURAR_PPI_ESTADUAL is
'Configurao da PPI do estado.';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_PROC_NAO_SUS is
'Status que indica se o estado poder cadastrar procedimentos no-sus: S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_MEDIA_COMPLEX_AMB is
'Indica se o estado vai programar envolvendo procedimentos de mdia complexidade ambulatorial S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_MEDIA_COMPLEX_HOSP is
'Indica se o estado vai programar envolvendo procedimentos de mdia complexidade hospitalar S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_ALTA_COMPLEX_AMB is
'Indica se o estado vai programar envolvendo procedimentos de alta complexidade ambulatorial S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_ALTA_COMPLEX_HOSP is
'Indica se o estado vai programar envolvendo procedimentos de alta complexidade hospitalar S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_ATENCAO_BASICA is
'Status que define se o estado vai alocar recursos prprios envolvendo a Ateno Bsica
S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_HOSPITALAR is
'Status que define se o estado vai alocar recursos prprios envolvendo procedimentos de mdia complexidade ambulatorial
S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_AMBULATORIAL is
'Status que define se o estado vai alocar recursos prprios envolvendo procedimentos de alta complexidade ambulatorial
S - sim / N - no';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONFIGURAR_PPI_ESTADUAL.ST_PARAMETRIZACAO_PREENCHIDA is
'Status da produo hospitalar: zero ou campos pr-preenchidos com os valores da produo - preenchimento padro das telas de parametrizao.';

/*==============================================================*/
/* Table: TB_CONFIGURAR_PPI_MUNICIPAL                           */
/*==============================================================*/
create table TB_CONFIGURAR_PPI_MUNICIPAL (
   CO_UF_IBGE           VARCHAR(2)           not null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   ST_ALOCAR_RECURSO_PROPRIO VARCHAR(1)           null,
   ST_MODULO_INTRAMUNICIPAL VARCHAR(1)           null,
   ST_PROC_NAO_SUS      VARCHAR(1)           null,
   CO_PPI               NUMERIC(28)          not null,
   ST_ATENCAO_BASICA    VARCHAR(1)           null,
   ST_HOSPITALAR        VARCHAR(1)           null,
   ST_AMBULATORIAL      VARCHAR(1)           null,
   constraint PK_CONFIGURAR_PPI_MUNICIPAL primary key (CO_UF_IBGE, CO_MUNICIPIO_IBGE, CO_PPI)
);

comment on table TB_CONFIGURAR_PPI_MUNICIPAL is
'Configurao da PPI municipal.';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.CO_UF_IBGE is
'Cdigo seqencial da tabela TB_UF - chave primria';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.CO_MUNICIPIO_IBGE is
'Cdigo seqencial  da tabela TB_MUNICIPIO - Chave primria';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_ALOCAR_RECURSO_PROPRIO is
'Status que indica se o municpio vai alocar recurso prprio ou no
S - sim / N - no';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_MODULO_INTRAMUNICIPAL is
'Status que indica se o municpio vai realizar PPI intermunicipal
S - sim / N - no';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_PROC_NAO_SUS is
'Status que indica se o municpio vai cadastrar procedimentos no-SUS
S - sim / N - no';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_ATENCAO_BASICA is
'Status que define se o municipio vai alocar recursos prprios envolvendo a Ateno Bsica
S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_HOSPITALAR is
'Indica se o municipio vai alocar recursos prprios para os procedimentos hospitalar.
S - Sim / N - No';

comment on column TB_CONFIGURAR_PPI_MUNICIPAL.ST_AMBULATORIAL is
'Indica se o municipio vai alocar recursos prprios para os procedimentos ambulatorial.
S - Sim / N - No';

/*==============================================================*/
/* Table: TB_CONFIG_PROCED_CBO                                  */
/*==============================================================*/
create table TB_CONFIG_PROCED_CBO (
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_PPI               NUMERIC(28)          not null,
   ST_AGRUPAMENTO       VARCHAR(1)           null,
   constraint PK_CONFIG_PROCED_CBO primary key (CO_PROCEDIMENTO, CO_PPI)
);

comment on table TB_CONFIG_PROCED_CBO is
'Contm os procedimentos que tero CBOs agregados';

comment on column TB_CONFIG_PROCED_CBO.CO_PROCEDIMENTO is
'Cdigo do Procedimento - Chave primria';

comment on column TB_CONFIG_PROCED_CBO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONFIG_PROCED_CBO.ST_AGRUPAMENTO is
'Indica se haver nivel abaixo do procedimento CBO. S - Sim, N- No';

/*==============================================================*/
/* Table: TB_CONS_PERC_INTERNACAO_H                             */
/*==============================================================*/
create table TB_CONS_PERC_INTERNACAO_H (
   CO_SEQ_CONS_PERC_INT_H NUMERIC(28)          not null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_PPI               NUMERIC(28)          null,
   VL_PERC              NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(8)           null,
   VL_PERC_PROD         NUMERIC(14,6)        null,
   QT_FISICO_PROD       NUMERIC(8)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   ST_ATUALIZAR_PERC_MUNIC VARCHAR(1)           null,
   ST_ATUALIZAR_VL_MEDIO VARCHAR(1)           null,
   constraint PK_CONS_PERC_INTERNACAO_H primary key (CO_SEQ_CONS_PERC_INT_H)
);

comment on table TB_CONS_PERC_INTERNACAO_H is
'Nessa tabela  armazenada a quantidade estimada de internaes da populao hospitalar por forma de financiamento, complexidade e PPI.
O usurio do mdulo estadual definir o percentual de internao da populao prpria por fonte de financiamento MAC, FAEC com limite, 
FAEC sem limite e recursos prprios, discriminando os percentuais referentes  mdia e alta complexidade.';

comment on column TB_CONS_PERC_INTERNACAO_H.CO_SEQ_CONS_PERC_INT_H is
'Cdigo dos nveis e das esferas. Por ltimo, a sequence de cada tabela de todos os nveis.
Esfera / Federal / Estadual / Regional / Municipal / Distrital / sequence nacional';

comment on column TB_CONS_PERC_INTERNACAO_H.TP_COMPLEXIDADE is
'Cdigo da complexidade do procedimento SIA ou SIH';

comment on column TB_CONS_PERC_INTERNACAO_H.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONS_PERC_INTERNACAO_H.VL_PERC is
' o percentual informado pelo usurio para planejamento da quantidade de atendimentos a serem realizados.';

comment on column TB_CONS_PERC_INTERNACAO_H.QT_FISICO is
' a quantidade estimada de atendimentos para a populao.';

comment on column TB_CONS_PERC_INTERNACAO_H.VL_PERC_PROD is
' o percentual informado pelo usurio para planejamento da quantidade de atendimentos a serem realizados.';

comment on column TB_CONS_PERC_INTERNACAO_H.QT_FISICO_PROD is
' um percentual baseado na quantidade de atendimentos da populao.';

comment on column TB_CONS_PERC_INTERNACAO_H.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_CONS_PERC_INTERNACAO_H.ST_ATUALIZAR_PERC_MUNIC is
'Status que indica se e necessario atualizar os percentuais dos municpio.
Impacto nas Telas:
Percentual de Participao por Tipo/Especialidade do leito - Municpio:
S - sim / N - no';

comment on column TB_CONS_PERC_INTERNACAO_H.ST_ATUALIZAR_VL_MEDIO is
'Status que indica se e necessario atualizar os valores medios dos municpio.
Impacto nas Telas:
Valor Mdio por Tipo/Especialidade do leito - Municpio:
S - sim / N - no';

/*==============================================================*/
/* Index: IN_CONSPERCINTERNACH_COMPFINAN                        */
/*==============================================================*/
create  index IN_CONSPERCINTERNACH_COMPFINAN on TB_CONS_PERC_INTERNACAO_H (
TP_COMPLEXIDADE,
CO_FINANCIAMENTO
);

/*==============================================================*/
/* Table: TB_CONTROLE_BASE_MUN                                  */
/*==============================================================*/
create table TB_CONTROLE_BASE_MUN (
   CO_SEQ_CONTROLE_BASE_MUN NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          null,
   DS_BASE_MUN          VARCHAR(200)         null,
   DS_VERSAO            VARCHAR(30)          null,
   IM_BASE_MUN          CHAR                 null,
   constraint PK_CONTROLEBASEMUN primary key (CO_SEQ_CONTROLE_BASE_MUN)
);

comment on table TB_CONTROLE_BASE_MUN is
'Esta tabela vai controlar a exportao e a importao das bases municipais.';

comment on column TB_CONTROLE_BASE_MUN.CO_SEQ_CONTROLE_BASE_MUN is
'Cdigo sequencial do controle das bases municipais.';

comment on column TB_CONTROLE_BASE_MUN.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_CONTROLE_BASE_MUN.DS_BASE_MUN is
'Descrio do controle das bases municipais.';

comment on column TB_CONTROLE_BASE_MUN.DS_VERSAO is
'Armazena a verso do sistema no momento da gerao da base municipal.';

comment on column TB_CONTROLE_BASE_MUN.IM_BASE_MUN is
'Armzena um arquivo zip com os dados que sero encaminhados para os municpios.';

/*==============================================================*/
/* Table: TB_DESTAQUE                                           */
/*==============================================================*/
create table TB_DESTAQUE (
   CO_SEQ_DESTAQUE      NUMERIC(28)          not null,
   CO_DESTAQUE_PAI      NUMERIC(28)          null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_LEITO             VARCHAR(2)           null,
   CO_PPI               NUMERIC(28)          null,
   CO_ESPECIALIDADE     VARCHAR(2)           null,
   ST_DESTACADO         VARCHAR(1)           null,
   ST_PARTICIPACAO_MUN  VARCHAR(1)           null,
   constraint PK_DESTAQUE primary key (CO_SEQ_DESTAQUE)
);

comment on table TB_DESTAQUE is
'Tabela de destaque das especialidades hospitalares.
Esta tabela  utilizada para armazenar os destaques hospitalares que sero realizados por complexidade e leito.';

comment on column TB_DESTAQUE.CO_SEQ_DESTAQUE is
'Cdigo de relacionamento com a TB_DESTAQUE, para buscar o que foi destacado (ST_DESTACADO=''S'') por:
Complexidade, forma de financiamento, leito, atributo e PPI.';

comment on column TB_DESTAQUE.CO_DESTAQUE_PAI is
'Cdigo do destaque agregador';

comment on column TB_DESTAQUE.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_DESTAQUE.TP_COMPLEXIDADE is
'Cdigo da complexidade de um procedimento hospitalar ou ambulatorial:
 1 - ATENO BSICA
 2 - ALTA COMPLEXIDADE
 4 - NO CLASSIFICADO
 3 - MDIA COMPLEXIDADE';

comment on column TB_DESTAQUE.CO_LEITO is
'Cdigo da especialidade de um determinado leito (CO_ATRIUBUTO) de um estabelecimento de sade (CNES)';

comment on column TB_DESTAQUE.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_DESTAQUE.CO_ESPECIALIDADE is
'Cdigo de um leito de sade';

comment on column TB_DESTAQUE.ST_DESTACADO is
'Verifica se foi feito ou no o destaque, de acordo com a complexidade e o tipo de leito.
S - Sim (Destacado), N - No (No Destacado)';

comment on column TB_DESTAQUE.ST_PARTICIPACAO_MUN is
'Verifica se foi feito ou no a habilitao do tipo leito/Especialidade por municipio
S - Sim (habilitado), N - No (No habilitado)';

/*==============================================================*/
/* Index: IN_DESTAQUE_ESPLEITFINCOMPLPPI                        */
/*==============================================================*/
create  index IN_DESTAQUE_ESPLEITFINCOMPLPPI on TB_DESTAQUE (
CO_ESPECIALIDADE,
CO_LEITO,
CO_FINANCIAMENTO,
TP_COMPLEXIDADE,
CO_PPI
);

/*==============================================================*/
/* Table: TB_DISTRIBUICAO                                       */
/*==============================================================*/
create table TB_DISTRIBUICAO (
   CO_SEQ_DISTRIBUICAO  NUMERIC(28)          not null,
   CO_RECURSO_ESPECIFICO NUMERIC(28)          null,
   VL_DISTRIBUICAO      NUMERIC(12,2)        not null,
   constraint PK_DISTRIBUICAO primary key (CO_SEQ_DISTRIBUICAO)
);

comment on table TB_DISTRIBUICAO is
'Esta tabela armazena o valor de recursos distribudos para o estado, municpio ou distrito.';

comment on column TB_DISTRIBUICAO.CO_SEQ_DISTRIBUICAO is
'Cdigo seqencial da distrituio dos recursos para o estado, municpio ou distrito.';

comment on column TB_DISTRIBUICAO.CO_RECURSO_ESPECIFICO is
'Cdigo dos recursos especficos. Ex: Reserva Tcnica, Incentivo';

comment on column TB_DISTRIBUICAO.VL_DISTRIBUICAO is
'Valor do recurso especfico distribudo para o estado, municpios ou distrito.';

/*==============================================================*/
/* Table: TB_DISTRITO_PPI                                       */
/*==============================================================*/
create table TB_DISTRITO_PPI (
   CO_SEQ_DISTRITO      NUMERIC(8)           not null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           null,
   NO_DISTRITO          VARCHAR(30)          null,
   constraint PK_DISTRITO_PPI primary key (CO_SEQ_DISTRITO)
);

comment on table TB_DISTRITO_PPI is
'Tabela dos distritos municipais';

comment on column TB_DISTRITO_PPI.CO_SEQ_DISTRITO is
'Cdigo seqencial - chave primria.';

comment on column TB_DISTRITO_PPI.CO_MUNICIPIO_IBGE is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria.';

comment on column TB_DISTRITO_PPI.NO_DISTRITO is
'Nome do Distrito.';

/*==============================================================*/
/* Table: TB_ENCAMINHADOR_A                                     */
/*==============================================================*/
create table TB_ENCAMINHADOR_A (
   CO_SEQ_ENCAMINHADOR_A NUMERIC(28)          not null,
   CO_ESPEC_EXECUTOR_A  NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   NU_COBERTURA         NUMERIC(10,2)        null,
   constraint PK_ENCAMINHADOR_A primary key (CO_SEQ_ENCAMINHADOR_A)
);

comment on table TB_ENCAMINHADOR_A is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_ESPEC_EXECUTOR_A.
Todos os campos so programados por servios e alta complexidade ambulatorial, por forma de financiamento, PPI, municpio executor e municpio encaminhador.';

comment on column TB_ENCAMINHADOR_A.CO_SEQ_ENCAMINHADOR_A is
'Cdigo do municpio que encaminhou a execuo da produo ambulatorial para outro municpio.';

comment on column TB_ENCAMINHADOR_A.CO_ESPEC_EXECUTOR_A is
'Cdigo que contm todas as esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, 
a sequence de cada tabela de todos os nveis.';

comment on column TB_ENCAMINHADOR_A.CO_MUNICIPIO_IBGE_RES is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio que encaminha para outro municpio realizar o procedimento ambulatorial.';

comment on column TB_ENCAMINHADOR_A.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ENCAMINHADOR_A.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ENCAMINHADOR_A.NU_COBERTURA is
'Valor da cobertura ambulatorial';

/*==============================================================*/
/* Index: IN_ENCAMINHAA_COESPECCOMUNICRE                        */
/*==============================================================*/
create  index IN_ENCAMINHAA_COESPECCOMUNICRE on TB_ENCAMINHADOR_A (
CO_ESPEC_EXECUTOR_A,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ENCAMINHADOR_AGREGADO                              */
/*==============================================================*/
create table TB_ENCAMINHADOR_AGREGADO (
   CO_SEQ_ENCAMINHADOR_AGREGADO NUMERIC(28)          not null,
   CO_EXECUTOR_AGREGADO NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   NU_COBERTURA         NUMERIC(10,2)        null,
   constraint PK_ENCAMINHADORAGREGADO primary key (CO_SEQ_ENCAMINHADOR_AGREGADO)
);

comment on table TB_ENCAMINHADOR_AGREGADO is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_EXECUTOR_AGREGADO.';

comment on column TB_ENCAMINHADOR_AGREGADO.CO_SEQ_ENCAMINHADOR_AGREGADO is
'Cdigo do municpio que encaminhou a execuo da produo ambulatorial para outro municpio.';

comment on column TB_ENCAMINHADOR_AGREGADO.CO_EXECUTOR_AGREGADO is
'Cdigo que contm todas as esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo,
a sequence de cada tabela de todos os nveis.';

comment on column TB_ENCAMINHADOR_AGREGADO.CO_MUNICIPIO_IBGE_RES is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio que encaminha para outro municpio realizar o procedimento ambulatorial.';

comment on column TB_ENCAMINHADOR_AGREGADO.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ENCAMINHADOR_AGREGADO.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ENCAMINHADOR_AGREGADO.NU_COBERTURA is
'Valor da cobertura agregado';

/*==============================================================*/
/* Index: IN_ENCAMIAGRE_COEXAGCOMUNICRES                        */
/*==============================================================*/
create  index IN_ENCAMIAGRE_COEXAGCOMUNICRES on TB_ENCAMINHADOR_AGREGADO (
CO_EXECUTOR_AGREGADO,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ENCAMINHADOR_H                                     */
/*==============================================================*/
create table TB_ENCAMINHADOR_H (
   CO_SEQ_ENCAMINHADOR_H NUMERIC(28)          not null,
   CO_ESPEC_EXECUTOR_H  NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   NU_COBERTURA         NUMERIC(10,2)        null,
   constraint PK_ENCAMINHADOR_H primary key (CO_SEQ_ENCAMINHADOR_H)
);

comment on table TB_ENCAMINHADOR_H is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_ESPEC_EXECUTOR_H. Todos os campos so programados
por tipo de leito, especialidade, forma de financiamento, complexidade, PPI, municpio executor e municpio encaminhador.
Esta tabela  utilizada para abrangncia da alta complexidade hospitalar.';

comment on column TB_ENCAMINHADOR_H.CO_SEQ_ENCAMINHADOR_H is
'Cdigo do municpio que executou a produo para outro.';

comment on column TB_ENCAMINHADOR_H.CO_ESPEC_EXECUTOR_H is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_ENCAMINHADOR_H.CO_MUNICIPIO_IBGE_RES is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio que encaminha para outro municpio realizar o procedimento hospitalar.';

comment on column TB_ENCAMINHADOR_H.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ENCAMINHADOR_H.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ENCAMINHADOR_H.NU_COBERTURA is
'Valor da cobertura hospitalar';

/*==============================================================*/
/* Index: IN_ENCAMINHAH_COESPEXECCOMUNRE                        */
/*==============================================================*/
create  index IN_ENCAMINHAH_COESPEXECCOMUNRE on TB_ENCAMINHADOR_H (
CO_ESPEC_EXECUTOR_H,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ENCAMINHADOR_UTI                                   */
/*==============================================================*/
create table TB_ENCAMINHADOR_UTI (
   CO_SEQ_ENCAMINHADOR_UTI NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   CO_ESPEC_EXECUTOR_UTI NUMERIC(28)          null,
   QT_POPULACAO         NUMERIC(8)           null,
   QT_FREQUENCIA        NUMERIC(16,10)       null,
   TP_IDENTIFICADOR     VARCHAR(1)           null,
   NU_COBERTURA         NUMERIC(10,2)        null,
   constraint PK_ENCAMINHADOR_UTI primary key (CO_SEQ_ENCAMINHADOR_UTI)
);

comment on table TB_ENCAMINHADOR_UTI is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_ESPEC_EXECUTOR_UTI.
Todos os campos so programados por tipo de UTI, forma de financiamento, PPI, municpio executor e municpio encaminhador.';

comment on column TB_ENCAMINHADOR_UTI.CO_SEQ_ENCAMINHADOR_UTI is
'Cdigo do municpio que encaminhou para outro executar a produo de UTI';

comment on column TB_ENCAMINHADOR_UTI.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial  da tabela TB_MUNICIPIO - Chave primria';

comment on column TB_ENCAMINHADOR_UTI.CO_ESPEC_EXECUTOR_UTI is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_ENCAMINHADOR_UTI.QT_POPULACAO is
'Quantidade da populao do municpio.';

comment on column TB_ENCAMINHADOR_UTI.QT_FREQUENCIA is
'Quantidade de atendimento da populao do municpio.';

comment on column TB_ENCAMINHADOR_UTI.TP_IDENTIFICADOR is
'Identifica o tipo 1- UTI, 2- UCI';

comment on column TB_ENCAMINHADOR_UTI.NU_COBERTURA is
'Valor da cobertura hospitalar UTI e UCI';

/*==============================================================*/
/* Index: IN_ENCAMINHAU_COESPEXUTCOMUNRE                        */
/*==============================================================*/
create  index IN_ENCAMINHAU_COESPEXUTCOMUNRE on TB_ENCAMINHADOR_UTI (
CO_ESPEC_EXECUTOR_UTI,
CO_MUNICIPIO_IBGE_RES
);

/*==============================================================*/
/* Table: TB_ESPECIALIDADE_PPI                                  */
/*==============================================================*/
create table TB_ESPECIALIDADE_PPI (
   CO_ESPECIALIDADE     VARCHAR(2)           not null,
   NO_ESPECIALIDADE     VARCHAR(150)         not null,
   constraint PK_ESPECIALIDADE_PPI primary key (CO_ESPECIALIDADE)
);

comment on table TB_ESPECIALIDADE_PPI is
'Tabela que contm todas as especialidades de um leito';

comment on column TB_ESPECIALIDADE_PPI.CO_ESPECIALIDADE is
'Cdigo das especialidades';

comment on column TB_ESPECIALIDADE_PPI.NO_ESPECIALIDADE is
'Descrio das especialidades';

/*==============================================================*/
/* Table: TB_ESPEC_EXECUTOR_A                                   */
/*==============================================================*/
create table TB_ESPEC_EXECUTOR_A (
   CO_SEQ_ESPEC_EXECUTOR_A NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_PARAM_ALTA_COMP_A NUMERIC(28)          null,
   VL_MEDIO             NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(14,6)        null,
   QT_CAPACIDADE_DISP   NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO    NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(14,6)        null,
   VL_PERC              NUMERIC(20,16)       null,
   CO_PARAMETRIZACAO_BOLSA NUMERIC(28)          null,
   constraint PK_ESPEC_EXECUTOR_A primary key (CO_SEQ_ESPEC_EXECUTOR_A)
);

comment on table TB_ESPEC_EXECUTOR_A is
'Tabela com os municpios executores, de  acordo com o que foi programado na TB_LEITO_ESPEC_A.
Todos os campos so programados por servios e alta complexidade ambulatorial, por forma de financiamento, PPI e municpio executor.';

comment on column TB_ESPEC_EXECUTOR_A.CO_SEQ_ESPEC_EXECUTOR_A is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_ESPEC_EXECUTOR_A.CO_MUNICIPIO_IBGE_MOV is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio executor.';

comment on column TB_ESPEC_EXECUTOR_A.CO_PARAM_ALTA_COMP_A is
'Cdigo dos parmetros da alta complexidade ambulatorial';

comment on column TB_ESPEC_EXECUTOR_A.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.';

comment on column TB_ESPEC_EXECUTOR_A.QT_FISICO is
' uma estimativa da quantidade de atendimentos da populao. O clculo do valor fsico  feito pela multiplicao do percentual executor pela freqncia do PC';

comment on column TB_ESPEC_EXECUTOR_A.QT_CAPACIDADE_DISP is
'Quantidade da populao disponvel para internaes.';

comment on column TB_ESPEC_EXECUTOR_A.VL_MEDIO_PRODUCAO is
' o valor mdio gasto com a populao. Vai buscar o VL_MEDIO_PRODUCAO na TB_BASE_GERADA_SIA.';

comment on column TB_ESPEC_EXECUTOR_A.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar o QT_FISICO_PRODUCAO na TB_BASE_GERADA_SIA.';

comment on column TB_ESPEC_EXECUTOR_A.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ESPEC_EXECUTOR_A.CO_PARAMETRIZACAO_BOLSA is
'Cdigo que vincula com a tb_espec_excutor_a e atravs desta vinculao  possvel localizar o fsico programado';

/*==============================================================*/
/* Index: IN_ESPECEXECA_COPARALTCOMUNMOV                        */
/*==============================================================*/
create  index IN_ESPECEXECA_COPARALTCOMUNMOV on TB_ESPEC_EXECUTOR_A (
CO_PARAM_ALTA_COMP_A,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Table: TB_ESPEC_EXECUTOR_H                                   */
/*==============================================================*/
create table TB_ESPEC_EXECUTOR_H (
   CO_SEQ_ESPEC_EXECUTOR_H NUMERIC(28)          not null,
   CO_LEITO_ESPEC_H     NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   VL_MEDIO             NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(14,6)        null,
   QT_CAPACIDADE_DISP   NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO    NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(14,6)        null,
   VL_PERC              NUMERIC(20,16)       null,
   constraint PK_ESPEC_EXECUTOR_H primary key (CO_SEQ_ESPEC_EXECUTOR_H)
);

comment on table TB_ESPEC_EXECUTOR_H is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_LEITO_ESPEC_H. Esta tabela  utilizada para abrangncia
da alta complexidade hospitalar. Todos os campos so programados por tipo de leito, especialidade, forma de financiamento, complexidade, 
PPI e municpio executor.';

comment on column TB_ESPEC_EXECUTOR_H.CO_SEQ_ESPEC_EXECUTOR_H is
'Cdigo dos nveis Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela para todos os nveis.';

comment on column TB_ESPEC_EXECUTOR_H.CO_LEITO_ESPEC_H is
'Cdigo dos nveis Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela para todos os nveis.';

comment on column TB_ESPEC_EXECUTOR_H.CO_MUNICIPIO_IBGE_MOV is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio executor.';

comment on column TB_ESPEC_EXECUTOR_H.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.';

comment on column TB_ESPEC_EXECUTOR_H.QT_FISICO is
' uma estimativa da quantidade de atendimentos da populao.';

comment on column TB_ESPEC_EXECUTOR_H.QT_CAPACIDADE_DISP is
'Quantidade da populao disponvel para internaes.';

comment on column TB_ESPEC_EXECUTOR_H.VL_MEDIO_PRODUCAO is
' o valor mdio gasto com a populao. Vai buscar o VL_MEDIO_PRODUCAO na TB_BASE_GERADA_SIH.';

comment on column TB_ESPEC_EXECUTOR_H.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar a QT_FISICO_PRODUCAO na TB_BASE_GERADA_SIH.';

comment on column TB_ESPEC_EXECUTOR_H.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

/*==============================================================*/
/* Index: IN_ESPECEXECH_COLEIESPCOMUNMOV                        */
/*==============================================================*/
create  index IN_ESPECEXECH_COLEIESPCOMUNMOV on TB_ESPEC_EXECUTOR_H (
CO_LEITO_ESPEC_H,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Table: TB_ESPEC_EXECUTOR_H_MUN                               */
/*==============================================================*/
create table TB_ESPEC_EXECUTOR_H_MUN (
   CO_SEQ_ESPEC_EXECUTOR_H_MUN NUMERIC(28)          not null,
   CO_LEITO_ESPEC_H_MUNIC NUMERIC(28)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   QT_FISICO            NUMERIC(14,6)        null,
   VL_MEDIO             NUMERIC(14,6)        null,
   constraint PK_ESPECEXECUTORHMUN primary key (CO_SEQ_ESPEC_EXECUTOR_H_MUN)
);

comment on table TB_ESPEC_EXECUTOR_H_MUN is
'Tabela com os municpios executores, de acordo com o que foi programado na tb_leito_espec_h_munic. Esta tabela  utilizada para abrangncia
da alta complexidade hospitalar. Todos os campos so programados por tipo de leito, especialidade, forma de financiamento, complexidade,
PPI e municpio executor.';

comment on column TB_ESPEC_EXECUTOR_H_MUN.CO_SEQ_ESPEC_EXECUTOR_H_MUN is
'Cdigo seqencial da tb_espec_executor_h_mun - Chave primria';

comment on column TB_ESPEC_EXECUTOR_H_MUN.CO_LEITO_ESPEC_H_MUNIC is
'Cdigo que vincula a tabela tb_leito_espec_h_munic, atravs desta vinculao  possvel localizar o fsico programado
por tipo de leito, especialidade, forma de financiamento  e complexidade';

comment on column TB_ESPEC_EXECUTOR_H_MUN.CO_MUNICIPIO_IBGE_MOV is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio executor.';

comment on column TB_ESPEC_EXECUTOR_H_MUN.QT_FISICO is
' uma estimativa da quantidade de atendimentos da populao.';

comment on column TB_ESPEC_EXECUTOR_H_MUN.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.';

/*==============================================================*/
/* Index: IN_ESPECEXECHMUN_COLEICOMUNMOV                        */
/*==============================================================*/
create  index IN_ESPECEXECHMUN_COLEICOMUNMOV on TB_ESPEC_EXECUTOR_H_MUN (
CO_LEITO_ESPEC_H_MUNIC,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Table: TB_ESPEC_EXECUTOR_UTI                                 */
/*==============================================================*/
create table TB_ESPEC_EXECUTOR_UTI (
   CO_SEQ_ESPEC_EXECUTOR_UTI NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_LEITO_UTI_H       NUMERIC(28)          null,
   VL_MEDIO             NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(14,6)        null,
   QT_CAPACIDADE_DISP   NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO    NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(14,6)        null,
   VL_PERC              NUMERIC(20,16)       null,
   TP_IDENTIFICADOR     VARCHAR(1)           null,
   constraint PK_ESPEC_EXECUTOR_UTI primary key (CO_SEQ_ESPEC_EXECUTOR_UTI)
);

comment on table TB_ESPEC_EXECUTOR_UTI is
'Tabela com os municpios executores, de acordo com o que foi programado na TB_LEITO_ESPEC_UTI. 
Todos os campos so programados por tipo de UTI, forma de financiamento, PPI e municpio executor.';

comment on column TB_ESPEC_EXECUTOR_UTI.CO_SEQ_ESPEC_EXECUTOR_UTI is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_ESPEC_EXECUTOR_UTI.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela TB_MUNICIPIO - Chave primria';

comment on column TB_ESPEC_EXECUTOR_UTI.CO_LEITO_UTI_H is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_ESPEC_EXECUTOR_UTI.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.';

comment on column TB_ESPEC_EXECUTOR_UTI.QT_FISICO is
' uma estimativa da quantidade de atendimentos da populao.';

comment on column TB_ESPEC_EXECUTOR_UTI.QT_CAPACIDADE_DISP is
'Quantidade da populao disponvel para internaes.';

comment on column TB_ESPEC_EXECUTOR_UTI.VL_MEDIO_PRODUCAO is
' o valor mdio gasto com a populao. Vai buscar o VL_MEDIO_PRODUCAO da TB_BASE_GERADA_SIH.';

comment on column TB_ESPEC_EXECUTOR_UTI.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar a QT_FISICO_PRODUCAO da TB_BASE_GERADA_SIH.';

comment on column TB_ESPEC_EXECUTOR_UTI.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_ESPEC_EXECUTOR_UTI.TP_IDENTIFICADOR is
'Identifica o tipo: 1- UTI, 2- UCI';

/*==============================================================*/
/* Index: IN_ESPECEXECU_COLEUTICOMUNMOV                         */
/*==============================================================*/
create  index IN_ESPECEXECU_COLEUTICOMUNMOV on TB_ESPEC_EXECUTOR_UTI (
CO_LEITO_UTI_H,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Table: TB_ESTABELECIMENTO_PPI                                */
/*==============================================================*/
create table TB_ESTABELECIMENTO_PPI (
   CO_UNIDADE           VARCHAR(31)          null,
   CO_CNES              VARCHAR(7)           null,
   NO_FANTASIA          VARCHAR(60)          null,
   CO_MUNICIPIO_GESTOR  VARCHAR(7)           null
);

comment on table TB_ESTABELECIMENTO_PPI is
'Tabela de que contm os estabelecimentos de sade';

comment on column TB_ESTABELECIMENTO_PPI.CO_UNIDADE is
'Cdigo formado pela juno do cdigo do municpio com o cdigo CNES';

comment on column TB_ESTABELECIMENTO_PPI.CO_CNES is
'Cdigo do estabelecimento de sade';

comment on column TB_ESTABELECIMENTO_PPI.NO_FANTASIA is
'Nome do estabelecimento de sade';

comment on column TB_ESTABELECIMENTO_PPI.CO_MUNICIPIO_GESTOR is
'Cdigo IBGE do municpio';

/*==============================================================*/
/* Table: TB_ESTRUT_REGIONALIZACAO                              */
/*==============================================================*/
create table TB_ESTRUT_REGIONALIZACAO (
   CO_SEQ_ESTRUT_REGIONALIZACAO NUMERIC(28)          not null,
   CO_REGIONALIZACAO    NUMERIC(8)           null,
   CO_ESTRUT_REGIONALIZACAO_PAI NUMERIC(28)          null,
   NO_ESTRUT_REGIONALIZACAO VARCHAR(60)          null,
   constraint PK_ESTRUT_REGIONALIZACAO primary key (CO_SEQ_ESTRUT_REGIONALIZACAO)
);

comment on table TB_ESTRUT_REGIONALIZACAO is
'Estrutura da regionalizao em relao aos seus nveis.';

comment on column TB_ESTRUT_REGIONALIZACAO.CO_SEQ_ESTRUT_REGIONALIZACAO is
'Cdigo seqencial da estrutura de uma regional';

comment on column TB_ESTRUT_REGIONALIZACAO.CO_REGIONALIZACAO is
'Cdigo seqencial  da tabela TB_REGIONALIZACAO - Chave primria';

comment on column TB_ESTRUT_REGIONALIZACAO.CO_ESTRUT_REGIONALIZACAO_PAI is
'Cdigo agrupador da estrutura';

comment on column TB_ESTRUT_REGIONALIZACAO.NO_ESTRUT_REGIONALIZACAO is
'Nome da estrutura da regionalizao';

/*==============================================================*/
/* Table: TB_EXECUTOR_AGREGADO                                  */
/*==============================================================*/
create table TB_EXECUTOR_AGREGADO (
   CO_SEQ_EXECUTOR_AGREGADO NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_AGREGADO          NUMERIC(28)          null,
   VL_MEDIO             NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(14,6)        null,
   VL_MEDIO_PRODUCAO    NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(14,6)        null,
   VL_PERC              NUMERIC(20,16)       null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   CO_PPI               NUMERIC(28)          null,
   CO_PROCEDIMENTO_NAO_SUS NUMERIC(28)          null,
   constraint PK_EXECUTORAGREGADO primary key (CO_SEQ_EXECUTOR_AGREGADO)
);

comment on table TB_EXECUTOR_AGREGADO is
'Tabela com os municpios executores, de  acordo com o que foi programado na TB_AGREGADO.';

comment on column TB_EXECUTOR_AGREGADO.CO_SEQ_EXECUTOR_AGREGADO is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_EXECUTOR_AGREGADO.CO_MUNICIPIO_IBGE_MOV is
'Cdigo do municpio, de acordo com a tabela do IBGE. Municpio executor.';

comment on column TB_EXECUTOR_AGREGADO.CO_AGREGADO is
'Cdigo dos parmetros dos agregados';

comment on column TB_EXECUTOR_AGREGADO.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.';

comment on column TB_EXECUTOR_AGREGADO.QT_FISICO is
' uma estimativa da quantidade de atendimentos da populao.
O clculo do valor fsico  feito pela multiplicao do percentual executor pela freqncia do PC';

comment on column TB_EXECUTOR_AGREGADO.VL_MEDIO_PRODUCAO is
' o valor mdio gasto com a populao. Vai buscar o VL_MEDIO_PRODUCAO na TB_BASE_GERADA_SIA.';

comment on column TB_EXECUTOR_AGREGADO.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar o QT_FISICO_PRODUCAO na TB_BASE_GERADA_SIA.';

comment on column TB_EXECUTOR_AGREGADO.VL_PERC is
'Esta coluna armazena o valor percentual de atendimentos de um municpio executor em relao ao total de executores.';

comment on column TB_EXECUTOR_AGREGADO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_EXECUTOR_AGREGADO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_EXECUTOR_AGREGADO.CO_PROCEDIMENTO_NAO_SUS is
'Cdigo do Procedimento no-SUS';

/*==============================================================*/
/* Index: IN_EXECUAGRE_COAGREGCOMUNMOV                          */
/*==============================================================*/
create  index IN_EXECUAGRE_COAGREGCOMUNMOV on TB_EXECUTOR_AGREGADO (
CO_AGREGADO,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Index: IN_EXECUAGRE_COPROCNAOCOMUNMOV                        */
/*==============================================================*/
create  index IN_EXECUAGRE_COPROCNAOCOMUNMOV on TB_EXECUTOR_AGREGADO (
CO_PROCEDIMENTO_NAO_SUS,
CO_MUNICIPIO_IBGE_MOV
);

/*==============================================================*/
/* Table: TB_FINANCIAMENTO_PPI                                  */
/*==============================================================*/
create table TB_FINANCIAMENTO_PPI (
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   SG_FINANCIAMENTO     VARCHAR(40)          null,
   ST_ATIVO             VARCHAR(1)           not null,
   ST_PROGRAMACAO       VARCHAR(1)           null,
   constraint PK_TB_FINANCIAMENTO_PPI primary key (CO_FINANCIAMENTO, CO_PPI)
);

comment on table TB_FINANCIAMENTO_PPI is
'Tabela que contm as formas de financiamento utilizadas pelo SISPPI.';

comment on column TB_FINANCIAMENTO_PPI.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_FINANCIAMENTO_PPI.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_FINANCIAMENTO_PPI.SG_FINANCIAMENTO is
'Sigla da forma de financiamento';

comment on column TB_FINANCIAMENTO_PPI.ST_ATIVO is
'Indica se a forma de financiamento ser usada no sistema SISPPI ou no: S - Sim, N -No';

comment on column TB_FINANCIAMENTO_PPI.ST_PROGRAMACAO is
'Indica se a forma de financiamento ser usada para programao: S - Sim, N -No';

/*==============================================================*/
/* Table: TB_FORMA_FINANCIAMENTO_DEPARA                         */
/*==============================================================*/
create table TB_FORMA_FINANCIAMENTO_DEPARA (
   CO_SEQ_FORMA_FINAN   NUMERIC(8)           not null,
   DS_FORMA_FINAN       VARCHAR(30)          not null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   constraint PK_FORMAFINANCIAMENTODEPARA primary key (CO_SEQ_FORMA_FINAN)
);

comment on table TB_FORMA_FINANCIAMENTO_DEPARA is
'Forma de financiamento dos procedimentos sia e sih.
Servir como tabela de apoio para os procedimentos que no tiverem DE_PARA (excludos)';

comment on column TB_FORMA_FINANCIAMENTO_DEPARA.CO_SEQ_FORMA_FINAN is
'Cdigo da forma de financiamento';

comment on column TB_FORMA_FINANCIAMENTO_DEPARA.DS_FORMA_FINAN is
'Descio da forma de financiamneto';

comment on column TB_FORMA_FINANCIAMENTO_DEPARA.CO_FINANCIAMENTO is
'Cdigo do financiamento - Tabela Unificada';

/*==============================================================*/
/* Table: TB_IBGE                                               */
/*==============================================================*/
create table TB_IBGE (
   CO_SEQ_IBGE          NUMERIC(8)           not null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           null,
   NU_ANO               NUMERIC(4)           null,
   TP_SEXO              VARCHAR(1)           null,
   DS_FAIXA_ETARIA      VARCHAR(4)           null,
   QT_POPULACAO         NUMERIC(10)          null,
   constraint PK_IBGE primary key (CO_SEQ_IBGE)
);

comment on table TB_IBGE is
'Tabela da populao do IBGE';

comment on column TB_IBGE.CO_SEQ_IBGE is
'Cdigo nico do IBGE que identifica uma Unidade Federativa Brasileira - UF - chave primria';

comment on column TB_IBGE.CO_MUNICIPIO_IBGE is
'Cdigo nico do IBGE que identifica um municpio brasileiro - chave secundria';

comment on column TB_IBGE.NU_ANO is
'Ano de uma populao';

comment on column TB_IBGE.TP_SEXO is
'Tipo do sexo - masculino/feminino';

comment on column TB_IBGE.DS_FAIXA_ETARIA is
'Descrio da faixa etria da populao.';

comment on column TB_IBGE.QT_POPULACAO is
'Quantidade da populao.';

/*==============================================================*/
/* Table: TB_INFORMACAO                                         */
/*==============================================================*/
create table TB_INFORMACAO (
   CO_SEQ_INFORMACAO    NUMERIC(28)          not null,
   CO_AREA_ATUACAO      NUMERIC(28)          null,
   CO_AREA_ESTRATEGICA  NUMERIC(28)          null,
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          null,
   DS_INFORMACAO        VARCHAR(150)         null,
   ST_INFORMACAO        VARCHAR(1)           null,
   NU_ORDENACAO         NUMERIC(10)          null,
   constraint PK_INFORMACAO primary key (CO_SEQ_INFORMACAO)
);

comment on table TB_INFORMACAO is
'Informaes sobre as reas estratgicas e reas de atuao e aes.';

comment on column TB_INFORMACAO.CO_SEQ_INFORMACAO is
'Chave primria - seqencial';

comment on column TB_INFORMACAO.CO_AREA_ATUACAO is
'Cdigo seqencial da rea de atuao - Chave primria.';

comment on column TB_INFORMACAO.CO_AREA_ESTRATEGICA is
'Cdigo seqencial da rea estratgica - Chave primria.';

comment on column TB_INFORMACAO.CO_CONFIGURACAO_POPULACAO is
'Cdigo da parametrizao da populao.';

comment on column TB_INFORMACAO.DS_INFORMACAO is
'Descrio de uma informao (ao, rea estratgica, rea de atuao)';

comment on column TB_INFORMACAO.ST_INFORMACAO is
'Status da informao';

comment on column TB_INFORMACAO.NU_ORDENACAO is
'Este campo ser utilizado para ordenar a descrio de uma informao (no_informacao).';

/*==============================================================*/
/* Table: TB_LEITO_ESPEC_H                                      */
/*==============================================================*/
create table TB_LEITO_ESPEC_H (
   CO_SEQ_LEITO_ESPEC_H NUMERIC(28)          not null,
   CO_DESTAQUE          NUMERIC(28)          null,
   VL_DISTRIBUICAO      NUMERIC(14,6)        null,
   VL_MEDIO             NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(8)           null,
   VL_DISTRIBUICAO_PRODUCAO NUMERIC(14,6)        null,
   VL_MEDIO_MUNICIPAL   NUMERIC(14,6)        null,
   VL_FINANCEIRO_PRODUCAO NUMERIC(14,2)        null,
   ST_ABRANGENCIA       VARCHAR(1)           null,
   ST_CARGA_ABRANGENCIA VARCHAR(1)           null,
   TP_ABRANGENCIA       VARCHAR(1)           null,
   constraint PK_LEITO_ESPEC_H primary key (CO_SEQ_LEITO_ESPEC_H)
);

comment on table TB_LEITO_ESPEC_H is
'Nessa tabela so armazenados os tipos de leitos e especialidades hospitalares, por forma de financiamento, complexidade e PPI da tabela TB_DESTAQUE.
Tabela criada para efetuar a programao das telas:
- Percentual de Participao por Tipo/Especialidade do leito - Estado.
- Consulta Percentual de Participao por Tipo/Especialidade do leito - Estado.
- Percentual de Participao por Tipo/Especialidade do leito - Municpio
- Consulta Percentual de Participao por Tipo/Especialidade do leito - Municpio
- Valor Mdio por Tipo/Especialidade do leito - Estado
- Consulta do Valor Mdio por Tipo/Especialidade do leito - Estado
- Valor Mdio por Tipo/Especialidade do leito - Municpio
- Consulta do Valor Mdio por Tipo/Especialidade do leito - Municpio
- Alta Complexidade Hospitalar (Abrangncia)';

comment on column TB_LEITO_ESPEC_H.CO_SEQ_LEITO_ESPEC_H is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_LEITO_ESPEC_H.CO_DESTAQUE is
'Cdigo de relacionamento com a TB_DESTAQUE para buscar o que foi destacado (ST_DESTACADO=''S'') por:
Complexidade, Forma de Financiamento, Leito, Atributo, PPI';

comment on column TB_LEITO_ESPEC_H.VL_DISTRIBUICAO is
' um percentual que o usurio informa para planejar a quantidade de atendimentos a serem realizados.
Esse percentual resulta no Fsico, que  uma regra de 3 que pega esse percentual * 100 / total da populao programado
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio';

comment on column TB_LEITO_ESPEC_H.VL_MEDIO is
' uma estimativa do valor mdio gasto com a populao.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Estado.
 um valor que o usurio informa para resultar no Financeiro. VL_MEDIO * QT_FISICO_MUNICIPAL igual a um Financeiro.';

comment on column TB_LEITO_ESPEC_H.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar a QT_FISICO_PRODUCAO na TB_BASE_GERADA_SIH.
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio
Valor Mdio por Tipo/Especialidade do leito - Estado';

comment on column TB_LEITO_ESPEC_H.VL_DISTRIBUICAO_PRODUCAO is
' um percentual baseado na quantidade de atendimentos da populao.
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio
 o resultado do (QT_FISICO_PRODUCAO * 100) / Soma de Todos os (QT_FISICO_PRODUCAO )';

comment on column TB_LEITO_ESPEC_H.VL_MEDIO_MUNICIPAL is
' uma estimativa do valor mdio gasto com a populao do municpio.
Utilizado na tela:
Valor Mdio por Tipo/Especialidade do leito - Estado
 um valor que o usurio informa para resultar no Financeiro.
VL_MEDIO * QT_FISICO_MUNICIPAL igual a um Financeiro.
Gerado por meio da frmula: vl_medio_municipal = (vl_medio_proprio + e.vl_medio_referenciado)/2';

comment on column TB_LEITO_ESPEC_H.VL_FINANCEIRO_PRODUCAO is
' o valor financeiro gasto com a populao por forma de financiamento, complexidade, leito e especialidade.';

comment on column TB_LEITO_ESPEC_H.ST_ABRANGENCIA is
'Indica se o leito vai realizar abrangncia: S - Sim ou N - No.';

comment on column TB_LEITO_ESPEC_H.ST_CARGA_ABRANGENCIA is
'Indica se foi realizada a carga para a abrangncia dos agregados.(S- Sim , N- No) S - com carga, N - sem carga.';

comment on column TB_LEITO_ESPEC_H.TP_ABRANGENCIA is
'Define o tipo de abrangncia:
(1 - abrangncia Per Capita,
 2 - abrangncia com distribuio programvel
 3 - abrangncia sem distribuio automtica)';

/*==============================================================*/
/* Index: IN_LEITOESPECH_CODESTAQUE                             */
/*==============================================================*/
create  index IN_LEITOESPECH_CODESTAQUE on TB_LEITO_ESPEC_H (
CO_DESTAQUE
);

/*==============================================================*/
/* Table: TB_LEITO_ESPEC_H_MUNIC                                */
/*==============================================================*/
create table TB_LEITO_ESPEC_H_MUNIC (
   CO_SEQ_LEITO_ESPEC_H_MUNIC NUMERIC(28)          not null,
   CO_DESTAQUE          NUMERIC(28)          not null,
   VL_DISTRIBUICAO      NUMERIC(14,6)        null,
   VL_MEDIO_PROPRIO     NUMERIC(14,6)        null,
   VL_MEDIO_REFERENCIADO NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO   NUMERIC(8)           null,
   VL_DISTRIBUICAO_PRODUCAO NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO_PROPRIA NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO_PROPRIA NUMERIC(14,6)        null,
   QT_FISICO_PRODUCAO_REFERENCIAD NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO_REFERENCIADA NUMERIC(14,6)        null,
   QT_FISICO            NUMERIC(8)           null,
   constraint PK_LEITO_ESPEC_H_MUNIC primary key (CO_SEQ_LEITO_ESPEC_H_MUNIC)
);

comment on table TB_LEITO_ESPEC_H_MUNIC is
'Nessa tabela so programados os tipos de leito e especialidades hospitalares, por forma de financiamento, complexidade, PPI da tabela TB_DESTAQUE.
Tabela criada para efetuar a programao das telas:
- Percentual de Participao por Tipo/Especialidade do leito - Estado.
- Consulta Percentual de Participao por Tipo/Especialidade do leito - Estado.
- Percentual de Participao por Tipo/Especialidade do leito - Municpio
- Consulta Percentual de Participao por Tipo/Especialidade do leito - Municpio
- Valor Mdio por Tipo/Especialidade do leito - Estado
- Consulta do Valor Mdio por Tipo/Especialidade do leito - Estado
- Valor Mdio por Tipo/Especialidade do leito - Municpio
- Consulta do Valor Mdio por Tipo/Especialidade do leito - Municpio
- Alta Complexidade Hospitalar (Abrangncia)';

comment on column TB_LEITO_ESPEC_H_MUNIC.CO_SEQ_LEITO_ESPEC_H_MUNIC is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_LEITO_ESPEC_H_MUNIC.CO_DESTAQUE is
'Cdigo de relacionamento com a TB_DESTAQUE, para buscar o que foi destacado (ST_DESTACADO=''S'') por:
Complexidade, Forma de Financiamento, Leito, Atributo, PPI';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_DISTRIBUICAO is
' um percentual que o usurio informa para planejar a quantidade de atendimentos a serem realizados.
Esse percentual resulta no Fsico, que  uma regra de 3 que pega esse percentual * 100 / total da populao programado.
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_MEDIO_PROPRIO is
' uma estimativa do valor mdio gasto com a populao do prprio estado.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio.
 um valor que o usurio informa para resultar em um VL_MEDIO do estado.
((VL_MEDIO_PROPRIO + VL_MEDIO_REFERENCIADO) / 2) / Qtde de Municpio.';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_MEDIO_REFERENCIADO is
' uma estimativa do valor mdio gasto com a populao de outro estado.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio.
 um valor que o usurio informa para resultar em um VL_MEDIO do estado. 
((VL_MEDIO_PROPRIO + VL_MEDIO_REFERENCIADO) / 2) / Qtde de Municpio.';

comment on column TB_LEITO_ESPEC_H_MUNIC.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos da populao. Vai buscar a QT_FISICO_PRODUCAO da TB_BASE_GERADA_SIH.
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio
Valor Mdio por Tipo/Especialidade do leito - Estado';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_DISTRIBUICAO_PRODUCAO is
' um percentual baseado na quantidade de atendimentos da populao.
Utilizado nas telas:
Percentual de Participao por Tipo/Especialidade do leito - Estado.
Percentual de Participao por Tipo/Especialidade do leito - Municpio
 um valor que vai ser o resultado do (QT_FISICO_PRODUCAO * 100) / Soma de Todos os (QT_FISICO_PRODUCAO )';

comment on column TB_LEITO_ESPEC_H_MUNIC.QT_FISICO_PRODUCAO_PROPRIA is
' a quantidade de atendimentos da populao do prprio estado.
Vai buscar a QT_FISICO_PRODUCAO da TB_BASE_GERADA_SIH, onde:
co_municipio_ibge_mov = Municpio
co_municipio_ibge_res = Municpio
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_MEDIO_PRODUCAO_PROPRIA is
' o valor mdio gasto com a populao do prprio estado.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio
Vai buscar a VL_MEDIO_PRODUCAO da TB_BASE_GERADA_SIH, onde:
co_municipio_ibge_mov = Municpio
co_municipio_ibge_res = Municpio';

comment on column TB_LEITO_ESPEC_H_MUNIC.QT_FISICO_PRODUCAO_REFERENCIAD is
' a quantidade de atendimentos da populao de outro estado.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio
Vai buscar a QT_FISICO_PRODUCAO da TB_BASE_GERADA_SIH, onde:
co_municipio_ibge_mov = Municpio
co_municipio_ibge_res <> Municpio';

comment on column TB_LEITO_ESPEC_H_MUNIC.VL_MEDIO_PRODUCAO_REFERENCIADA is
' o valor mdio gasto com a populao de outro estado.
Utilizado na tela: Valor Mdio por Tipo/Especialidade do leito - Municpio
Vai buscar a VL_MEDIO_PRODUCAO da TB_BASE_GERADA_SIH, onde:
co_municipio_ibge_mov = Municpio
co_municipio_ibge_res <> Municpio';

comment on column TB_LEITO_ESPEC_H_MUNIC.QT_FISICO is
'Quantidade de atendimentos a serem realizados.';

/*==============================================================*/
/* Index: IN_LEITESPMUNI_COLEITOFISICO                          */
/*==============================================================*/
create  index IN_LEITESPMUNI_COLEITOFISICO on TB_LEITO_ESPEC_H_MUNIC (
(substr(co_seq_leito_espec_h_munic, 8,6)),
QT_FISICO
);

/*==============================================================*/
/* Index: IN_LEITESPMUNI_COSLEITESPEMUNI                        */
/*==============================================================*/
create  index IN_LEITESPMUNI_COSLEITESPEMUNI on TB_LEITO_ESPEC_H_MUNIC (
(substr(co_seq_leito_espec_h_munic, 8,6))
);

/*==============================================================*/
/* Index: IN_LEITOESPECHMUNIC_CODESTAQUE                        */
/*==============================================================*/
create  index IN_LEITOESPECHMUNIC_CODESTAQUE on TB_LEITO_ESPEC_H_MUNIC (
CO_DESTAQUE
);

/*==============================================================*/
/* Table: TB_LEITO_PPI                                          */
/*==============================================================*/
create table TB_LEITO_PPI (
   CO_LEITO             VARCHAR(2)           not null,
   NO_LEITO             VARCHAR(60)          null,
   constraint PK_LEITO_PPI primary key (CO_LEITO)
);

comment on table TB_LEITO_PPI is
'Tabela com os leitos dos estabelecimentos.';

comment on column TB_LEITO_PPI.CO_LEITO is
'Cdigo do leito de um estabelecimento';

comment on column TB_LEITO_PPI.NO_LEITO is
'Descrio do leito';

/*==============================================================*/
/* Table: TB_LEITO_UTI_H                                        */
/*==============================================================*/
create table TB_LEITO_UTI_H (
   CO_SEQ_LEITO_UTI_H   NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          null,
   QT_FISICO_CIB        NUMERIC(8)           null,
   VL_DIARIA_ABRANGENCIA NUMERIC(10,2)        null,
   VL_FISICO_PRODUCAO   NUMERIC(10,2)        null,
   VL_FINANCEIRO_PRODUCAO NUMERIC(10,2)        null,
   TP_IDENTIFICADOR     VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_TIPO_LEITO        VARCHAR(2)           null,
   TP_ABRANGENCIA       VARCHAR(1)           null,
   constraint PK_LEITO_UTI_H primary key (CO_SEQ_LEITO_UTI_H)
);

comment on table TB_LEITO_UTI_H is
'Nessa tabela  armazenada a programao dos tipos de UTI, por forma de financiamento e PPI.';

comment on column TB_LEITO_UTI_H.CO_SEQ_LEITO_UTI_H is
'Cdigo das esferas: Federal, Estadual, Regional, Municipal e Distrital e, por ltimo, a sequence de cada tabela de todos os nveis.';

comment on column TB_LEITO_UTI_H.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_LEITO_UTI_H.QT_FISICO_CIB is
' a quantidade estimada de atendimentos para a populao.';

comment on column TB_LEITO_UTI_H.VL_DIARIA_ABRANGENCIA is
' o valor gasto por dia de permanncia na UTI.';

comment on column TB_LEITO_UTI_H.VL_FISICO_PRODUCAO is
' a quantidade de atendimentos para a populao.';

comment on column TB_LEITO_UTI_H.VL_FINANCEIRO_PRODUCAO is
' o valor financeiro gasto com a populao.';

comment on column TB_LEITO_UTI_H.TP_IDENTIFICADOR is
'Identifica o tipo: 1- UTI, 2- UCI';

comment on column TB_LEITO_UTI_H.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_LEITO_UTI_H.CO_TIPO_LEITO is
'Cdigo do tipo de leito da tabela unificada';

comment on column TB_LEITO_UTI_H.TP_ABRANGENCIA is
'Define o tipo de abrangncia:
(1 - abrangncia Per Capita,
 2 - abrangncia com distribuio programvel
 3 - abrangncia sem distribuio automtica)';

/*==============================================================*/
/* Index: IN_LEITUTI_COIDENLEITFINPPIFIS                        */
/*==============================================================*/
create  index IN_LEITUTI_COIDENLEITFINPPIFIS on TB_LEITO_UTI_H (
TP_IDENTIFICADOR,
(substr(co_seq_leito_uti_h, 8,6)),
CO_FINANCIAMENTO,
CO_PPI,
QT_FISICO_CIB
);

/*==============================================================*/
/* Table: TB_LIMITE_FINANCEIRO                                  */
/*==============================================================*/
create table TB_LIMITE_FINANCEIRO (
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   VL_LIMITE_FINANCEIRO NUMERIC(14,2)        not null,
   VL_RECURSO_PROGRAMACAO NUMERIC(14,2)        null,
   CO_SEQ_LIMITE_FINANCEIRO NUMERIC(28)          not null,
   constraint PK_LIMITEFINANCEIRO primary key (CO_SEQ_LIMITE_FINANCEIRO)
);

comment on table TB_LIMITE_FINANCEIRO is
'Contm os limites financeiros liberados para os estados, de acordo com a forma de financiamento.';

comment on column TB_LIMITE_FINANCEIRO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento de um procedimento SIA ou SIH';

comment on column TB_LIMITE_FINANCEIRO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_LIMITE_FINANCEIRO.VL_LIMITE_FINANCEIRO is
'Valor total que pode ser gasto com um recurso especfico para uma forma de financiamento.';

comment on column TB_LIMITE_FINANCEIRO.VL_RECURSO_PROGRAMACAO is
'Valor a ser utilizado para a programao dos recursos especficos.';

comment on column TB_LIMITE_FINANCEIRO.CO_SEQ_LIMITE_FINANCEIRO is
'Cdigo seqencial da tb_limite_financeiro - Chave primria';

/*==============================================================*/
/* Table: TB_MODALIDADE_PPI                                     */
/*==============================================================*/
create table TB_MODALIDADE_PPI (
   CO_SEQ_MODALIDADE    NUMERIC(8)           not null,
   DS_MODALIDADE        VARCHAR(60)          null,
   constraint PK_MODALIDADE_PPI primary key (CO_SEQ_MODALIDADE)
);

comment on table TB_MODALIDADE_PPI is
'Contm as modalidades do servio de uma alta complexidade.';

comment on column TB_MODALIDADE_PPI.CO_SEQ_MODALIDADE is
'Cdigo seqencial das modalidades de uma alta complexidade';

comment on column TB_MODALIDADE_PPI.DS_MODALIDADE is
'Descrio das modalidades de uma alta complexidade';

/*==============================================================*/
/* Table: TB_NIVEL_REGIONALIZACAO                               */
/*==============================================================*/
create table TB_NIVEL_REGIONALIZACAO (
   CO_SEQ_NIVEL_REGIONALIZACAO NUMERIC(4)           not null,
   CO_ESTRUT_REGIONALIZACAO NUMERIC(28)          null,
   CO_NIVEL_REGIONALIZACAO_PAI NUMERIC(4)           null,
   NO_NIVEL_REGIONALIZACAO VARCHAR(50)          null,
   constraint PK_NIVEL_REGIONALIZACAO primary key (CO_SEQ_NIVEL_REGIONALIZACAO)
);

comment on table TB_NIVEL_REGIONALIZACAO is
'Descrio dos nveis de regionalizao de uma determinada regional';

comment on column TB_NIVEL_REGIONALIZACAO.CO_SEQ_NIVEL_REGIONALIZACAO is
'Cdigo seqencial da tabela TB_NIVEL_REGIONALIZACAO - Chave Primria.';

comment on column TB_NIVEL_REGIONALIZACAO.CO_ESTRUT_REGIONALIZACAO is
'Cdigo da estrutura da regionalizao a qual o nvel pertence.';

comment on column TB_NIVEL_REGIONALIZACAO.CO_NIVEL_REGIONALIZACAO_PAI is
'Cdigo seqencial da tabela TB_NIVEL_REGIONALIZACAO - Chave estrangeira.';

comment on column TB_NIVEL_REGIONALIZACAO.NO_NIVEL_REGIONALIZACAO is
'Descrio do nvel de regionalizao.';

/*==============================================================*/
/* Table: TB_PACOTE_TRS                                         */
/*==============================================================*/
create table TB_PACOTE_TRS (
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_ALTA_COMP_AMB_MOD NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          not null,
   DS_CONCENTRACAO      VARCHAR(500)         null,
   DS_QUANT_EXAME       VARCHAR(500)         null,
   QT_EXAME_PACIENTE    NUMERIC(10,2)        null,
   CO_IDENTIFICADOR     VARCHAR(13)          not null,
   constraint PK_PROCEDIMENTOSIA_PPICOMPETEN primary key (CO_PROCEDIMENTO, CO_ALTA_COMP_AMB_MOD, CO_PPI, CO_IDENTIFICADOR)
);

comment on table TB_PACOTE_TRS is
'Procedimentos especficos da TRS.';

comment on column TB_PACOTE_TRS.CO_PROCEDIMENTO is
'Cdigo do Procedimento - Chave primria';

comment on column TB_PACOTE_TRS.CO_ALTA_COMP_AMB_MOD is
'Cdigo da alta complexidade ambulatorial/modalidade - RL.';

comment on column TB_PACOTE_TRS.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_PACOTE_TRS.DS_CONCENTRACAO is
'Descrio da concentrao do procedimento TRS';

comment on column TB_PACOTE_TRS.DS_QUANT_EXAME is
'Descrio da quantidade de exames, por perodo, que o paciente de TRS poder realizar.';

comment on column TB_PACOTE_TRS.QT_EXAME_PACIENTE is
'Quantidade de exames que o paciente de TRS poder realizar.';

comment on column TB_PACOTE_TRS.CO_IDENTIFICADOR is
'Cdigo que indica o nvel em que o procedimento est no pacote trs.';

/*==============================================================*/
/* Table: TB_PARAMETRIZACAO_ALTA_COMP_A                         */
/*==============================================================*/
create table TB_PARAMETRIZACAO_ALTA_COMP_A (
   CO_SEQ_PARAM_ALTA_COMP_A NUMERIC(28)          not null,
   CO_ALTA_COMP_AMB_MOD NUMERIC(28)          null,
   CO_PPI               NUMERIC(28)          null,
   QT_FISICO_PROPOSTO   NUMERIC(8)           null,
   VL_MEDIO_PROPOSTO    NUMERIC(14,6)        null,
   VL_PERCENTUAL_PROPOSTO NUMERIC(16,10)       null,
   QT_FISICO_PRODUCAO   NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO    NUMERIC(14,6)        null,
   VL_PERCENTUAL_PRODUCAO NUMERIC(16,10)       null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   TP_ABRANGENCIA       VARCHAR(1)           null,
   constraint PK_PARAMETRIZACAO_ALTA_COMP primary key (CO_SEQ_PARAM_ALTA_COMP_A)
);

comment on table TB_PARAMETRIZACAO_ALTA_COMP_A is
'Nessa tabela  feita a programao dos servios de alta complexidade ambulatorial por forma de financiamento e PPI.
Utilizada pelas seguintes tabelas: Litotripsia, Oncologia, Sade Auditiva, Reabilitao Motora, Bolsas para Ostomizados, Diagnsticos, TRS e Hemoterapia.';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.CO_SEQ_PARAM_ALTA_COMP_A is
'Cdigo dos parmetros da alta complexidade ambulatorial';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.CO_ALTA_COMP_AMB_MOD is
'Cdigo da descrio da alta complexidade ambulatorial/modalidade';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.QT_FISICO_PROPOSTO is
' a quantidade estimada de atendimentos para a populao.';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.VL_MEDIO_PROPOSTO is
' uma estimativa do valor mdio gasto com a populao.';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.VL_PERCENTUAL_PROPOSTO is
'Percentual da parametrizao proposto';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.QT_FISICO_PRODUCAO is
' a quantidade de atendimentos para a populao.';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.VL_MEDIO_PRODUCAO is
' o valor mdio gasto com a populao.';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.VL_PERCENTUAL_PRODUCAO is
'Percentual da parametrizao produo';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PARAMETRIZACAO_ALTA_COMP_A.TP_ABRANGENCIA is
'Define o tipo de abrangncia:
(1 - abrangncia Per Capita,
 2 - abrangncia com distribuio programvel
 3 - abrangncia sem distribuio automtica)';

/*==============================================================*/
/* Index: IN_PARAMALTACO_COFINTPABRCOPPI                        */
/*==============================================================*/
create  index IN_PARAMALTACO_COFINTPABRCOPPI on TB_PARAMETRIZACAO_ALTA_COMP_A (
CO_FINANCIAMENTO,
TP_ABRANGENCIA,
CO_PPI
);

/*==============================================================*/
/* Index: IN_PARAMALTACOM_COSEQPARAMALTA                        */
/*==============================================================*/
create  index IN_PARAMALTACOM_COSEQPARAMALTA on TB_PARAMETRIZACAO_ALTA_COMP_A (
(substr(co_seq_param_alta_comp_a, 8,6))
);

/*==============================================================*/
/* Table: TB_PARAMETRIZACAO_BOLSA                               */
/*==============================================================*/
create table TB_PARAMETRIZACAO_BOLSA (
   CO_SEQ_PARAMETRIZACAO_BOLSA NUMERIC(28)          not null,
   CO_ALTA_COMP_AMB_MOD NUMERIC(28)          null,
   CO_PROCEDIMENTO      VARCHAR(10)          null,
   CO_PPI               NUMERIC(28)          null,
   QT_FISICO_PRODUCAO   NUMERIC(8)           null,
   VL_MEDIO_PRODUCAO    NUMERIC(10,2)        null,
   QT_FISICO_PROPOSTO   NUMERIC(8)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   VL_SA                NUMERIC(10,2)        null,
   constraint PK_PARAMETRIZACAO_BOLSA primary key (CO_SEQ_PARAMETRIZACAO_BOLSA)
);

comment on table TB_PARAMETRIZACAO_BOLSA is
'Tabela para o tipo de alta complexidade ambulatorial Bolsas Ostomizados.
Nesta tabela estaro os dados da produo para fsico, mdia e financeiro, de acordo com o grupo, subgrupo, forma de organizao e procedimento.';

comment on column TB_PARAMETRIZACAO_BOLSA.CO_SEQ_PARAMETRIZACAO_BOLSA is
'Cdigo do procedimento ao qual um procedimento ambulatorial pertence.
Os Procedimentos SIA so organizados da seguinte forma: Grupo / Subgrupo / Forma de Organizao / Procedimento
Ex: 01/02/3/12 - > 0102312';

comment on column TB_PARAMETRIZACAO_BOLSA.CO_ALTA_COMP_AMB_MOD is
'Cdigo da descrio da alta complexidade ambulatorial/modalidade - Chave Secundria';

comment on column TB_PARAMETRIZACAO_BOLSA.CO_PROCEDIMENTO is
'Cdigo seqencial da TB_PROCEDIMENTO - Chave primria';

comment on column TB_PARAMETRIZACAO_BOLSA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PARAMETRIZACAO_BOLSA.QT_FISICO_PRODUCAO is
'Quantidade de procedimentos realizados para bolsas';

comment on column TB_PARAMETRIZACAO_BOLSA.VL_MEDIO_PRODUCAO is
'Valor mdio de produo para bolsas';

comment on column TB_PARAMETRIZACAO_BOLSA.QT_FISICO_PROPOSTO is
'Quantidade de procedimentos propostos para bolsas';

comment on column TB_PARAMETRIZACAO_BOLSA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PARAMETRIZACAO_BOLSA.VL_SA is
'Valor mdio proposto para bolsas';

/*==============================================================*/
/* Table: TB_PARAMETRO_AGREGADO                                 */
/*==============================================================*/
create table TB_PARAMETRO_AGREGADO (
   CO_AGREGADO          NUMERIC(28)          null,
   NU_PERCAPTO_AGREGADO NUMERIC(14,10)       null,
   QT_FISICO_AGREGADO   NUMERIC(12)          null,
   NU_PERCAPTO_ESTRATEGICA NUMERIC(14,10)       null,
   QT_FISICO_ESTRATEGICA NUMERIC(12)          null,
   QT_FISICA_PRODUCAO   NUMERIC(12)          null,
   VL_FINANCEIRO_PRODUCAO NUMERIC(14,2)        null,
   CO_PROCEDIMENTO_NAO_SUS NUMERIC(28)          null,
   TP_PARAMETRIZADO     VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          null,
   ST_CARGA_ABRANGENCIA VARCHAR(1)           null,
   TP_ABRANGENCIA       VARCHAR(1)           null,
   VL_MEDIO             NUMERIC(14,6)        null,
   CO_IDENTIFICADOR     VARCHAR(13)          null
);

comment on table TB_PARAMETRO_AGREGADO is
'Tabela de procedimentos ambulatoriais agregados.';

comment on column TB_PARAMETRO_AGREGADO.CO_AGREGADO is
'Cdigo do agregado onde os procedimentos sero agregados.';

comment on column TB_PARAMETRO_AGREGADO.NU_PERCAPTO_AGREGADO is
'Quantidade per capta para cada agregado.';

comment on column TB_PARAMETRO_AGREGADO.QT_FISICO_AGREGADO is
'Quantidade da produo para cada agregado.';

comment on column TB_PARAMETRO_AGREGADO.NU_PERCAPTO_ESTRATEGICA is
'Quantidade per capta para cada rea estratgica.';

comment on column TB_PARAMETRO_AGREGADO.QT_FISICO_ESTRATEGICA is
'Quantidade de produo para cada rea estratgica.';

comment on column TB_PARAMETRO_AGREGADO.QT_FISICA_PRODUCAO is
'Quantidade de atendimentos realizados para a populao.';

comment on column TB_PARAMETRO_AGREGADO.VL_FINANCEIRO_PRODUCAO is
'Valor financeiro gasto com os atendimentos realizados para a populao.';

comment on column TB_PARAMETRO_AGREGADO.CO_PROCEDIMENTO_NAO_SUS is
'Cdigo de parametrizao de um procedimento no-SUS.';

comment on column TB_PARAMETRO_AGREGADO.TP_PARAMETRIZADO is
'Se o registro  do tipo agregado ou procedimento no-SUS. ''0'' - agregado, ''1'' - procedimento no-SUS';

comment on column TB_PARAMETRO_AGREGADO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PARAMETRO_AGREGADO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PARAMETRO_AGREGADO.ST_CARGA_ABRANGENCIA is
'Verifica se foi realizada a carga para a abrangencia dos agregados.(S- Sim , N- No) S - com carga, N - sem carga';

comment on column TB_PARAMETRO_AGREGADO.TP_ABRANGENCIA is
'Define o tipo de abrangncia:
(1 - abrangncia Per Capita,
 2 - abrangncia com distribuio programvel
 3 - abrangncia sem distribuio automtica)';

comment on column TB_PARAMETRO_AGREGADO.VL_MEDIO is
' o valor mdio gasto com um grupo de procedimentos (agregado).
 No primeiro momento ele vai ser igual ao valor mdio de produo.
 E depois pode ser alterado.';

comment on column TB_PARAMETRO_AGREGADO.CO_IDENTIFICADOR is
'Cdigo que indica o nvel em que o procedimento foi agregado.';

/*==============================================================*/
/* Index: IN_PARAMAGRE_COIDENTCOPPI                             */
/*==============================================================*/
create  index IN_PARAMAGRE_COIDENTCOPPI on TB_PARAMETRO_AGREGADO (
CO_IDENTIFICADOR,
CO_PPI
);

/*==============================================================*/
/* Index: IN_PARAMAGREG_COAGREGIDENTPPI                         */
/*==============================================================*/
create  index IN_PARAMAGREG_COAGREGIDENTPPI on TB_PARAMETRO_AGREGADO (
CO_AGREGADO,
CO_IDENTIFICADOR,
CO_PPI
);

/*==============================================================*/
/* Index: IN_PARAMAGREG_COIDENTIFICA                            */
/*==============================================================*/
create  index IN_PARAMAGREG_COIDENTIFICA on TB_PARAMETRO_AGREGADO (
(substr(co_identificador, 5,6))
);

/*==============================================================*/
/* Index: IN_PARAMAGREG_COPRNASUCOIDCOPP                        */
/*==============================================================*/
create  index IN_PARAMAGREG_COPRNASUCOIDCOPP on TB_PARAMETRO_AGREGADO (
CO_PROCEDIMENTO_NAO_SUS,
CO_IDENTIFICADOR,
CO_PPI
);

/*==============================================================*/
/* Table: TB_PARAM_CARDAPIO                                     */
/*==============================================================*/
create table TB_PARAM_CARDAPIO (
   CO_PPI               NUMERIC(28)          not null,
   DT_COMP_INICIAL_FIS_AMB VARCHAR(6)           null,
   DT_COMP_FINAL_FIS_AMB VARCHAR(6)           null,
   DT_COMP_INICIAL_FIS_HOSP VARCHAR(6)           null,
   DT_COMP_FINAL_FIS_HOSP VARCHAR(6)           null,
   NU_ANO_POPULACAO     VARCHAR(4)           null,
   DT_PROCESSAMENTO     DATE                 null,
   ST_REALIZADO         VARCHAR(1)           null,
   DT_COMP_PROC_UNIFICADO VARCHAR(6)           null,
   DT_COMP_INICIAL_FINANC_HOSP VARCHAR(6)           null,
   DT_COMP_FINAL_FINANC_HOSP VARCHAR(6)           null,
   constraint PK_PARAM_CARDAPIO primary key (CO_PPI)
);

comment on table TB_PARAM_CARDAPIO is
'Tabela de parmetros escolhidos pelos gestores estaduais.';

comment on column TB_PARAM_CARDAPIO.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_PARAM_CARDAPIO.DT_COMP_INICIAL_FIS_AMB is
'Data inicial da produo fsico-ambulatorial no formato ANO/MS (200601).';

comment on column TB_PARAM_CARDAPIO.DT_COMP_FINAL_FIS_AMB is
'Data final da produo fsicoambulatorial no formato ANO/MS (200601).';

comment on column TB_PARAM_CARDAPIO.DT_COMP_INICIAL_FIS_HOSP is
'Data inicial da produo fsico-hospitalar no formato ANO/MS (200601).';

comment on column TB_PARAM_CARDAPIO.DT_COMP_FINAL_FIS_HOSP is
'Data final da produo fsico-hospitalar no formato ANO/MS (200601).';

comment on column TB_PARAM_CARDAPIO.NU_ANO_POPULACAO is
'Ano da populao selecionada 1.';

comment on column TB_PARAM_CARDAPIO.DT_PROCESSAMENTO is
'Data do agendamento para o processamento da rotina';

comment on column TB_PARAM_CARDAPIO.ST_REALIZADO is
'Status de realizao da configurao do cardpio. 0 - No Realizado 1 - Realizado.';

comment on column TB_PARAM_CARDAPIO.DT_COMP_PROC_UNIFICADO is
'Data da competncia vigente da Tabela de Procedimentos Unificada';

comment on column TB_PARAM_CARDAPIO.DT_COMP_INICIAL_FINANC_HOSP is
'Data inicial da produo financeiro-hospitalar, no formato ANO/MS (200601), para calcular o valor mdio';

comment on column TB_PARAM_CARDAPIO.DT_COMP_FINAL_FINANC_HOSP is
'Data final da produo financeiro-hospitalar, no formato ANO/MS (200601), para calcular o valor mdio';

/*==============================================================*/
/* Table: TB_PARAM_PRODUCAO_ANALISADA                           */
/*==============================================================*/
create table TB_PARAM_PRODUCAO_ANALISADA (
   DT_PROCESSAMENTO     DATE                 null,
   DT_COMPETENCIA       DATE                 null,
   SG_UF                VARCHAR(2)           null,
   ST_DESCARTE          VARCHAR(1)           null,
   ST_REALIZADO         VARCHAR(1)           null,
   TP_PRODUCAO          VARCHAR(1)           null
);

comment on table TB_PARAM_PRODUCAO_ANALISADA is
'Tabela de agendamento do processamento da anlise feita pelo federal para posterior gerao das bases de produo definitivas.';

comment on column TB_PARAM_PRODUCAO_ANALISADA.DT_PROCESSAMENTO is
'Data do agendamento para o processamento da rotina de gerao das bases de produo.';

comment on column TB_PARAM_PRODUCAO_ANALISADA.DT_COMPETENCIA is
'Data da competncia de produo analisada a ser descartada ou no.';

comment on column TB_PARAM_PRODUCAO_ANALISADA.SG_UF is
'Estado/UF em que ser realizado o processamento.';

comment on column TB_PARAM_PRODUCAO_ANALISADA.ST_DESCARTE is
'Status que indica se a competncia vai ser descartada ou no: S - Sim, N - No';

comment on column TB_PARAM_PRODUCAO_ANALISADA.ST_REALIZADO is
'Status de realizao da importao dos dados de produo: S- Sim N- No';

comment on column TB_PARAM_PRODUCAO_ANALISADA.TP_PRODUCAO is
'Tipo da produo: H - HOSPITALAR, A - AMBULATORIAL';

/*==============================================================*/
/* Table: TB_PERFIL_SISPPI                                      */
/*==============================================================*/
create table TB_PERFIL_SISPPI (
   CO_USUARIO           NUMERIC(8)           not null,
   ST_AREAESTRATEGICA   VARCHAR(1)           null,
   ST_AGREGADO          VARCHAR(1)           null,
   ST_HOSPITALAR        VARCHAR(1)           null,
   ST_ABRANGENCIAHOSPITALAR VARCHAR(1)           null,
   ST_AMBULATORIAL      VARCHAR(1)           null,
   ST_ABRANGENCIAAMBULATORIAL VARCHAR(1)           null,
   ST_CONSULTA          VARCHAR(1)           null,
   constraint PK_PERFIL_SISPPI primary key (CO_USUARIO)
);

comment on table TB_PERFIL_SISPPI is
'Tabela para armazenamento dos perfis de acesso dos usurios do SISPPI.';

comment on column TB_PERFIL_SISPPI.CO_USUARIO is
'Cdigo do usurio';

comment on column TB_PERFIL_SISPPI.ST_AREAESTRATEGICA is
'Status que indica se o usurio vai ter acesso ao menu das reas Estratgicas: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_AGREGADO is
'Status que indica se o usurio vai ter acesso ao menu dos Agregados: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_HOSPITALAR is
'Status que indica se o usurio vai ter acesso ao menu das reas Hospitalares: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_ABRANGENCIAHOSPITALAR is
'Status que indica se o usurio vai ter acesso ao menu da Abrangncia Hospitalar: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_AMBULATORIAL is
'Status que indica se o usurio vai ter acesso ao menu Ambulatorial: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_ABRANGENCIAAMBULATORIAL is
'Status que indica se o usurio vai ter acesso ao menu da Abrangncia Ambulatorial: S - sim, N - no';

comment on column TB_PERFIL_SISPPI.ST_CONSULTA is
'Status que indica se o usurio vai ter acesso ao menu de Consulta: S - sim, N - no';

/*==============================================================*/
/* Table: TB_POPULACAO_ABRANGENCIA                              */
/*==============================================================*/
create table TB_POPULACAO_ABRANGENCIA (
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   NU_ANO               NUMERIC(4)           not null,
   QT_POPULACAO         NUMERIC(10)          null,
   constraint PK_POPULACAO_ABRANGENCIA primary key (CO_MUNICIPIO_IBGE, NU_ANO)
);

comment on table TB_POPULACAO_ABRANGENCIA is
'Populao do Brasil, gerada a partir da tabela do TCU e do IBGE';

comment on column TB_POPULACAO_ABRANGENCIA.CO_MUNICIPIO_IBGE is
'Cdigo IBGE do Municpio';

comment on column TB_POPULACAO_ABRANGENCIA.NU_ANO is
'Ano de pesquisa da populao estimada oficial informada pelo TCU.';

comment on column TB_POPULACAO_ABRANGENCIA.QT_POPULACAO is
'Quantidade da populao informada pelo TCU';

/*==============================================================*/
/* Table: TB_POPULACAO_ADICIONAL                                */
/*==============================================================*/
create table TB_POPULACAO_ADICIONAL (
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   TP_SEXO              VARCHAR(1)           not null,
   DS_FAIXA_ETARIA      VARCHAR(4)           not null,
   QT_POPULACAO_ADICIONAL NUMERIC(10)          null,
   constraint PK_POPULACAO_ADICIONAL primary key (CO_MUNICIPIO_IBGE, TP_SEXO, DS_FAIXA_ETARIA)
);

comment on table TB_POPULACAO_ADICIONAL is
'Tabela de populao adicional, em que o gestor estadual adicionar uma quantidade de populao para o municpio';

comment on column TB_POPULACAO_ADICIONAL.CO_MUNICIPIO_IBGE is
'Cdigo IBGE do Municpio';

comment on column TB_POPULACAO_ADICIONAL.TP_SEXO is
'Tipo do sexo - masculino/feminino(M ou F)';

comment on column TB_POPULACAO_ADICIONAL.DS_FAIXA_ETARIA is
'Descrio da faixa etria da populao.';

comment on column TB_POPULACAO_ADICIONAL.QT_POPULACAO_ADICIONAL is
'Quantidade da populao adicional informada pelo gestor estadual/municipal';

/*==============================================================*/
/* Table: TB_POPULACAO_CALCULADA                                */
/*==============================================================*/
create table TB_POPULACAO_CALCULADA (
   CO_SEQ_POPULACAO_CALCULADA NUMERIC(8)           not null,
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   NU_ANO               NUMERIC(4)           not null,
   TP_SEXO              VARCHAR(1)           not null,
   DS_FAIXA_ETARIA      VARCHAR(4)           not null,
   QT_POPULACAO         NUMERIC(10)          null,
   constraint PK_POPULACAO_CALCULADA primary key (CO_SEQ_POPULACAO_CALCULADA)
);

comment on table TB_POPULACAO_CALCULADA is
'Populao gerada a partir da tabela do TCU e IBGE com faixa etria e sexo';

comment on column TB_POPULACAO_CALCULADA.CO_SEQ_POPULACAO_CALCULADA is
'Cdigo seqencial da populao calculada atravs das TB_POPULACAO_HOMOLOGADA e TB_IBGE';

comment on column TB_POPULACAO_CALCULADA.CO_MUNICIPIO_IBGE is
'Cdigo(IBGE) da tabela TB_MUNICIPIO - Chave primria';

comment on column TB_POPULACAO_CALCULADA.NU_ANO is
'Ano de pesquisa da populao estimada oficial informada pelo TCU.';

comment on column TB_POPULACAO_CALCULADA.TP_SEXO is
'Tipo do sexo - masculino/feminino(M ou F)';

comment on column TB_POPULACAO_CALCULADA.DS_FAIXA_ETARIA is
'Descrio da faixa etria da populao.';

comment on column TB_POPULACAO_CALCULADA.QT_POPULACAO is
'Quantidade da populao informada pelo TCU';

/*==============================================================*/
/* Table: TB_POPULACAO_HOMOLOGADA                               */
/*==============================================================*/
create table TB_POPULACAO_HOMOLOGADA (
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   QT_POPULACAO         NUMERIC(8)           not null,
   NU_ANO               NUMERIC(4)           not null,
   constraint PK_POPULACAO_HOMOLOGADA primary key (CO_MUNICIPIO_IBGE, QT_POPULACAO, NU_ANO)
);

comment on table TB_POPULACAO_HOMOLOGADA is
'Tabela contendo a populao estimada pelo IBGE, com os valores homologados pelo TCU e mantida pelo DERAC.';

comment on column TB_POPULACAO_HOMOLOGADA.CO_MUNICIPIO_IBGE is
'Cdigo nico do IBGE que identifica um municpio brasileiro - Chave primria';

comment on column TB_POPULACAO_HOMOLOGADA.QT_POPULACAO is
'Quantidade de populao estimada oficial informada pelo TCU';

comment on column TB_POPULACAO_HOMOLOGADA.NU_ANO is
'Ano da populao estimada oficial informada pelo TCU';

/*==============================================================*/
/* Table: TB_POPULACAO_MDA                                      */
/*==============================================================*/
create table TB_POPULACAO_MDA (
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   QT_POPULACAO_MDA     NUMERIC(10)          null,
   constraint PK_POPULACAO_MDA primary key (CO_MUNICIPIO_IBGE)
);

comment on table TB_POPULACAO_MDA is
'Contm a populao levantada pelo Ministrio do Desenvolvimento Agrrio';

comment on column TB_POPULACAO_MDA.CO_MUNICIPIO_IBGE is
'Cdigo IBGE do Municpio';

comment on column TB_POPULACAO_MDA.QT_POPULACAO_MDA is
'Quantidade da populao do municpio - levantamento feito pelo Ministrio do Desenvolvimento Agrrio';

/*==============================================================*/
/* Table: TB_PPI                                                */
/*==============================================================*/
create table TB_PPI (
   CO_SEQ_PPI           NUMERIC(28)          not null,
   DS_PPI               VARCHAR(150)         null,
   ST_PPI               VARCHAR(1)           null,
   DT_PPI_CADASTRO      DATE                 null,
   constraint PK_PPI primary key (CO_SEQ_PPI)
);

comment on table TB_PPI is
'Tabela de PPI - Pactuao Programada Integrada.
A PPI  uma viso e simulao de como o Brasil est realizando e demandando suas produes hospitalares e ambulatoriais. 
A PPI, para se realizar completamente, ter que passar por todas as esferas (Federal, Regional, Estadual, Municipal e Distrital),
com o objetivo de se ter uma viso ampla das produes do Brasil. De acordo com essas informaes,  que ser programada 
a previso para o ano prximo, para justificar verbas e ateno do governo federal.';

comment on column TB_PPI.CO_SEQ_PPI is
'Cdigo da PPI principal';

comment on column TB_PPI.DS_PPI is
'Nome da PPI principal';

comment on column TB_PPI.ST_PPI is
'Status da PPI principal: A - ABERTO, P - PUBLICADO, D - DESCARTADO';

comment on column TB_PPI.DT_PPI_CADASTRO is
'Data de incio no formato ANO/MS (200601) da PPI principal.';

/*==============================================================*/
/* Table: TB_PPI_COMPETENCIA                                    */
/*==============================================================*/
create table TB_PPI_COMPETENCIA (
   CO_SEQ_PPI_COMPETENCIA NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          not null,
   DT_COMPETENCIA_PPI   VARCHAR(6)           not null,
   constraint PK_PPI_COMPETENCIA primary key (CO_SEQ_PPI_COMPETENCIA)
);

comment on table TB_PPI_COMPETENCIA is
'Tabela de ompetncias de uma PPI.';

comment on column TB_PPI_COMPETENCIA.CO_SEQ_PPI_COMPETENCIA is
'Cdigo da campetncia da PPI principal';

comment on column TB_PPI_COMPETENCIA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PPI_COMPETENCIA.DT_COMPETENCIA_PPI is
'Data no formato ANO/MS (200601) que identificar as diversas competncias da PPI principal';

/*==============================================================*/
/* Table: TB_PPI_INTERESTADUAL                                  */
/*==============================================================*/
create table TB_PPI_INTERESTADUAL (
   CO_MUNICIPIO_IBGE    VARCHAR(6)           not null,
   CO_PPI               NUMERIC(28)          not null,
   CO_UF_IBGE           VARCHAR(2)           not null,
   constraint PK_PPIINTERESTADUAL primary key (CO_UF_IBGE, CO_PPI, CO_MUNICIPIO_IBGE)
);

comment on table TB_PPI_INTERESTADUAL is
'Tabela que vai conter os municpios para programao da PPI Insterestatual';

comment on column TB_PPI_INTERESTADUAL.CO_MUNICIPIO_IBGE is
'Cdigo do municpio IBGE';

comment on column TB_PPI_INTERESTADUAL.CO_PPI is
'Cdigo da PPI. PPI - Programa de Pactuao Integrada.';

comment on column TB_PPI_INTERESTADUAL.CO_UF_IBGE is
'Cdigo da UF';

/*==============================================================*/
/* Table: TB_PPI_INTERESTADUAL_CONFIG                           */
/*==============================================================*/
create table TB_PPI_INTERESTADUAL_CONFIG (
   CO_PPI               NUMERIC(28)          not null,
   DT_GERACAO           DATE                 not null,
   ST_REALIZADO         VARCHAR(1)           null,
   DS_PPI_INTERESTADUAL VARCHAR(150)         null,
   constraint PK_PPIINTERESTADUALCONFIG primary key (CO_PPI, DT_GERACAO)
);

comment on table TB_PPI_INTERESTADUAL_CONFIG is
'Tabela que vai conter a configurao das PPIs Insterestatuais';

comment on column TB_PPI_INTERESTADUAL_CONFIG.CO_PPI is
'Cdigo da PPI. PPI - Programa de Pactuao Integrada.';

comment on column TB_PPI_INTERESTADUAL_CONFIG.DT_GERACAO is
'Data e Hora da gerao da PPI Interestadual';

comment on column TB_PPI_INTERESTADUAL_CONFIG.ST_REALIZADO is
'Status de realizao da configurao da PPI Interestadual. 0 - No Realizado 1 - Realizado.';

comment on column TB_PPI_INTERESTADUAL_CONFIG.DS_PPI_INTERESTADUAL is
'Descrio da PPI Interestadual';

/*==============================================================*/
/* Table: TB_PROCEDIMENTO_NAO_SUS                               */
/*==============================================================*/
create table TB_PROCEDIMENTO_NAO_SUS (
   CO_SEQ_PROCEDIMENTO_NAO_SUS NUMERIC(28)          not null,
   NO_PROCEDIMENTO      VARCHAR(150)         null,
   VL_PROCEDIMENTO      NUMERIC(12,2)        null,
   CO_PPI               NUMERIC(28)          null,
   constraint PK_PROCEDIMENTO_NAO_SUS primary key (CO_SEQ_PROCEDIMENTO_NAO_SUS)
);

comment on table TB_PROCEDIMENTO_NAO_SUS is
'Tabela de procedimentos prprios da PPI, no contidos na tabela de procedimentos do SUS.';

comment on column TB_PROCEDIMENTO_NAO_SUS.CO_SEQ_PROCEDIMENTO_NAO_SUS is
'Cdigo do Procedimento no-SUS - Chave primria';

comment on column TB_PROCEDIMENTO_NAO_SUS.NO_PROCEDIMENTO is
'Nome do procedimento';

comment on column TB_PROCEDIMENTO_NAO_SUS.VL_PROCEDIMENTO is
'Valor do procedimento SIA';

comment on column TB_PROCEDIMENTO_NAO_SUS.CO_PPI is
'Cdigo da PPI principal';

/*==============================================================*/
/* Table: TB_PROCEDIMENTO_SIH_DEPARA                            */
/*==============================================================*/
create table TB_PROCEDIMENTO_SIH_DEPARA (
   CO_PROCEDIMENTO      VARCHAR(8)           not null,
   CO_COMPLEXIDADE      NUMERIC(8)           not null,
   CO_FORMA_FINAN       NUMERIC(8)           not null,
   NO_PROCEDIMENTO      VARCHAR(150)         null,
   VL_PROCEDIMENTO      NUMERIC(10,2)        null,
   constraint PK_PROCEDIMENTOSIHDEPARA primary key (CO_PROCEDIMENTO, CO_COMPLEXIDADE, CO_FORMA_FINAN)
);

comment on table TB_PROCEDIMENTO_SIH_DEPARA is
'Tabela que contm os procedimentos hospitalares antigos com 8 digitos.
Servir como tabela de apoio para os procedimentos que no tiverem DE_PARA (excludos)';

comment on column TB_PROCEDIMENTO_SIH_DEPARA.CO_PROCEDIMENTO is
'Cdigo do Procedimento Hospitalar';

comment on column TB_PROCEDIMENTO_SIH_DEPARA.CO_COMPLEXIDADE is
'Cdigo da complexidade de um procedimento. Chave estrangeira em DBSISPPI.TB_COMPLEXIDADE_DEPARA.';

comment on column TB_PROCEDIMENTO_SIH_DEPARA.CO_FORMA_FINAN is
'Forma de financimaneto de um procedimento. Chave estrangeira em DBSISPPI.TB_FORMA_FINANCIAMENTO_DEPARA';

comment on column TB_PROCEDIMENTO_SIH_DEPARA.NO_PROCEDIMENTO is
'Nome do procedimento';

comment on column TB_PROCEDIMENTO_SIH_DEPARA.VL_PROCEDIMENTO is
'Valor do procedimento hospitalar';

/*==============================================================*/
/* Table: TB_PROCEDIMENTO_TRS                                   */
/*==============================================================*/
create table TB_PROCEDIMENTO_TRS (
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_PPI               NUMERIC(28)          not null,
   DS_CONCENTRACAO      VARCHAR(500)         null,
   NU_CONCENTRACAO      NUMERIC(10,2)        null,
   ST_RDC               VARCHAR(1)           null,
   constraint PK_PROCEDIMENTO_TRS primary key (CO_PROCEDIMENTO, CO_PPI)
);

comment on table TB_PROCEDIMENTO_TRS is
'Procedimentos especficos da TRS.';

comment on column TB_PROCEDIMENTO_TRS.CO_PROCEDIMENTO is
'Cdigo do Procedimento - Chave primria';

comment on column TB_PROCEDIMENTO_TRS.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PROCEDIMENTO_TRS.DS_CONCENTRACAO is
'Descrio da concentrao do procedimento TRS';

comment on column TB_PROCEDIMENTO_TRS.NU_CONCENTRACAO is
'Quantidade da concentrao da TRS';

comment on column TB_PROCEDIMENTO_TRS.ST_RDC is
'Status que indica se ser uma RDC: Sim - no pode deletar, No - pode deletar';

/*==============================================================*/
/* Table: TB_PROC_EXCLUIDO_SIH_DEPARA                           */
/*==============================================================*/
create table TB_PROC_EXCLUIDO_SIH_DEPARA (
   CO_PROCEDIMENTO      VARCHAR(8)           not null,
   CO_COMPLEXIDADE      NUMERIC(8)           null,
   CO_FORMA_FINAN       NUMERIC(8)           null,
   CO_ESPECIALIDADE_RD  VARCHAR(2)           null,
   DT_COMPETENCIA       VARCHAR(6)           null,
   NU_AIH               VARCHAR(13)          null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(14,2)        null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(8)           null,
   NU_IDADE             NUMERIC(8)           null
);

comment on table TB_PROC_EXCLUIDO_SIH_DEPARA is
'Tabela que contm os procedimentos hospitalares antigos que foram excludos da nova tabela unificada e consequentemente no possuem DEPARA. Servir como tabela de apoio para os procedimentos que no tiverem DE_PARA (excludos)';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_PROCEDIMENTO is
'Cdigo do Procedimento Hospitalar';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_COMPLEXIDADE is
'Cdigo da complexidade de um procedimento';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_FORMA_FINAN is
'Forma de financimaneto de um procedimento';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_ESPECIALIDADE_RD is
'Cdigo da especialidade de um procedimento hospitalar , recuperado a partir do arquivo fsico RD.DBF';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.DT_COMPETENCIA is
'Data em que foi realizada a produo SIH';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.NU_AIH is
'Nmero do atendimento da internao hospitalar.';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_MUNICIPIO_IBGE_MOV is
'Cdigo do Municpio. Municpio que executou o procedimento.';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.CO_MUNICIPIO_IBGE_RES is
'Cdigo do Municpio. Municpio que encaminhou o procedimento para ser executado em outro Municpio.';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.VL_PROCEDIMENTO_APROVADO is
'Valor dos procedimentos aprovados.';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados.';

comment on column TB_PROC_EXCLUIDO_SIH_DEPARA.NU_IDADE is
'Idade do internado';

/*==============================================================*/
/* Table: TB_PRODUCAO_ONCOLOGIA                                 */
/*==============================================================*/
create table TB_PRODUCAO_ONCOLOGIA (
   CO_PPI               NUMERIC(28)          null,
   DT_COMPETENCIA       VARCHAR(6)           not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_OCUPACAO          VARCHAR(6)           null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           not null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           not null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(14,2)        null
);

comment on table TB_PRODUCAO_ONCOLOGIA is
'Tabela que vai armazenar a produo de Oncologia. Esses dados vem de dois arquivos TA e PR.';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_PPI is
'Cdigo da PPI principal.';

comment on column TB_PRODUCAO_ONCOLOGIA.DT_COMPETENCIA is
'Data da competncia do procedimento';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_PROCEDIMENTO is
'Cdigo do Procedimento da Tabela de Procedimento (dbTabUnificada).';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_OCUPACAO is
'Cdigo que identifica a classificao das ocupaes definidas pela CBO-2002';

comment on column TB_PRODUCAO_ONCOLOGIA.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos SIA';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_MUNICIPIO_IBGE_MOV is
'Cdigo seqencial da tabela de TB_MUNICIPIO (dbGeral).';

comment on column TB_PRODUCAO_ONCOLOGIA.CO_MUNICIPIO_IBGE_RES is
'Cdigo seqencial da tabela de TB_MUNICIPIO (dbGeral).';

comment on column TB_PRODUCAO_ONCOLOGIA.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados.';

comment on column TB_PRODUCAO_ONCOLOGIA.VL_PROCEDIMENTO_APROVADO is
'Valor dos procedimentos aprovados.';

/*==============================================================*/
/* Table: TB_PRODUCAO_SIA                                       */
/*==============================================================*/
create table TB_PRODUCAO_SIA (
   CO_PPI               NUMERIC(28)          not null,
   NU_APAC              VARCHAR(13)          null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_MODALIDADE        VARCHAR(2)           null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_OCUPACAO          VARCHAR(6)           null,
   CO_CNES              VARCHAR(7)           null,
   CO_MUNICIPIO_IBGE_GESTOR VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   ST_CNRAC             VARCHAR(1)           null,
   ST_CIRURGIA_ELETIVA  VARCHAR(1)           null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   QT_PROCEDIMENTO_APRESENTADA NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APRESENTADA NUMERIC(10,2)        null,
   DT_COMPETENCIA       VARCHAR(6)           null,
   NU_IDADE             NUMERIC(8)           null,
   TP_SEXO              VARCHAR(1)           null,
   CO_CID_PRIMARIO      VARCHAR(4)           null,
   CO_CID_SECUNDARIO    VARCHAR(4)           null,
   CO_SUBTIPO_FAEC      VARCHAR(2)           null,
   TP_REGISTRO          VARCHAR(1)           null,
   DT_REFERENCIA        VARCHAR(6)           null,
   QT_CAMPO_IRRADIADO   NUMERIC(10,2)        null
);

comment on table TB_PRODUCAO_SIA is
'Tabela que contm toda a produo ambulatorial.';

comment on column TB_PRODUCAO_SIA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PRODUCAO_SIA.NU_APAC is
'Nmero da APAC';

comment on column TB_PRODUCAO_SIA.CO_PROCEDIMENTO is
'Cdigo do procedimento - Chave primria';

comment on column TB_PRODUCAO_SIA.CO_MODALIDADE is
'Cdigo que identifica as modalidades de atendimento.';

comment on column TB_PRODUCAO_SIA.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos SIA';

comment on column TB_PRODUCAO_SIA.CO_OCUPACAO is
'Cdigo que identifica a classificao das ocupaes definidas pela CBO-2002';

comment on column TB_PRODUCAO_SIA.CO_CNES is
'Cdigo do estabelecimento de sade que realizou o atendimento hospitalar. Cdigo CNES';

comment on column TB_PRODUCAO_SIA.CO_MUNICIPIO_IBGE_GESTOR is
'Cdigo IBGE do municpio Gestor.';

comment on column TB_PRODUCAO_SIA.CO_MUNICIPIO_IBGE_RES is
'Cdigo IBGE do municpio.';

comment on column TB_PRODUCAO_SIA.CO_MUNICIPIO_IBGE_MOV is
'Cdigo IBGE do municpio.';

comment on column TB_PRODUCAO_SIA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PRODUCAO_SIA.ST_CNRAC is
'Status que indica se  CNRAC: S - sim, N - no';

comment on column TB_PRODUCAO_SIA.ST_CIRURGIA_ELETIVA is
'Status que indica se  cirurgia eletiva: S - sim, N - no';

comment on column TB_PRODUCAO_SIA.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados';

comment on column TB_PRODUCAO_SIA.VL_PROCEDIMENTO_APROVADO is
'Valor do procedimento aprovado pelo SUS';

comment on column TB_PRODUCAO_SIA.QT_PROCEDIMENTO_APRESENTADA is
'Quantidade de vezes que foi realizado um determinado procedimento';

comment on column TB_PRODUCAO_SIA.VL_PROCEDIMENTO_APRESENTADA is
'Valor do procedimento apresentado pelo SUS';

comment on column TB_PRODUCAO_SIA.DT_COMPETENCIA is
'Data da competncia do procedimento SIA';

comment on column TB_PRODUCAO_SIA.NU_IDADE is
'Idade do internado';

comment on column TB_PRODUCAO_SIA.TP_SEXO is
'Tipo do sexo: M - Masculino, F - Feminino.';

comment on column TB_PRODUCAO_SIA.CO_CID_PRIMARIO is
'Cdigo que identifica o CID-10.';

comment on column TB_PRODUCAO_SIA.CO_CID_SECUNDARIO is
'Cdigo que identifica o CID-10.';

comment on column TB_PRODUCAO_SIA.CO_SUBTIPO_FAEC is
'Cdigo do subtipo da forma de financiamnto FAEC';

comment on column TB_PRODUCAO_SIA.TP_REGISTRO is
'Tipo do registro: A - APAC, B - BPA';

comment on column TB_PRODUCAO_SIA.DT_REFERENCIA is
'Data da produo ambulatorial. Refere-se  data em que foi realizado o procedimento referente  mesma APAC, sendo anterior  data de apresentao';

comment on column TB_PRODUCAO_SIA.QT_CAMPO_IRRADIADO is
'Quantidade Irradiados - produo de radioterapia';

/*==============================================================*/
/* Index: IN_PRODUCAOSIA_PROCDATAPAC                            */
/*==============================================================*/
create  index IN_PRODUCAOSIA_PROCDATAPAC on TB_PRODUCAO_SIA (
CO_PROCEDIMENTO,
DT_COMPETENCIA,
NU_APAC
);

/*==============================================================*/
/* Table: TB_PRODUCAO_SIH                                       */
/*==============================================================*/
create table TB_PRODUCAO_SIH (
   CO_PPI               NUMERIC(28)          not null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_MODALIDADE        VARCHAR(2)           null,
   TP_COMPLEXIDADE      VARCHAR(1)           null,
   CO_OCUPACAO          VARCHAR(6)           null,
   ST_CNRAC             VARCHAR(1)           null,
   ST_CIRURGIA_ELETIVA  VARCHAR(1)           null,
   CO_CNES              VARCHAR(7)           null,
   QT_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   VL_PROCEDIMENTO_APROVADO NUMERIC(10,2)        null,
   CO_MUNICIPIO_IBGE_GESTOR VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           null,
   CO_FINANCIAMENTO     VARCHAR(2)           null,
   NU_IDADE             NUMERIC(8)           null,
   TP_SEXO              VARCHAR(1)           null,
   CO_CID_PRIMARIO      VARCHAR(4)           null,
   CO_CID_SECUNDARIO    VARCHAR(4)           null,
   QT_DIA_PERMANENCIA   NUMERIC(8)           null,
   QT_DIA_PERMANENCIA_UCI NUMERIC(8)           null,
   QT_DIA_PERMANENCIA_UTI NUMERIC(8)           null,
   DT_ENTRADA_INTERNACAO VARCHAR(8)           null,
   DT_SAIDA_INTERNACAO  VARCHAR(8)           null,
   NU_AIH               VARCHAR(13)          null,
   DT_COMPETENCIA       VARCHAR(6)           null,
   ST_AIH               VARCHAR(1)           null,
   CO_SUBTIPO_FAEC      VARCHAR(2)           null,
   TP_IDADE             NUMERIC(1)           null
);

comment on table TB_PRODUCAO_SIH is
'Tabela que contm toda a produo hospitalar.';

comment on column TB_PRODUCAO_SIH.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PRODUCAO_SIH.CO_PROCEDIMENTO is
'Cdigo do procedimento - Chave primria';

comment on column TB_PRODUCAO_SIH.CO_MODALIDADE is
'Cdigo que identifica as modalidades de atendimento.';

comment on column TB_PRODUCAO_SIH.TP_COMPLEXIDADE is
'Cdigo da complexidade dos procedimentos SIA';

comment on column TB_PRODUCAO_SIH.CO_OCUPACAO is
'Cdigo que identifica a classificao das ocupaes definidas pela CBO-2002';

comment on column TB_PRODUCAO_SIH.ST_CNRAC is
'Status que indica se  CNRAC: S - sim, N- no';

comment on column TB_PRODUCAO_SIH.ST_CIRURGIA_ELETIVA is
'Status se  Cirurgia Eletiva: S - sim, N- no';

comment on column TB_PRODUCAO_SIH.CO_CNES is
'Cdigo do estabelecimento de sade que realizou o atendimento hospitalar. Cdigo CNES';

comment on column TB_PRODUCAO_SIH.QT_PROCEDIMENTO_APROVADO is
'Quantidade de procedimentos aprovados';

comment on column TB_PRODUCAO_SIH.VL_PROCEDIMENTO_APROVADO is
'Valor do procedimento aprovado pelo SUS';

comment on column TB_PRODUCAO_SIH.CO_MUNICIPIO_IBGE_GESTOR is
'Cdigo IBGE do municpio';

comment on column TB_PRODUCAO_SIH.CO_MUNICIPIO_IBGE_RES is
'Cdigo IBGE do municpio';

comment on column TB_PRODUCAO_SIH.CO_MUNICIPIO_IBGE_MOV is
'Cdigo IBGE do municpio';

comment on column TB_PRODUCAO_SIH.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PRODUCAO_SIH.NU_IDADE is
'Idade do internado';

comment on column TB_PRODUCAO_SIH.TP_SEXO is
'Tipo do sexo. M - Masculino, F - Feminino.';

comment on column TB_PRODUCAO_SIH.CO_CID_PRIMARIO is
'Cdigo que identifica o CID-10.';

comment on column TB_PRODUCAO_SIH.CO_CID_SECUNDARIO is
'Cdigo que identifica o CID-10.';

comment on column TB_PRODUCAO_SIH.QT_DIA_PERMANENCIA is
'Quantidade de dias de permanncia na AIH';

comment on column TB_PRODUCAO_SIH.QT_DIA_PERMANENCIA_UCI is
'Quantidade de dias de permanncia na UCI';

comment on column TB_PRODUCAO_SIH.QT_DIA_PERMANENCIA_UTI is
'Quantidade de dias de permanncia na UTI';

comment on column TB_PRODUCAO_SIH.DT_ENTRADA_INTERNACAO is
'Data de entrada da internao hospitalar';

comment on column TB_PRODUCAO_SIH.DT_SAIDA_INTERNACAO is
'Data de sada da internao hospitalar';

comment on column TB_PRODUCAO_SIH.NU_AIH is
'Nmero do atendimento da internao hospitalar';

comment on column TB_PRODUCAO_SIH.DT_COMPETENCIA is
'Data em que foi realizada a produo SIH';

comment on column TB_PRODUCAO_SIH.ST_AIH is
'Status que indica se a produo foi rejeitada ou no';

comment on column TB_PRODUCAO_SIH.CO_SUBTIPO_FAEC is
'Cdigo do subtipo da forma de financiamnto FAEC';

comment on column TB_PRODUCAO_SIH.TP_IDADE is
'A idade do paciente  composta de 2 campos: NU_IDADE e TP_IDADE.
O TP_IDADE Indica se a idade  em dia, ms ou ano.
2 = dia
3 = ms
4 = ano
5 = 100 anos ou mais.';

/*==============================================================*/
/* Table: TB_PRODUCAO_UTI_UCI                                   */
/*==============================================================*/
create table TB_PRODUCAO_UTI_UCI (
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          not null,
   CO_MUNICIPIO_IBGE_MOV VARCHAR(6)           not null,
   CO_MUNICIPIO_IBGE_RES VARCHAR(6)           not null,
   QT_ATO_PROFISSIONAL  NUMERIC(10,2)        null,
   VL_ATO_PROFISSIONAL  NUMERIC(10,2)        null,
   CO_PROCEDIMENTO      VARCHAR(10)          not null,
   CO_TIPO_LEITO        VARCHAR(2)           null,
   DT_COMPETENCIA       VARCHAR(6)           null,
   TP_IDENTIFICADOR     VARCHAR(1)           null
);

comment on table TB_PRODUCAO_UTI_UCI is
'Contm os dados de produo de UTI e UCI de acordo com o arquivo "SP"';

comment on column TB_PRODUCAO_UTI_UCI.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PRODUCAO_UTI_UCI.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_PRODUCAO_UTI_UCI.CO_MUNICIPIO_IBGE_MOV is
'Cdigo IBGE do municpio executor.';

comment on column TB_PRODUCAO_UTI_UCI.CO_MUNICIPIO_IBGE_RES is
'Cdigo IBGE do municpio encaminhador.';

comment on column TB_PRODUCAO_UTI_UCI.QT_ATO_PROFISSIONAL is
'Quantidade de atos realizados';

comment on column TB_PRODUCAO_UTI_UCI.VL_ATO_PROFISSIONAL is
'Valor do ato profissional';

comment on column TB_PRODUCAO_UTI_UCI.CO_PROCEDIMENTO is
'Cdigo do Procedimento';

comment on column TB_PRODUCAO_UTI_UCI.CO_TIPO_LEITO is
'Cdigo do tipo de leito da tabela unificada';

comment on column TB_PRODUCAO_UTI_UCI.DT_COMPETENCIA is
'Data em que foi realizada a produo SIH';

comment on column TB_PRODUCAO_UTI_UCI.TP_IDENTIFICADOR is
'Identifica o tipo de produo:
1- UTI
2- UCI';

/*==============================================================*/
/* Table: TB_PROGRAMACAO_ACAO                                   */
/*==============================================================*/
create table TB_PROGRAMACAO_ACAO (
   CO_SEQ_PROGRAMACAO_ACAO NUMERIC(28)          not null,
   CO_ACAO              NUMERIC(28)          null,
   TX_PERCENTUAL_ACAO   NUMERIC(14,6)        null,
   QT_PROCEDIMENTO_PESSOA NUMERIC(14,10)       null,
   NU_INDICE_AGRUPAMENTO NUMERIC(10,2)        null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          null,
   constraint PK_PROGRAMACAO_ACAO primary key (CO_SEQ_PROGRAMACAO_ACAO)
);

comment on table TB_PROGRAMACAO_ACAO is
'Programao das aes em relao  configurao.';

comment on column TB_PROGRAMACAO_ACAO.CO_SEQ_PROGRAMACAO_ACAO is
'Cdigo nacional/sequence.';

comment on column TB_PROGRAMACAO_ACAO.CO_ACAO is
'Cdigo seqencial da TB_ACAO - Chave primria.';

comment on column TB_PROGRAMACAO_ACAO.TX_PERCENTUAL_ACAO is
'Percentual de aes a serem aplicadas a uma determinada populao';

comment on column TB_PROGRAMACAO_ACAO.QT_PROCEDIMENTO_PESSOA is
'Quantidade de procedimentos a serem aplicados por pessoa';

comment on column TB_PROGRAMACAO_ACAO.NU_INDICE_AGRUPAMENTO is
'Esse ndice gera um impacto no total fsico que vai ser igual ao fsico dividido pelo ndice de agrupamento.';

comment on column TB_PROGRAMACAO_ACAO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_PROGRAMACAO_ACAO.CO_PPI is
'Cdigo da PPI principal';

/*==============================================================*/
/* Index: IN_PROGRAMAACAO_COACAOCOFINAN                         */
/*==============================================================*/
create  index IN_PROGRAMAACAO_COACAOCOFINAN on TB_PROGRAMACAO_ACAO (
CO_ACAO,
CO_FINANCIAMENTO
);

/*==============================================================*/
/* Table: TB_PROGRAMACAO_POPULACAO                              */
/*==============================================================*/
create table TB_PROGRAMACAO_POPULACAO (
   CO_SEQ_PROGRAMACAO_POPULACAO NUMERIC(28)          not null,
   CO_CONFIGURACAO_POPULACAO NUMERIC(28)          null,
   QT_POPULACAO         NUMERIC(8)           null,
   TX_COBERTURA_POPULACAO NUMERIC(14,10)       null,
   QT_POPULACAO_COBERTA NUMERIC(8)           null,
   constraint PK_PROGRAMACAO_POPULACAO primary key (CO_SEQ_PROGRAMACAO_POPULACAO)
);

comment on table TB_PROGRAMACAO_POPULACAO is
'Programao da populao em relao  configurao.';

comment on column TB_PROGRAMACAO_POPULACAO.CO_SEQ_PROGRAMACAO_POPULACAO is
'Cdigo nacional/sequence.';

comment on column TB_PROGRAMACAO_POPULACAO.CO_CONFIGURACAO_POPULACAO is
'Cdigo nacional/sequence - da configurao da populao.';

comment on column TB_PROGRAMACAO_POPULACAO.QT_POPULACAO is
'Quantidade da populao.';

comment on column TB_PROGRAMACAO_POPULACAO.TX_COBERTURA_POPULACAO is
'Porcentagem de cobertura da populao';

comment on column TB_PROGRAMACAO_POPULACAO.QT_POPULACAO_COBERTA is
'Quantidade da populao coberta programada.';

/*==============================================================*/
/* Index: IN_PROGRAMACAOPOPULA_CONFIGPOP                        */
/*==============================================================*/
create  index IN_PROGRAMACAOPOPULA_CONFIGPOP on TB_PROGRAMACAO_POPULACAO (
CO_CONFIGURACAO_POPULACAO
);

/*==============================================================*/
/* Table: TB_RECURSO_ESPECIFICO                                 */
/*==============================================================*/
create table TB_RECURSO_ESPECIFICO (
   CO_SEQ_RECURSO_ESPECIFICO NUMERIC(28)          not null,
   CO_TIPO_RECURSO_ESPECIFICO NUMERIC(2)           not null,
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_PPI               NUMERIC(28)          null,
   NO_RECURSO_ESPECIFICO VARCHAR(80)          not null,
   DS_RECURSO_ESPECIFICO VARCHAR(400)         null,
   VL_RECURSO_ESPECIFICO NUMERIC(14,2)        null,
   SG_ESFERA            VARCHAR(1)           null,
   constraint PK_RECURSO_ESPECIFICO primary key (CO_SEQ_RECURSO_ESPECIFICO)
);

comment on table TB_RECURSO_ESPECIFICO is
'Esta tabela se refere  criao de recursos especficos para reserva tcnica e incentivo de uma determinada forma de financiamento. Nesta tabela, os registros ficam vinculados a uma PPI, a uma forma de financiamento e a uma esfera.';

comment on column TB_RECURSO_ESPECIFICO.CO_SEQ_RECURSO_ESPECIFICO is
'Cdigo seqencial dos recursos especficos de cada municpio';

comment on column TB_RECURSO_ESPECIFICO.CO_TIPO_RECURSO_ESPECIFICO is
'Cdigo do tipo do recurso especfico. Ex: Reserva Tcnica, Incentivos.';

comment on column TB_RECURSO_ESPECIFICO.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento';

comment on column TB_RECURSO_ESPECIFICO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_RECURSO_ESPECIFICO.NO_RECURSO_ESPECIFICO is
'Nome de um tipo de recurso especfico (Reserva Tcnica ou Incentivos).
Ex.: SAMU, INTGRASUS, FIDEPS, IAPI, IAC';

comment on column TB_RECURSO_ESPECIFICO.DS_RECURSO_ESPECIFICO is
'Descrio detalhada de um recurso especfico.';

comment on column TB_RECURSO_ESPECIFICO.VL_RECURSO_ESPECIFICO is
'Valor que pode ser gasto com um recurso especfico.';

comment on column TB_RECURSO_ESPECIFICO.SG_ESFERA is
'Esfera Federal (F), Estadual (E) ou Municipal (M) de um recurso especfico.';

/*==============================================================*/
/* Table: TB_REGIONALIZACAO                                     */
/*==============================================================*/
create table TB_REGIONALIZACAO (
   CO_SEQ_REGIONALIZACAO NUMERIC(8)           not null,
   CO_UF_IBGE           VARCHAR(2)           null,
   CO_TIPO_REGIONALIZACAO NUMERIC(8)           null,
   QT_NIVEL             NUMERIC(8)           null,
   DT_CRIACAO           DATE                 null,
   NU_NIVEL_REGIAO      NUMERIC(8)           null,
   CO_PPI               NUMERIC(28)          null,
   ST_REGIONALIZACAO    VARCHAR(1)           null,
   constraint PK_REGIONALIZACAO primary key (CO_SEQ_REGIONALIZACAO)
);

comment on table TB_REGIONALIZACAO is
'Tabela que contm a regional de um determinado estado';

comment on column TB_REGIONALIZACAO.CO_SEQ_REGIONALIZACAO is
'Cdigo seqencial da tabela TB_REGIONALIZACAO - Chave primria.';

comment on column TB_REGIONALIZACAO.CO_UF_IBGE is
'Cdigo seqencial da tabela TB_UF- Chave estrangeira.';

comment on column TB_REGIONALIZACAO.CO_TIPO_REGIONALIZACAO is
'Cdigo seqencial da tabela TB_TIPO_REGIONALIZACAO - Chave estrangeira.';

comment on column TB_REGIONALIZACAO.QT_NIVEL is
'Definio do nmero de nveis.';

comment on column TB_REGIONALIZACAO.DT_CRIACAO is
'Data de criao do registro.';

comment on column TB_REGIONALIZACAO.NU_NIVEL_REGIAO is
'Nmero do nivel onde se encontra a regio escolhida dentre as quantidades estipuladas no atributo qt_nivel.';

comment on column TB_REGIONALIZACAO.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_REGIONALIZACAO.ST_REGIONALIZACAO is
'Status da concluso da Regionalizao:
  S - SIM, N - NO';

/*==============================================================*/
/* Table: TB_RESULTADO_BANDA_PARAMETRICA                        */
/*==============================================================*/
create table TB_RESULTADO_BANDA_PARAMETRICA (
   CO_FINANCIAMENTO     VARCHAR(2)           not null,
   CO_AGREGADO          NUMERIC(28)          not null,
   CO_PPI               NUMERIC(28)          not null,
   VL_LIMITE_INFERIOR_G NUMERIC(14,12)       null,
   VL_LIMITE_INFERIOR_P NUMERIC(14,12)       null,
   VL_MEDIANA           NUMERIC(14,12)       null,
   VL_LIMITE_SUPERIOR_P NUMERIC(14,12)       null,
   VL_LIMITE_SUPERIOR_G NUMERIC(14,12)       null,
   VL_PRODUCAO          NUMERIC(8)           null,
   ST_ALERTA            VARCHAR(3)           null,
   constraint PK_RESULTADO_BANDA_PARAMETRICA primary key (CO_FINANCIAMENTO, CO_AGREGADO, CO_PPI)
);

comment on table TB_RESULTADO_BANDA_PARAMETRICA is
'Contm os dados estatsticos de produo dos estados, importados de um arquivo CSV, que  gerado pelo programa R.';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.CO_FINANCIAMENTO is
'Cdigo da forma de financiamento de um procedimento SIA ou SIH.';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.CO_AGREGADO is
'Cdigo do agregado. Procedimentos sero agregados.';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.CO_PPI is
'Cdigo da PPI principal';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_LIMITE_INFERIOR_G is
'Valor do limite inferior grande calculado pela banda paramtrica';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_LIMITE_INFERIOR_P is
'Valor do limite inferior pequeno calculado pela banda paramtrica';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_MEDIANA is
'Valor da mediana calculada pela banda paramtrica';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_LIMITE_SUPERIOR_P is
'Valor do limite superior pequeno calculado pela banda paramtrica';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_LIMITE_SUPERIOR_G is
'Valor do limite superior grande calculado pela banda paramtrica';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.VL_PRODUCAO is
'Valor de produo';

comment on column TB_RESULTADO_BANDA_PARAMETRICA.ST_ALERTA is
'Alerta se o valor est acima do limite superior grande ou abaixo do limite inferior grande. MAX - Mximo, MIN - Mnimo';

/*==============================================================*/
/* Table: TB_SERV_CLASS_PPI                                     */
/*==============================================================*/
create table TB_SERV_CLASS_PPI (
   CO_PPI               NUMERIC(28)          not null,
   CO_CLASSIFICACAO     VARCHAR(3)           not null,
   CO_SERVICO           VARCHAR(3)           not null,
   CO_HABILITACAO       VARCHAR(4)           not null,
   QT_FISICO            NUMERIC(8)           null,
   QT_FISICO_VINCULADO_SUS NUMERIC(8)           null,
   constraint PK_SERV_CLASS_PPI primary key (CO_CLASSIFICACAO, CO_SERVICO, CO_HABILITACAO, CO_PPI)
);

comment on table TB_SERV_CLASS_PPI is
'Tabela de servios e classificao provenientes do CNES.';

comment on column TB_SERV_CLASS_PPI.CO_PPI is
'Cdigo da ppi principal';

comment on column TB_SERV_CLASS_PPI.CO_CLASSIFICACAO is
'Cdigo da classificao cnes.';

comment on column TB_SERV_CLASS_PPI.CO_SERVICO is
'Cdigo do servio do estabelecimento de sade.';

comment on column TB_SERV_CLASS_PPI.CO_HABILITACAO is
'Cdigo da habilitao de um estabelecimento de sade';

comment on column TB_SERV_CLASS_PPI.QT_FISICO is
'Quantidade de servios ou habilitaes de um estabelecimento de sade';

comment on column TB_SERV_CLASS_PPI.QT_FISICO_VINCULADO_SUS is
'Quantidade de servios ou habilitaes de um estabelecimento de sade vinculado ao SUS.';

/*==============================================================*/
/* Table: TB_SUBGRUPO_HABILITACAO_PPI                           */
/*==============================================================*/
create table TB_SUBGRUPO_HABILITACAO_PPI (
   CO_CODIGO_GRUPO      VARCHAR(10)          null,
   NO_DESCRICAO_GRUPO   VARCHAR(200)         null
);

comment on table TB_SUBGRUPO_HABILITACAO_PPI is
'Tabela que contm a descrio das habilitaes dos estabelecimentos de sade';

comment on column TB_SUBGRUPO_HABILITACAO_PPI.CO_CODIGO_GRUPO is
'Cdigo da habilitao';

comment on column TB_SUBGRUPO_HABILITACAO_PPI.NO_DESCRICAO_GRUPO is
'Descrio da habilitao';

/*==============================================================*/
/* Table: TB_TIPO_ESTIMATIVA                                    */
/*==============================================================*/
create table TB_TIPO_ESTIMATIVA (
   CO_SEQ_TIPO_ESTIMATIVA NUMERIC(2)           not null,
   DS_TIPO_ESTIMATIVA   VARCHAR(150)         null,
   constraint PK_TIPO_ESTIMATIVA primary key (CO_SEQ_TIPO_ESTIMATIVA)
);

comment on table TB_TIPO_ESTIMATIVA is
'Cadastro do tipo de estimativa. Ex.:Incidncia, Prevalncia';

comment on column TB_TIPO_ESTIMATIVA.CO_SEQ_TIPO_ESTIMATIVA is
'Cdigo do tipo de estimativa de uma populao';

comment on column TB_TIPO_ESTIMATIVA.DS_TIPO_ESTIMATIVA is
'Descrio do tipo de estimativa de uma populao (Incidncia, Prevalncia, Nenhum)';

/*==============================================================*/
/* Table: TB_TIPO_POPULACAO                                     */
/*==============================================================*/
create table TB_TIPO_POPULACAO (
   CO_SEQ_TIPO_POPULACAO NUMERIC(2)           not null,
   DS_TIPO_POPULACAO    VARCHAR(150)         null,
   constraint PK_TIPO_POPULACAO primary key (CO_SEQ_TIPO_POPULACAO)
);

comment on table TB_TIPO_POPULACAO is
'Contm o tipo da populao gerada:
Fixa - Populao sem delimitao de faixa etria;
Faixa Etria - Populao com delimitao de idade;
Herdada - Informa que esta populao herdou a caracterstica de uma populao Fixa, Faixa Etria, ou uma outra que foi herdada.';

comment on column TB_TIPO_POPULACAO.CO_SEQ_TIPO_POPULACAO is
'Cdigo do tipo da populao';

comment on column TB_TIPO_POPULACAO.DS_TIPO_POPULACAO is
'Descrio do tipo de uma populao:
Fixa - Populao sem delimitao de faixa etria;
Faixa Etria - Populao com delimitao de idade;
Herdada - Informa que esta populao herdou a caracterstica de uma populao Fixa, Faixa Etria, ou uma outra que foi herdada.';

/*==============================================================*/
/* Table: TB_TIPO_RECURSO_ESPECIFICO                            */
/*==============================================================*/
create table TB_TIPO_RECURSO_ESPECIFICO (
   CO_SEQ_TIPO_RECURSO_ESPECIFICO NUMERIC(2)           not null,
   NO_TIPO_RECURSO_ESPECIFICO VARCHAR(50)          not null,
   constraint PK_TIPO_RECURSO_ESPECIFICO primary key (CO_SEQ_TIPO_RECURSO_ESPECIFICO)
);

comment on table TB_TIPO_RECURSO_ESPECIFICO is
'Esta tabela contm os tipos de recursos com finalidade especfica dos estados.';

comment on column TB_TIPO_RECURSO_ESPECIFICO.CO_SEQ_TIPO_RECURSO_ESPECIFICO is
'Cdigo do tipo do recurso com finalidade especfica.';

comment on column TB_TIPO_RECURSO_ESPECIFICO.NO_TIPO_RECURSO_ESPECIFICO is
'Descrio de um tipo de um recurso com finalidade especfica. Ex.:Reserva Tcnica, Incentivos.';

/*==============================================================*/
/* Table: TB_TIPO_REGIONALIZACAO                                */
/*==============================================================*/
create table TB_TIPO_REGIONALIZACAO (
   CO_SEQ_TIPO_REGIONALIZACAO NUMERIC(8)           not null,
   DS_TIPO_REGIONALIZACAO VARCHAR(50)          null,
   SG_TIPO_REGIONALIZACAO VARCHAR(6)           null,
   constraint PK_TIPO_REGIONALIZACAO primary key (CO_SEQ_TIPO_REGIONALIZACAO)
);

comment on table TB_TIPO_REGIONALIZACAO is
'Contm os tipos de regionalizao de um estado';

comment on column TB_TIPO_REGIONALIZACAO.CO_SEQ_TIPO_REGIONALIZACAO is
'Cdigo seqencial da tabela TB_TIPO_REGIONALIZACAO - Chave primria.';

comment on column TB_TIPO_REGIONALIZACAO.DS_TIPO_REGIONALIZACAO is
'Descrio do tipo de regionalizao.';

comment on column TB_TIPO_REGIONALIZACAO.SG_TIPO_REGIONALIZACAO is
'Sigla da descrio da regionalizao.';

alter table RL_ACAO_PROCEDIMENTO
   add constraint FK_ACAO_ACAOPROCEDIMENTO foreign key (CO_ACAO)
      references TB_ACAO (CO_SEQ_ACAO)
      on delete cascade on update restrict;

alter table RL_ACAO_PROCEDIMENTONAOSUS
   add constraint FK_ACAO_ACAOPROCEDNAOSUS foreign key (CO_ACAO)
      references TB_ACAO (CO_SEQ_ACAO)
      on delete cascade on update restrict;

alter table RL_ACAO_PROCEDIMENTONAOSUS
   add constraint FK_PROCEDNSUS_ACAOPROCEDNSUS foreign key (CO_PROCEDIMENTO_NAO_SUS)
      references TB_PROCEDIMENTO_NAO_SUS (CO_SEQ_PROCEDIMENTO_NAO_SUS)
      on delete cascade on update restrict;

alter table RL_AGREGADO_PROCEDIMENTO
   add constraint FK_AGREGADO_AGREGADOPROCEDIM foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table RL_ALTACOMPAMBMODAL_PROCEDIMEN
   add constraint FK_ALTACOMPAMBMOD_ALTCOMODPROC foreign key (CO_ALTA_COMP_AMB_MOD)
      references RL_ALTACOMPAMB_MODALIDADE (CO_SEQ_ALTA_COMP_AMB_MOD)
      on update restrict;

alter table RL_ALTACOMPAMBMODAL_PROCEDIMEN
   add constraint FK_PPI_ALTACOMPAMBMODPROC foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table RL_ALTACOMPAMB_MODALIDADE
   add constraint FK_ALTACOMPLEX_ALTACOMPAMBMODA foreign key (CO_ALTA_COMP_AMB)
      references TB_ALTA_COMPLEXIDADE_AMB (CO_SEQ_ALTA_COMP_AMB)
      on update restrict;

alter table RL_ALTACOMPAMB_MODALIDADE
   add constraint FK_MODALIDADEPPI_ALTACOMPAMBMO foreign key (CO_MODALIDADE)
      references TB_MODALIDADE_PPI (CO_SEQ_MODALIDADE)
      on update restrict;

alter table RL_AREAALOCACAO_FINANCIAMENPPI
   add constraint FK_AREAALOC_AREAALOCFINANCPPI foreign key (CO_AREA_ALOCACAO)
      references TB_AREA_ALOCACAO (CO_AREA_ALOCACAO)
      on update restrict;

alter table RL_AREAALOCACAO_FINANCIAMENPPI
   add constraint FK_FINANPPI_AREAALOCFINANCPPI foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table RL_FORMAFINAN_PPI_PROGRAMACUTI
   add constraint FK_FINANCPPI_FORMAFINANPRODUTI foreign key (CO_FINANCIAMENTO_PROD, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table RL_FORMAFINAN_PPI_PROGRAMACUTI
   add constraint FK_FINANCPPI_FORMAFINANPROGUTI foreign key (CO_FINANCIAMENTO_PROG, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table RL_NIVELREGIONALIZACAO_MUNICI
   add constraint FK_NIVELREGIONAL_NIVELREGIOMUN foreign key (CO_NIVEL_REGIONALIZACAO)
      references TB_NIVEL_REGIONALIZACAO (CO_SEQ_NIVEL_REGIONALIZACAO)
      on delete cascade on update restrict;

alter table RL_PROCEDIMENTOSIH_LEITOPPI
   add constraint FK_COMPLEXPPI_PROCLEITOPPI foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table RL_PROCEDIMENTOSIH_LEITOPPI
   add constraint FK_ESPECPPI_PROCSIHLEITOPPI foreign key (CO_ESPECIALIDADE)
      references TB_ESPECIALIDADE_PPI (CO_ESPECIALIDADE)
      on update restrict;

alter table RL_PROCEDIMENTOSIH_LEITOPPI
   add constraint FK_FINANCPPI_PROCLEITOPPI foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table RL_PROCEDIMENTOSIH_LEITOPPI
   add constraint FK_LEITOPPI_PROCSIHLEITOPPI foreign key (CO_LEITO)
      references TB_LEITO_PPI (CO_LEITO)
      on update restrict;

alter table TB_ABRANGENCIA_A
   add constraint FK_PARAMALTACOMPA_ABRANGENCIAA foreign key (CO_PARAM_ALTA_COMP_A)
      references TB_PARAMETRIZACAO_ALTA_COMP_A (CO_SEQ_PARAM_ALTA_COMP_A)
      on delete cascade on update restrict;

alter table TB_ABRANGENCIA_AGREGADO
   add constraint FK_AGREGADO_ABRANGAGREGADO foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table TB_ABRANGENCIA_AGREGADO
   add constraint FK_FINANCPPI_ABRANGAGREGADO foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_ABRANGENCIA_H
   add constraint FK_LEITOESPECH_ABRANGENCIAH foreign key (CO_LEITO_ESPEC_H)
      references TB_LEITO_ESPEC_H (CO_SEQ_LEITO_ESPEC_H)
      on delete cascade on update restrict;

alter table TB_ABRANGENCIA_UTI
   add constraint FK_LEITOUTIH_ABRANGENCIAUTI foreign key (CO_LEITO_UTI_H)
      references TB_LEITO_UTI_H (CO_SEQ_LEITO_UTI_H)
      on delete cascade on update restrict;

alter table TB_ACAO
   add constraint FK_AREAATUACAO_ACAO foreign key (CO_AREA_ATUACAO)
      references TB_AREA_ATUACAO (CO_SEQ_AREA_ATUACAO)
      on delete cascade on update restrict;

alter table TB_ACAO
   add constraint FK_AREAESTRATEGICA_ACAO foreign key (CO_AREA_ESTRATEGICA)
      references TB_AREA_ESTRATEGICA (CO_SEQ_AREA_ESTRATEGICA)
      on delete cascade on update restrict;

alter table TB_ACAO
   add constraint FK_CONFIGPOPULACAO_ACAO foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_ACAO
   add constraint FK_PPI_ACAO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_AGREGADO
   add constraint FK_PPI_AGREGADO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_AREA_ATUACAO
   add constraint FK_AREAATUACAO_AREAATUACAOPAI foreign key (CO_AREA_ATUACAO_PAI)
      references TB_AREA_ATUACAO (CO_SEQ_AREA_ATUACAO)
      on delete cascade on update restrict;

alter table TB_AREA_ATUACAO
   add constraint FK_AREAESTRATEGICA_AREAATUACAO foreign key (CO_AREA_ESTRATEGICA)
      references TB_AREA_ESTRATEGICA (CO_SEQ_AREA_ESTRATEGICA)
      on delete cascade on update restrict;

alter table TB_AREA_ATUACAO
   add constraint FK_CONFIGPOPULACAO_AREAATUACAO foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_AREA_ESTRATEGICA
   add constraint FK_CONFIGPOPULA_AREAESTRATEGIC foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_AREA_ESTRATEGICA
   add constraint FK_PPI_AREAESTRATEGICA foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_BASE_GERADA_SIA
   add constraint FK_COMPLEXIDADE_BASEGERADASIA foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_BASE_GERADA_SIH
   add constraint FK_COMPLEXIDADE_BASEGERADASIH foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_BASE_GERADA_SIH
   add constraint FK_ESPECPPI_BASEGERADASIH foreign key (CO_ESPECIALIDADE)
      references TB_ESPECIALIDADE_PPI (CO_ESPECIALIDADE)
      on update restrict;

alter table TB_BASE_GERADA_SIH
   add constraint FK_FINANCPPI_BASEGERASIH foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_BASE_GERADA_SIH
   add constraint FK_LEITOPPI_BASEGERADASIH foreign key (CO_LEITO)
      references TB_LEITO_PPI (CO_LEITO)
      on update restrict;

alter table TB_BASE_GERADA_SIH_UTI
   add constraint FK_FINANCPPI_BASEGERASIHUTI foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_CALCULO_BANDA_PARAMETRICA
   add constraint FK_AGREGADO_CALCBANDAPARAM foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table TB_CALCULO_BANDA_PARAMETRICA
   add constraint FK_FINANCPPI_CALCBANDPARA foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_CAPACIDADE_INSTALADA_SIH
   add constraint FK_COMPLEXPPI_CAPACIDADINSTSIH foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_CAPACIDADE_INSTALADA_SIH
   add constraint FK_LEITOPPI_CAPACIDINSTALADSIH foreign key (CO_LEITO)
      references TB_LEITO_PPI (CO_LEITO)
      on update restrict;

alter table TB_CBO_SIMPLIFICADA
   add constraint FK_PPI_CBOSIMPLIFICADA foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_COMPLEXIDADE_PPI
   add constraint FK_PPI_COMPLEXPPI foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONFIGPOP_FAIXA_ETARIA
   add constraint FK_CONFIGPOP_CONFIGPOPFAIXETAR foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_CONFIGURACAO_MEDIA_ALTA_COM
   add constraint FK_PPI_CONFIGMEDIAALTACOMP foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONFIGURACAO_POPULACAO
   add constraint FK_CONFIGPOPUL_CONFIGPOPULPAI foreign key (CO_CONFIGURACAO_POPULACAO_PAI)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_CONFIGURACAO_POPULACAO
   add constraint FK_PPI_CONFIGURACAOPOPULACAO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONFIGURACAO_POPULACAO
   add constraint FK_TIPOESTIMATIVA_CONFIGPOPUL foreign key (CO_TIPO_ESTIMATIVA)
      references TB_TIPO_ESTIMATIVA (CO_SEQ_TIPO_ESTIMATIVA)
      on update restrict;

alter table TB_CONFIGURACAO_POPULACAO
   add constraint FK_TIPOPOPUL_CONFIGPOPUL foreign key (CO_TIPO_POPULACAO)
      references TB_TIPO_POPULACAO (CO_SEQ_TIPO_POPULACAO)
      on update restrict;

alter table TB_CONFIGURAR_PPI_ESTADUAL
   add constraint FK_PPI_CONFIGPPIESTADUAL foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONFIGURAR_PPI_MUNICIPAL
   add constraint FK_PPI_CONFIGPPIMUNICIPAL foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONFIG_PROCED_CBO
   add constraint FK_PPI_CONFIGPROCEDCBO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_CONS_PERC_INTERNACAO_H
   add constraint FK_COMPLEXIDADE_CONSPERCINTERH foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_CONS_PERC_INTERNACAO_H
   add constraint FK_FINANCPPI_CONSPERCINTERH foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_CONTROLE_BASE_MUN
   add constraint FK_PPI_CONTROLEBASEMUN foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_DESTAQUE
   add constraint FK_COMPLEXIDADEPPI_DESTAQUE foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_DESTAQUE
   add constraint FK_DESTAQUE_DESTAQUEPAI foreign key (CO_DESTAQUE_PAI)
      references TB_DESTAQUE (CO_SEQ_DESTAQUE)
      on update restrict;

alter table TB_DESTAQUE
   add constraint FK_ESPECIALIDADEPPI_DESTAQUE foreign key (CO_ESPECIALIDADE)
      references TB_ESPECIALIDADE_PPI (CO_ESPECIALIDADE)
      on update restrict;

alter table TB_DESTAQUE
   add constraint FK_FINANCPPI_DESTAQUE foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_DESTAQUE
   add constraint FK_LEITOPPI_DESTAQUE foreign key (CO_LEITO)
      references TB_LEITO_PPI (CO_LEITO)
      on update restrict;

alter table TB_DISTRIBUICAO
   add constraint FK_RECURESPEC_DISTRIBUICAO foreign key (CO_RECURSO_ESPECIFICO)
      references TB_RECURSO_ESPECIFICO (CO_SEQ_RECURSO_ESPECIFICO)
      on delete cascade on update restrict;

alter table TB_ENCAMINHADOR_A
   add constraint FK_ESPECEXECA_ENCAMINHADORA foreign key (CO_ESPEC_EXECUTOR_A)
      references TB_ESPEC_EXECUTOR_A (CO_SEQ_ESPEC_EXECUTOR_A)
      on delete cascade on update restrict;

alter table TB_ENCAMINHADOR_AGREGADO
   add constraint FK_EXECAGREGADO_ENCAMIAGREGADO foreign key (CO_EXECUTOR_AGREGADO)
      references TB_EXECUTOR_AGREGADO (CO_SEQ_EXECUTOR_AGREGADO)
      on delete cascade on update restrict;

alter table TB_ENCAMINHADOR_H
   add constraint FK_ESPECEXECH_ENCAMINHADORH foreign key (CO_ESPEC_EXECUTOR_H)
      references TB_ESPEC_EXECUTOR_H (CO_SEQ_ESPEC_EXECUTOR_H)
      on delete cascade on update restrict;

alter table TB_ENCAMINHADOR_UTI
   add constraint FK_ESPECEXECUTI_ENCAMINHAUTI foreign key (CO_ESPEC_EXECUTOR_UTI)
      references TB_ESPEC_EXECUTOR_UTI (CO_SEQ_ESPEC_EXECUTOR_UTI)
      on delete cascade on update restrict;

alter table TB_ESPEC_EXECUTOR_A
   add constraint FK_PARAMALTACOMPABO_ESPECEXECA foreign key (CO_PARAMETRIZACAO_BOLSA)
      references TB_PARAMETRIZACAO_BOLSA (CO_SEQ_PARAMETRIZACAO_BOLSA)
      on delete cascade on update restrict;

alter table TB_ESPEC_EXECUTOR_A
   add constraint FK_PARAMALTACOMPA_ESPECEXECA foreign key (CO_PARAM_ALTA_COMP_A)
      references TB_PARAMETRIZACAO_ALTA_COMP_A (CO_SEQ_PARAM_ALTA_COMP_A)
      on delete cascade on update restrict;

alter table TB_ESPEC_EXECUTOR_H
   add constraint FK_LEITOESPECH_ESPECEXECUTORH foreign key (CO_LEITO_ESPEC_H)
      references TB_LEITO_ESPEC_H (CO_SEQ_LEITO_ESPEC_H)
      on delete cascade on update restrict;

alter table TB_ESPEC_EXECUTOR_H_MUN
   add constraint FK_LEITOESPECHM_ESPECEXEHMUN foreign key (CO_LEITO_ESPEC_H_MUNIC)
      references TB_LEITO_ESPEC_H_MUNIC (CO_SEQ_LEITO_ESPEC_H_MUNIC)
      on delete cascade on update restrict;

alter table TB_ESPEC_EXECUTOR_UTI
   add constraint FK_LEITOUTIH_ESPECEXECUTORUTI foreign key (CO_LEITO_UTI_H)
      references TB_LEITO_UTI_H (CO_SEQ_LEITO_UTI_H)
      on delete cascade on update restrict;

alter table TB_ESTRUT_REGIONALIZACAO
   add constraint FK_ESTRUTREGIO_ESTRUTREGIOPAI foreign key (CO_ESTRUT_REGIONALIZACAO_PAI)
      references TB_ESTRUT_REGIONALIZACAO (CO_SEQ_ESTRUT_REGIONALIZACAO)
      on delete cascade on update restrict;

alter table TB_ESTRUT_REGIONALIZACAO
   add constraint FK_REGIONALIZACAO_ESTRUTREGION foreign key (CO_REGIONALIZACAO)
      references TB_REGIONALIZACAO (CO_SEQ_REGIONALIZACAO)
      on delete cascade on update restrict;

alter table TB_EXECUTOR_AGREGADO
   add constraint FK_AGREGADO_EXECAGREGADO foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table TB_EXECUTOR_AGREGADO
   add constraint FK_FINANCPPI_EXECAGREGADO foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_EXECUTOR_AGREGADO
   add constraint FK_PROCEDNAOSUS_EXECAGREGADO foreign key (CO_PROCEDIMENTO_NAO_SUS)
      references TB_PROCEDIMENTO_NAO_SUS (CO_SEQ_PROCEDIMENTO_NAO_SUS)
      on update restrict;

alter table TB_FINANCIAMENTO_PPI
   add constraint FK_PPI_FINANCIAMENTOPPI foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_INFORMACAO
   add constraint FK_AREAATUACAO_INFORMACAO foreign key (CO_AREA_ATUACAO)
      references TB_AREA_ATUACAO (CO_SEQ_AREA_ATUACAO)
      on delete cascade on update restrict;

alter table TB_INFORMACAO
   add constraint FK_AREAESTRATEGICA_INFORMACAO foreign key (CO_AREA_ESTRATEGICA)
      references TB_AREA_ESTRATEGICA (CO_SEQ_AREA_ESTRATEGICA)
      on delete cascade on update restrict;

alter table TB_INFORMACAO
   add constraint FK_CONFIGPOPUL_INFORMACAO foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_LEITO_ESPEC_H
   add constraint FK_DESTAQUE_LEITOESPECH foreign key (CO_DESTAQUE)
      references TB_DESTAQUE (CO_SEQ_DESTAQUE)
      on delete cascade on update restrict;

alter table TB_LEITO_ESPEC_H_MUNIC
   add constraint FK_DESTAQUE_LEITOESPECHMUNIC foreign key (CO_DESTAQUE)
      references TB_DESTAQUE (CO_SEQ_DESTAQUE)
      on delete cascade on update restrict;

alter table TB_LEITO_UTI_H
   add constraint FK_FINANCPPI_LEITOUTIH foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_LIMITE_FINANCEIRO
   add constraint FK_FINANPPI_LIMITEFINANCEIRO foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_NIVEL_REGIONALIZACAO
   add constraint FK_ESTRUTREGIONAL_NIVELREGION foreign key (CO_ESTRUT_REGIONALIZACAO)
      references TB_ESTRUT_REGIONALIZACAO (CO_SEQ_ESTRUT_REGIONALIZACAO)
      on delete cascade on update restrict;

alter table TB_NIVEL_REGIONALIZACAO
   add constraint FK_NIVELREGIO_NIVELREGIOPAI foreign key (CO_NIVEL_REGIONALIZACAO_PAI)
      references TB_NIVEL_REGIONALIZACAO (CO_SEQ_NIVEL_REGIONALIZACAO)
      on delete cascade on update restrict;

alter table TB_PACOTE_TRS
   add constraint FK_ALTCOMAMBMOD_PROCSIAPPICOMP foreign key (CO_ALTA_COMP_AMB_MOD)
      references RL_ALTACOMPAMB_MODALIDADE (CO_SEQ_ALTA_COMP_AMB_MOD)
      on update restrict;

alter table TB_PACOTE_TRS
   add constraint FK_PPI_PROCEDIMSIAPPICOMPETENC foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_PARAMETRIZACAO_ALTA_COMP_A
   add constraint FK_ALTCOMPAMBMOD_PARAMALTCOMPA foreign key (CO_ALTA_COMP_AMB_MOD)
      references RL_ALTACOMPAMB_MODALIDADE (CO_SEQ_ALTA_COMP_AMB_MOD)
      on update restrict;

alter table TB_PARAMETRIZACAO_ALTA_COMP_A
   add constraint FK_FINANCPPI_PARALTACOMPA foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PARAMETRIZACAO_BOLSA
   add constraint FK_ALTACOMPAMBMODPR_PARAMBOLSA foreign key (CO_ALTA_COMP_AMB_MOD, CO_PROCEDIMENTO, CO_PPI)
      references RL_ALTACOMPAMBMODAL_PROCEDIMEN (CO_ALTA_COMP_AMB_MOD, CO_PROCEDIMENTO, CO_PPI)
      on update restrict;

alter table TB_PARAMETRIZACAO_BOLSA
   add constraint FK_FINANCPPI_PARAMETBOLSA foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PARAMETRO_AGREGADO
   add constraint FK_AGREGADO_PARAMETROAGREGADO foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table TB_PARAMETRO_AGREGADO
   add constraint FK_FINANCPPI_PARAMAGREG foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PARAMETRO_AGREGADO
   add constraint FK_PROCEDNAOSUS_PARAMETROAGREG foreign key (CO_PROCEDIMENTO_NAO_SUS)
      references TB_PROCEDIMENTO_NAO_SUS (CO_SEQ_PROCEDIMENTO_NAO_SUS)
      on delete cascade on update restrict;

alter table TB_PARAM_CARDAPIO
   add constraint FK_PPI_PARAMCARDAPIO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_PPI_COMPETENCIA
   add constraint FK_PPI_PPICOMPETENCIA foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_PPI_INTERESTADUAL_CONFIG
   add constraint FK_PPI_PPIINTERESTADUALCONFIG foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on delete cascade on update restrict;

alter table TB_PROCEDIMENTO_NAO_SUS
   add constraint FK_PPI_PROCEDIMENTONAOSUS foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_PROCEDIMENTO_SIH_DEPARA
   add constraint FK_COMPLEXDEPARA_PROCSIHDEPARA foreign key (CO_COMPLEXIDADE)
      references TB_COMPLEXIDADE_DEPARA (CO_SEQ_COMPLEXIDADE)
      on update restrict;

alter table TB_PROCEDIMENTO_SIH_DEPARA
   add constraint FK_FORMFINANDEPAR_PROCSIHDEPAR foreign key (CO_FORMA_FINAN)
      references TB_FORMA_FINANCIAMENTO_DEPARA (CO_SEQ_FORMA_FINAN)
      on update restrict;

alter table TB_PROCEDIMENTO_TRS
   add constraint FK_PPI_PROCEDIMENTOTRS foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_PROC_EXCLUIDO_SIH_DEPARA
   add constraint FK_PROCSIHDEPAR_PROCEXCSIHDEPA foreign key (CO_PROCEDIMENTO, CO_COMPLEXIDADE, CO_FORMA_FINAN)
      references TB_PROCEDIMENTO_SIH_DEPARA (CO_PROCEDIMENTO, CO_COMPLEXIDADE, CO_FORMA_FINAN)
      on update restrict;

alter table TB_PRODUCAO_ONCOLOGIA
   add constraint FK_COMPLEXPPI_PRODUCAOONCOL foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_PRODUCAO_SIA
   add constraint FK_COMPLEXIDADEPPI_PRODSIA foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_PRODUCAO_SIA
   add constraint FK_FINANCIAMENTOPPI_PRODSIA foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PRODUCAO_SIH
   add constraint FK_COMPLEXIDADEPPI_PRODUCAOSIH foreign key (TP_COMPLEXIDADE, CO_PPI)
      references TB_COMPLEXIDADE_PPI (TP_COMPLEXIDADE, CO_PPI)
      on update restrict;

alter table TB_PRODUCAO_SIH
   add constraint FK_FINANCPPI_PRODUCAOSIH foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PRODUCAO_UTI_UCI
   add constraint FK_FINANPPI_PRODUTIUCI foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PROGRAMACAO_ACAO
   add constraint FK_ACAO_PROGRAMACAOACAO foreign key (CO_ACAO)
      references TB_ACAO (CO_SEQ_ACAO)
      on delete cascade on update restrict;

alter table TB_PROGRAMACAO_ACAO
   add constraint FK_FINANCPPI_PROGRAMACAO foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_PROGRAMACAO_POPULACAO
   add constraint FK_CONFIGPOP_PROGRAMPOPULACAO foreign key (CO_CONFIGURACAO_POPULACAO)
      references TB_CONFIGURACAO_POPULACAO (CO_SEQ_CONFIGURACAO_POPULACAO)
      on delete cascade on update restrict;

alter table TB_RECURSO_ESPECIFICO
   add constraint FK_FORMAFINANPPI_RECURSESPEC foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_RECURSO_ESPECIFICO
   add constraint FK_TIPORECURESPEC_RECURESPEC foreign key (CO_TIPO_RECURSO_ESPECIFICO)
      references TB_TIPO_RECURSO_ESPECIFICO (CO_SEQ_TIPO_RECURSO_ESPECIFICO)
      on update restrict;

alter table TB_REGIONALIZACAO
   add constraint FK_PPI_REGIONALIZACAO foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;

alter table TB_REGIONALIZACAO
   add constraint FK_TIPOREGIONALIZ_REGIONALIZ foreign key (CO_TIPO_REGIONALIZACAO)
      references TB_TIPO_REGIONALIZACAO (CO_SEQ_TIPO_REGIONALIZACAO)
      on update restrict;

alter table TB_RESULTADO_BANDA_PARAMETRICA
   add constraint FK_AGREGADO_RESULTBANDAPARAM foreign key (CO_AGREGADO)
      references TB_AGREGADO (CO_SEQ_AGREGADO)
      on delete cascade on update restrict;

alter table TB_RESULTADO_BANDA_PARAMETRICA
   add constraint FK_FINANPPI_RESULTBANDPARA foreign key (CO_FINANCIAMENTO, CO_PPI)
      references TB_FINANCIAMENTO_PPI (CO_FINANCIAMENTO, CO_PPI)
      on update restrict;

alter table TB_SERV_CLASS_PPI
   add constraint FK_PPI_SERVCLASSPPI foreign key (CO_PPI)
      references TB_PPI (CO_SEQ_PPI)
      on update restrict;



--**********************************************************************
INSERT INTO TB_CONFIGURACAO_ACESSO
(DS_VERSAO_BD) VALUES ('7');
--**********************************************************************

--**********************************************************************
-- Manter sempre esta rotina
-- reversa gera como tipo (char)
--**********************************************************************

ALTER TABLE TB_CONTROLE_BASE_MUN
  DROP COLUMN im_base_mun;

ALTER TABLE TB_CONTROLE_BASE_MUN
 ADD COLUMN im_base_mun oid;
  

COMMENT ON COLUMN TB_CONTROLE_BASE_MUN.IM_BASE_MUN
IS 'Armzena um arquivo zip com os dados que sera encaminhado para os municipios.';


--------------- SQL ---------------

ALTER TABLE tb_configuracao_populacao
  DROP CONSTRAINT fk_configpopul_configpopulpai RESTRICT;

ALTER TABLE tb_configuracao_populacao
  ADD CONSTRAINT fk_configpopul_configpopulpai FOREIGN KEY (co_configuracao_populacao_pai)
    REFERENCES tb_configuracao_populacao(co_seq_configuracao_populacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
    --------------- SQL ---------------

ALTER TABLE tb_configuracao_populacao
  DROP CONSTRAINT fk_ppi_configuracaopopulacao RESTRICT;

ALTER TABLE tb_configuracao_populacao
  ADD CONSTRAINT fk_ppi_configuracaopopulacao FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
--------------- SQL ---------------

ALTER TABLE tb_configuracao_populacao
  DROP CONSTRAINT fk_tipoestimativa_configpopul RESTRICT;

ALTER TABLE tb_configuracao_populacao
  ADD CONSTRAINT fk_tipoestimativa_configpopul FOREIGN KEY (co_tipo_estimativa)
    REFERENCES tb_tipo_estimativa(co_seq_tipo_estimativa)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
--------------- SQL ---------------

ALTER TABLE tb_configuracao_populacao
  DROP CONSTRAINT fk_tipopopul_configpopul RESTRICT;

ALTER TABLE tb_configuracao_populacao
  ADD CONSTRAINT fk_tipopopul_configpopul FOREIGN KEY (co_tipo_populacao)
    REFERENCES tb_tipo_populacao(co_seq_tipo_populacao)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
--------------- SQL ---------------

ALTER TABLE tb_acao
  DROP CONSTRAINT fk_areaatuacao_acao RESTRICT;

ALTER TABLE tb_acao
  ADD CONSTRAINT fk_areaatuacao_acao FOREIGN KEY (co_area_atuacao)
    REFERENCES tb_area_atuacao(co_seq_area_atuacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
--------------- SQL ---------------

ALTER TABLE tb_acao
  DROP CONSTRAINT fk_areaestrategica_acao RESTRICT;

ALTER TABLE tb_acao
  ADD CONSTRAINT fk_areaestrategica_acao FOREIGN KEY (co_area_estrategica)
    REFERENCES tb_area_estrategica(co_seq_area_estrategica)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
    
--------------- SQL ---------------

ALTER TABLE tb_acao
  DROP CONSTRAINT fk_configpopulacao_acao RESTRICT;

ALTER TABLE tb_acao
  ADD CONSTRAINT fk_configpopulacao_acao FOREIGN KEY (co_configuracao_populacao)
    REFERENCES tb_configuracao_populacao(co_seq_configuracao_populacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE tb_acao
  DROP CONSTRAINT fk_ppi_acao RESTRICT;

ALTER TABLE tb_acao
  ADD CONSTRAINT fk_ppi_acao FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_programacao_acao
  DROP CONSTRAINT fk_acao_programacaoacao RESTRICT;

ALTER TABLE tb_programacao_acao
  ADD CONSTRAINT fk_acao_programacaoacao FOREIGN KEY (co_acao)
    REFERENCES tb_acao(co_seq_acao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE tb_programacao_acao
  DROP CONSTRAINT fk_financppi_programacao RESTRICT;

ALTER TABLE tb_programacao_acao
  ADD CONSTRAINT fk_financppi_programacao FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE rl_acao_procedimento
  DROP CONSTRAINT fk_acao_acaoprocedimento RESTRICT;

ALTER TABLE rl_acao_procedimento
  ADD CONSTRAINT fk_acao_acaoprocedimento FOREIGN KEY (co_acao)
    REFERENCES tb_acao(co_seq_acao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    


--------------- SQL ---------------

ALTER TABLE tb_informacao
  DROP CONSTRAINT fk_areaatuacao_informacao RESTRICT;

ALTER TABLE tb_informacao
  ADD CONSTRAINT fk_areaatuacao_informacao FOREIGN KEY (co_area_atuacao)
    REFERENCES tb_area_atuacao(co_seq_area_atuacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE tb_informacao
  DROP CONSTRAINT fk_areaestrategica_informacao RESTRICT;

ALTER TABLE tb_informacao
  ADD CONSTRAINT fk_areaestrategica_informacao FOREIGN KEY (co_area_estrategica)
    REFERENCES tb_area_estrategica(co_seq_area_estrategica)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE tb_informacao
  DROP CONSTRAINT fk_configpopul_informacao RESTRICT;

ALTER TABLE tb_informacao
  ADD CONSTRAINT fk_configpopul_informacao FOREIGN KEY (co_configuracao_populacao)
    REFERENCES tb_configuracao_populacao(co_seq_configuracao_populacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE rl_acao_procedimentonaosus
  DROP CONSTRAINT fk_acao_acaoprocednaosus RESTRICT;

ALTER TABLE rl_acao_procedimentonaosus
  ADD CONSTRAINT fk_acao_acaoprocednaosus FOREIGN KEY (co_acao)
    REFERENCES tb_acao(co_seq_acao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE rl_acao_procedimentonaosus
  DROP CONSTRAINT fk_procednsus_acaoprocednsus RESTRICT;

ALTER TABLE rl_acao_procedimentonaosus
  ADD CONSTRAINT fk_procednsus_acaoprocednsus FOREIGN KEY (co_procedimento_nao_sus)
    REFERENCES tb_procedimento_nao_sus(co_seq_procedimento_nao_sus)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_area_estrategica
  DROP CONSTRAINT fk_configpopula_areaestrategic RESTRICT;

ALTER TABLE tb_area_estrategica
  ADD CONSTRAINT fk_configpopula_areaestrategic FOREIGN KEY (co_configuracao_populacao)
    REFERENCES tb_configuracao_populacao(co_seq_configuracao_populacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_area_estrategica
  DROP CONSTRAINT fk_ppi_areaestrategica RESTRICT;

ALTER TABLE tb_area_estrategica
  ADD CONSTRAINT fk_ppi_areaestrategica FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_area_atuacao
  DROP CONSTRAINT fk_areaatuacao_areaatuacaopai RESTRICT;

ALTER TABLE tb_area_atuacao
  ADD CONSTRAINT fk_areaatuacao_areaatuacaopai FOREIGN KEY (co_area_atuacao_pai)
    REFERENCES tb_area_atuacao(co_seq_area_atuacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_area_atuacao
  DROP CONSTRAINT fk_areaestrategica_areaatuacao RESTRICT;

ALTER TABLE tb_area_atuacao
  ADD CONSTRAINT fk_areaestrategica_areaatuacao FOREIGN KEY (co_area_estrategica)
    REFERENCES tb_area_estrategica(co_seq_area_estrategica)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_area_atuacao
  DROP CONSTRAINT fk_configpopulacao_areaatuacao RESTRICT;

ALTER TABLE tb_area_atuacao
  ADD CONSTRAINT fk_configpopulacao_areaatuacao FOREIGN KEY (co_configuracao_populacao)
    REFERENCES tb_configuracao_populacao(co_seq_configuracao_populacao)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE rl_agregado_procedimento
  DROP CONSTRAINT fk_agregado_agregadoprocedim RESTRICT;

ALTER TABLE rl_agregado_procedimento
  ADD CONSTRAINT fk_agregado_agregadoprocedim FOREIGN KEY (co_agregado)
    REFERENCES tb_agregado(co_seq_agregado)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    

--------------- SQL ---------------

ALTER TABLE tb_parametro_agregado
  DROP CONSTRAINT fk_agregado_parametroagregado RESTRICT;

ALTER TABLE tb_parametro_agregado
  ADD CONSTRAINT fk_agregado_parametroagregado FOREIGN KEY (co_agregado)
    REFERENCES tb_agregado(co_seq_agregado)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_parametro_agregado
  DROP CONSTRAINT fk_financppi_paramagreg RESTRICT;

ALTER TABLE tb_parametro_agregado
  ADD CONSTRAINT fk_financppi_paramagreg FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    ON DELETE NO ACTION
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_parametro_agregado
  DROP CONSTRAINT fk_procednaosus_parametroagreg RESTRICT;

ALTER TABLE tb_parametro_agregado
  ADD CONSTRAINT fk_procednaosus_parametroagreg FOREIGN KEY (co_procedimento_nao_sus)
    REFERENCES tb_procedimento_nao_sus(co_seq_procedimento_nao_sus)
    ON DELETE CASCADE
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;
    
--------------- SQL ---------------

ALTER TABLE tb_agregado
  DROP CONSTRAINT fk_ppi_agregado RESTRICT;

ALTER TABLE tb_agregado
  ADD CONSTRAINT fk_ppi_agregado FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    ON DELETE RESTRICT
    ON UPDATE RESTRICT
    DEFERRABLE
    INITIALLY DEFERRED;      


-------------SQL2----------------------------------------
ALTER TABLE tb_configurar_ppi_municipal
  DROP CONSTRAINT fk_ppi_configppimunicipal ;

ALTER TABLE tb_configurar_ppi_municipal
  ADD CONSTRAINT fk_ppi_configppimunicipal FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_controle_base_mun
  DROP CONSTRAINT fk_ppi_controlebasemun ;

ALTER TABLE tb_controle_base_mun
  ADD CONSTRAINT fk_ppi_controlebasemun FOREIGN KEY (co_ppi)
    REFERENCES tb_ppi(co_seq_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;




ALTER TABLE tb_recurso_especifico
  DROP CONSTRAINT fk_formafinanppi_recursespec ;

ALTER TABLE tb_recurso_especifico
  ADD CONSTRAINT fk_formafinanppi_recursespec FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_recurso_especifico
  DROP CONSTRAINT fk_tiporecurespec_recurespec ;

ALTER TABLE tb_recurso_especifico
  ADD CONSTRAINT fk_tiporecurespec_recurespec FOREIGN KEY (co_tipo_recurso_especifico)
    REFERENCES tb_tipo_recurso_especifico(co_seq_tipo_recurso_especifico)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_distribuicao
  DROP CONSTRAINT fk_recurespec_distribuicao ;

ALTER TABLE tb_distribuicao
  ADD CONSTRAINT fk_recurespec_distribuicao FOREIGN KEY (co_recurso_especifico)
    REFERENCES tb_recurso_especifico(co_seq_recurso_especifico)
    ON DELETE CASCADE
    DEFERRABLE
    INITIALLY DEFERRED;


ALTER TABLE tb_limite_financeiro
  DROP CONSTRAINT fk_finanppi_limitefinanceiro ;

ALTER TABLE tb_limite_financeiro
  ADD CONSTRAINT fk_finanppi_limitefinanceiro FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_cons_perc_internacao_h
  DROP CONSTRAINT fk_complexidade_conspercinterh ;

ALTER TABLE tb_cons_perc_internacao_h
  ADD CONSTRAINT fk_complexidade_conspercinterh FOREIGN KEY (tp_complexidade, co_ppi)
    REFERENCES tb_complexidade_ppi(tp_complexidade, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_cons_perc_internacao_h
  DROP CONSTRAINT fk_financppi_conspercinterh ;

ALTER TABLE tb_cons_perc_internacao_h
  ADD CONSTRAINT fk_financppi_conspercinterh FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_destaque
  DROP CONSTRAINT fk_complexidadeppi_destaque ;

ALTER TABLE tb_destaque
  ADD CONSTRAINT fk_complexidadeppi_destaque FOREIGN KEY (tp_complexidade, co_ppi)
    REFERENCES tb_complexidade_ppi(tp_complexidade, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_destaque
  DROP CONSTRAINT fk_destaque_destaquepai ;

ALTER TABLE tb_destaque
  ADD CONSTRAINT fk_destaque_destaquepai FOREIGN KEY (co_destaque_pai)
    REFERENCES tb_destaque(co_seq_destaque)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_destaque
  DROP CONSTRAINT fk_especialidadeppi_destaque ;

ALTER TABLE tb_destaque
  ADD CONSTRAINT fk_especialidadeppi_destaque FOREIGN KEY (co_especialidade)
    REFERENCES tb_especialidade_ppi(co_especialidade)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_destaque
  DROP CONSTRAINT fk_financppi_destaque ;

ALTER TABLE tb_destaque
  ADD CONSTRAINT fk_financppi_destaque FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_destaque
  DROP CONSTRAINT fk_leitoppi_destaque ;

ALTER TABLE tb_destaque
  ADD CONSTRAINT fk_leitoppi_destaque FOREIGN KEY (co_leito)
    REFERENCES tb_leito_ppi(co_leito)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_leito_espec_h_munic
  DROP CONSTRAINT fk_destaque_leitoespechmunic ;

ALTER TABLE tb_leito_espec_h_munic
  ADD CONSTRAINT fk_destaque_leitoespechmunic FOREIGN KEY (co_destaque)
    REFERENCES tb_destaque(co_seq_destaque)
    ON DELETE CASCADE
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_leito_uti_h
  DROP CONSTRAINT fk_financppi_leitoutih ;

ALTER TABLE tb_leito_uti_h
  ADD CONSTRAINT fk_financppi_leitoutih FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_parametrizacao_alta_comp_a
  DROP CONSTRAINT fk_altcompambmod_paramaltcompa ;

ALTER TABLE tb_parametrizacao_alta_comp_a
  ADD CONSTRAINT fk_altcompambmod_paramaltcompa FOREIGN KEY (co_alta_comp_amb_mod)
    REFERENCES rl_altacompamb_modalidade(co_seq_alta_comp_amb_mod)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_parametrizacao_alta_comp_a
  DROP CONSTRAINT fk_financppi_paraltacompa ;

ALTER TABLE tb_parametrizacao_alta_comp_a
  ADD CONSTRAINT fk_financppi_paraltacompa FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_parametrizacao_bolsa
  DROP CONSTRAINT fk_altacompambmodpr_parambolsa ;

ALTER TABLE tb_parametrizacao_bolsa
  ADD CONSTRAINT fk_altacompambmodpr_parambolsa FOREIGN KEY (co_alta_comp_amb_mod, co_procedimento, co_ppi)
    REFERENCES rl_altacompambmodal_procedimen(co_alta_comp_amb_mod, co_procedimento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;



ALTER TABLE tb_parametrizacao_bolsa
  DROP CONSTRAINT fk_financppi_parametbolsa ;

ALTER TABLE tb_parametrizacao_bolsa
  ADD CONSTRAINT fk_financppi_parametbolsa FOREIGN KEY (co_financiamento, co_ppi)
    REFERENCES tb_financiamento_ppi(co_financiamento, co_ppi)
    DEFERRABLE
    INITIALLY DEFERRED;
    
    
 
 

--**********************************************************************
--**********************************************************************

--01 - FG_FormataZeroEsquerda
--02 - FG_BuscaCodigoSequencial
--03 - FG_RetornaPopulacaoEstado
--04 - FG_RetornaPopulacaoMunicipio
--05 - atualizamuntb_cons_perc_internacao_h
--06 - carga_tb_leito_espec_h
--07 - carga_tb_leito_espec_h_municipio
--08 - cargatb_cons_perc_internacao_h_estado
--09 - cargatb_cons_perc_internacao_h_municipio
--10 - cargatb_espec_executor_a
--11 - cargatb_espec_executor_h
--12 - cargatb_espec_executor_uti
--13 - cargatb_encaminhador_a
--14 - cargatb_abrangencia_a
--15 - cargatb_abrangencia_h
--16 - cargatb_abrangencia_uti
--17 - cargatb_abrangenciaa_voltapre
--18 - cargatb_abrangenciah_voltapreliminar
--19 - cargatb_abrangenciauti_voltapre
--20 - cargatb_especexecutora_voltapre
--21 - cargatb_especexecutorh_voltapreliminar
--22 - cargatb_especexecutoruti_voltapre
--23 - cargatb_encaminhadora_voltapre

--24 carga_tb_leito_espec_h_municipio_atualiza
--25 carga_tb_leito_espec_h_municipio_vl_medio
--26 fg_atualiza_abrangencia_h
--27 fg_atualiza_abrangencia_a
--28 fg_atualiza_abrangencia_uti


--29 fg_atualiza_abrangencia_a_tipo2
--30 fg_atualiza_abrangencia_h_tipo2
--31 fg_atualiza_abrangencia_uti_tipo2
--32 fg_atualiza_abrangencia_agregado_tipo2


--**********************************************************************

CREATE OR REPLACE FUNCTION "dbsisppi"."FG_BuscaCodigoSequencial" (co_ppi varchar, sequenceparam varchar, municipio varchar) RETURNS numeric AS
$body$
DECLARE
  v_esfera varchar;
  v_uf varchar;
  v_regiao varchar;
  v_municipio varchar;
  v_distrito varchar;
  v_ppi varchar;
  v_codsequencial varchar;
  v_novo_codsequencial varchar;
  v_codigo_geral varchar;
  v_codigo_geral_result numeric;
BEGIN
  -- Campo de 28 Posicoes
  -- Esfera | UF | Regiao | Municipio | Distrito | PPI  | Codigo Sequencial
  --   0    | 00 |  0000  |  000000   |   000    | 0000 |    00000000
  --   1    | 2  |  4     |    6      |    3     |  4   |       8
  --   2      35    0000     000000       000      0123      00000059
  --   2      43    1111     666666       333      0000      00000018

  v_novo_codsequencial = 'dbsisppi.'||lower(sequenceparam);

  v_esfera = substr(co_ppi,1,1);
  v_uf= substr(co_ppi,2,2);
  v_regiao = substr(co_ppi,4,4);
  v_municipio = municipio;
  v_distrito = '0';
  v_ppi= substr(co_ppi,Length(co_ppi)-3,4);

  v_codsequencial= '0';
  select nextval(v_novo_codsequencial) into v_codsequencial;

  select * from dbsisppi."FG_FormataZeroEsquerda"(v_regiao,'4') into v_regiao;
  select * from dbsisppi."FG_FormataZeroEsquerda"(v_municipio,'6') into v_municipio;
  select * from dbsisppi."FG_FormataZeroEsquerda"(v_distrito,'3') into v_distrito;
  select * from dbsisppi."FG_FormataZeroEsquerda"(v_ppi,'4') into v_ppi;
  select * from dbsisppi."FG_FormataZeroEsquerda"(v_codsequencial,'8') into v_codsequencial;

  v_codigo_geral = v_esfera||v_uf||v_regiao||v_municipio||v_distrito||v_ppi||v_codsequencial;

  v_codigo_geral_result = v_codigo_geral;

  RETURN v_codigo_geral_result;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;




CREATE OR REPLACE FUNCTION "dbsisppi"."FG_FormataZeroEsquerda" (numero varchar, qtdezero integer) RETURNS varchar AS
$body$
DECLARE
   i integer;
   NovoNumero varchar;
begin
  NovoNumero= '';

  FOR i in 1..qtdezero - Length(numero) LOOP
      NovoNumero = NovoNumero || '0';
   END LOOP;

   RETURN NovoNumero||numero;

end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."FG_RetornaPopulacaoEstado" (uf varchar, p_co_ppi varchar) RETURNS numeric AS
$body$
DECLARE
v_populacao numeric;
BEGIN

    select coalesce(sum(qt_populacao),0) from dbsisppi.tb_populacao_abrangencia p
    where substr(co_municipio_ibge,1,2) = uf
    and p.nu_ano =
    (select c.nu_ano_populacao
    from dbsisppi.tb_param_cardapio c
    where c.co_ppi = p_co_ppi)
    into v_populacao;

  return v_populacao;
END;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."FG_RetornaPopulacaoMunicipio" (municipio varchar, p_co_ppi varchar) RETURNS numeric AS
$body$
DECLARE
v_populacao numeric;
BEGIN
    select sum(p.qt_populacao) as qt_populacao
    from  dbsisppi.tb_populacao_abrangencia  p
    where p.co_municipio_ibge = municipio
    and p.nu_ano = (select p.nu_ano_populacao from  dbsisppi.tb_param_cardapio  p
    where p.co_ppi = p_co_ppi)
    group by p.co_municipio_ibge
    into v_populacao;

  return v_populacao;
END;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."atualizamuntb_cons_perc_internacao_h" (p_co_uf_ibge varchar, p_co_ppi varchar) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_municipio record;
      v_populacao  numeric;

      reg_munic record;
      reg_perc record;

      v_qt_fisico numeric;

      v_ano varchar;

  begin


  select p.nu_ano_populacao from  dbsisppi.tb_param_cardapio  p
  where p.co_ppi = p_co_ppi
  into v_ano;

  --************************************************************************
    for reg_generica in
      select h.tp_complexidade, h.co_financiamento, h.vl_perc
      from   dbsisppi.tb_cons_perc_internacao_h  h
      where h.co_ppi = p_co_ppi
      and substr(h.co_seq_cons_perc_int_h, 2, 2) = p_co_uf_ibge
      and substr(h.co_seq_cons_perc_int_h, 8, 6) = '000000'
    loop
         --************************************************************************

       update  dbsisppi.tb_cons_perc_internacao_h  set
       vl_perc = reg_generica.vl_perc
       where co_ppi = p_co_ppi
       and substr(co_seq_cons_perc_int_h, 2, 2) = p_co_uf_ibge
       and substr(co_seq_cons_perc_int_h, 8, 6) <> '000000'
       and tp_complexidade = reg_generica.tp_complexidade
       and co_financiamento = reg_generica.co_financiamento ;

       for reg_municipio in
          select p.co_municipio_ibge, p.qt_populacao
          from  dbsisppi.tb_populacao_abrangencia  p
          where substr(p.co_municipio_ibge,1,2) = p_co_uf_ibge
          and p.nu_ano = v_ano
        loop

       --************************************************************************

      -- select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_municipio.co_municipio_ibge,p_co_ppi) into v_populacao;
      -- 8,99 seg

       update   dbsisppi.tb_cons_perc_internacao_h   set
       qt_fisico = trunc((vl_perc * reg_municipio.qt_populacao) / 100)
       where co_ppi = p_co_ppi
       and substr(co_seq_cons_perc_int_h, 2, 2) = p_co_uf_ibge
       and substr(co_seq_cons_perc_int_h, 8, 6) <> '000000'
       and tp_complexidade = reg_generica.tp_complexidade
       and co_financiamento = reg_generica.co_financiamento
       and substr(co_seq_cons_perc_int_h, 8, 6) = reg_municipio.co_municipio_ibge;

      end loop;
  end loop;



   for reg_munic in
     select a.tp_complexidade, a.co_financiamento,
     substr(co_seq_cons_perc_int_h, 8, 6) as munic,
     sum(a.qt_fisico) as qt_fisico
     from dbsisppi.tb_cons_perc_internacao_h a
     where a.tp_complexidade = 2
     and substr(co_seq_cons_perc_int_h, 2, 2) = p_co_uf_ibge
     and substr(co_seq_cons_perc_int_h, 8, 6) <> '000000'
     and a.co_ppi = p_co_ppi
     group by a.tp_complexidade, a.co_financiamento,
     substr(co_seq_cons_perc_int_h, 8, 6)
   loop

       for reg_perc in

          select l.co_seq_leito_espec_h_munic, l.vl_distribuicao
          from dbsisppi.tb_leito_espec_h_munic l
          inner join dbsisppi.tb_destaque d
          on l.co_destaque = d.co_seq_destaque
          where d.co_financiamento = reg_munic.co_financiamento
          and d.tp_complexidade = reg_munic.tp_complexidade
          and d.co_ppi = p_co_ppi
          and l.vl_distribuicao > 0
          and substr(l.co_seq_leito_espec_h_munic, 8, 6) = reg_munic.munic

       loop

          v_qt_fisico = trunc((reg_munic.qt_fisico * reg_perc.vl_distribuicao) / 100);

          update dbsisppi.tb_leito_espec_h_munic
          set qt_fisico = v_qt_fisico
          where co_seq_leito_espec_h_munic = reg_perc.co_seq_leito_espec_h_munic;

       end loop;

   end loop;

-- antes - 60,83
-- 2 sql - 31,22

  return 1;
  end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."carga_tb_leito_espec_h" (p_co_ppi varchar, parametrizacao_zero boolean) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_generica_update record;
      reg_producao record;
      v_sequence numeric;
      -- estado

      v_qt_fisico_producao numeric;
      v_vl_financeiro_producao numeric;
      v_vl_medio numeric;
      v_vl_medio_municipal numeric;

      ppi varchar;
      a numeric;
      b numeric;
      c numeric;

  begin
    ppi = substr(p_co_ppi,length(p_co_ppi)-3,4);

    select * from dbsisppi."FG_FormataZeroEsquerda"(ppi,'4') into ppi;

    delete from dbsisppi.tb_leito_espec_h
    where substr(co_seq_leito_espec_h,17,4) = ppi;

--***************************************************
  -- Busca produo por tipo de leito, especialidade,
  -- forma de financiamento, complexidade e PPI.
--*******************************************************

  for reg_generica in
     select d.co_seq_destaque,
     trunc(coalesce(sum(bb.qt_procedimento_aprovado), 0)) as qt_fisico_producao,
     case trunc(sum(bb.qt_procedimento_aprovado))
     when 0 then 0
     else
     coalesce(sum(bb.vl_procedimento_aprovado)/trunc(sum(bb.qt_procedimento_aprovado)),0)
     end
     as vl_medio_producao,
     coalesce(sum(bb.vl_procedimento_aprovado),0) as vl_financeiro_producao
     from dbsisppi.tb_destaque d
     inner join dbsisppi.tb_leito_ppi l
     on d.co_leito = l.co_leito
     inner join dbsisppi.tb_especialidade_ppi ee
     on d.co_especialidade =  ee.co_especialidade
     left outer join dbsisppi.tb_base_gerada_sih bb
     on d.tp_complexidade = bb.tp_complexidade
     and d.co_financiamento = bb.co_financiamento
     and d.co_especialidade = bb.co_especialidade
     and d.co_leito = bb.co_leito
     and d.co_ppi = bb.co_ppi
     and substr(bb.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
     and substr(bb.co_municipio_ibge_mov,1,2) = substr(p_co_ppi,2,2)
     where d.co_ppi = p_co_ppi
     group by d.co_seq_destaque

  loop

     v_qt_fisico_producao = reg_generica.qt_fisico_producao;
     v_vl_financeiro_producao = reg_generica.vl_financeiro_producao;

    if (parametrizacao_zero) then
      v_vl_medio = 0;
      v_vl_medio_municipal = 0;
    else
      v_vl_medio = reg_generica.vl_medio_producao;
      v_vl_medio_municipal = reg_generica.vl_medio_producao;
    end if;

    select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_leitoespech_coseqleitespech','') into v_sequence;

        INSERT INTO dbsisppi.tb_leito_espec_h
         (co_seq_leito_espec_h,
         co_destaque,
         vl_distribuicao,
         vl_medio,
         qt_fisico_producao,
         vl_distribuicao_producao,
         vl_medio_municipal,
         vl_financeiro_producao,
         st_abrangencia,
         st_carga_abrangencia,
         tp_abrangencia
         ) VALUES (
         v_sequence, -- co_seq_leito_espec_h
         reg_generica.co_seq_destaque, -- co_destaque
         0,  -- vl_distribuicao - rotina a parte
         v_vl_medio, -- vl_medio
         v_qt_fisico_producao, -- qt_fisico_producao
         0, -- vl_distribuicao_producao --  rotina aparte
         v_vl_medio_municipal, -- vl_medio_municipal
         v_vl_financeiro_producao,
         'N',
         'N',
         '1');

  end loop;

  -- Atualiza os destacados
  for reg_generica in
    select d.tp_complexidade, d.co_financiamento,
    d.co_leito, h.vl_distribuicao, h.vl_medio,
    h.qt_fisico_producao, h.vl_distribuicao_producao,
    h.vl_financeiro_producao, h.vl_medio_municipal
    from dbsisppi.tb_destaque d
    inner join dbsisppi.tb_leito_espec_h h
    on h.co_destaque = d.co_seq_destaque
    where d.st_destacado = 'N'
    and d.co_ppi = p_co_ppi
    and d.co_financiamento <> '99'
    and d.co_financiamento <> '98'
  loop

        for reg_generica_update in
          select h.co_seq_leito_espec_h, h.qt_fisico_producao,
          h.vl_financeiro_producao, h.vl_distribuicao,
          h.vl_medio, d.co_seq_destaque
          from dbsisppi.tb_leito_espec_h h,
          dbsisppi.tb_destaque d,
          dbsisppi.tb_especialidade_ppi es
          where h.co_destaque = d.co_seq_destaque
          and d.co_especialidade = es.co_especialidade
          and (es.no_especialidade = 'CIRURGIA GERAL'
          or  es.no_especialidade = 'CLINICA GERAL')
          and d.st_destacado = 'S'
          and d.tp_complexidade = reg_generica.tp_complexidade
          and d.co_financiamento = reg_generica.co_financiamento
          and d.co_leito =  reg_generica.co_leito
          and d.co_ppi = p_co_ppi
        loop

        end loop;

         a  = (reg_generica.vl_financeiro_producao +
               reg_generica_update.vl_financeiro_producao);

         b = (reg_generica.qt_fisico_producao +
              reg_generica_update.qt_fisico_producao);

         if b > 0 then
           c = a/b;
         else
           c = 0;
         end if;

        if (parametrizacao_zero) then
          v_vl_medio = 0;
        else
          v_vl_medio = c;
        end if;

        update dbsisppi.tb_leito_espec_h set

          vl_distribuicao = vl_distribuicao + reg_generica.vl_distribuicao ,
          vl_medio = v_vl_medio,
          qt_fisico_producao = qt_fisico_producao + reg_generica.qt_fisico_producao ,
          vl_distribuicao_producao = vl_distribuicao_producao + reg_generica.vl_distribuicao_producao ,
          vl_financeiro_producao = vl_financeiro_producao + reg_generica.vl_financeiro_producao ,
          vl_medio_municipal = c
        where co_seq_leito_espec_h = reg_generica_update.co_seq_leito_espec_h;

  end loop;


  -- 1 minuto
  for reg_generica in

     select
     DISTINCT(d.co_financiamento)as co_financiamento,d.tp_complexidade
     from dbsisppi.tb_destaque d
     where d.co_financiamento <> '99'
     and d.co_ppi = p_co_ppi
  loop


     for reg_generica_update in
         select l.co_seq_leito_espec_h,
         replace(l.qt_fisico_producao * 100 /
         (select
         coalesce(sum(l.qt_fisico_producao),1) as qt_fisico_producao
         from dbsisppi.tb_leito_espec_h l, dbsisppi.tb_destaque  d
         where d.co_seq_destaque = l.co_destaque
         and d.co_financiamento = reg_generica.co_financiamento
         and d.tp_complexidade = reg_generica.tp_complexidade
         and d.st_destacado = 'S'
         and d.co_ppi = p_co_ppi
         and l.qt_fisico_producao > 0 ),',','.') as TOTAL
         from dbsisppi.tb_leito_espec_h l, dbsisppi.tb_destaque d
         where d.co_seq_destaque = l.co_destaque
         and d.co_financiamento = reg_generica.co_financiamento
         and d.tp_complexidade = reg_generica.tp_complexidade
         and d.co_ppi = p_co_ppi
         and d.st_destacado = 'S'
         and l.qt_fisico_producao > 0
     loop


        if (parametrizacao_zero) then
             update dbsisppi.tb_leito_espec_h
             set vl_distribuicao_producao = cast(reg_generica_update.TOTAL as double precision)
             where co_seq_leito_espec_h = reg_generica_update.co_seq_leito_espec_h;
        else
             update dbsisppi.tb_leito_espec_h
             set vl_distribuicao_producao = cast(reg_generica_update.TOTAL as double precision),
             vl_distribuicao = cast(reg_generica_update.TOTAL as double precision)
             where co_seq_leito_espec_h = reg_generica_update.co_seq_leito_espec_h;
        end if;


     end loop;

  end loop;

  return 1;
  end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."carga_tb_leito_espec_h_municipio" (p_co_ppi varchar, parametrizacao_zero boolean) RETURNS boolean AS
$body$
DECLARE
      reg_com_forma record;
      reg_generica record;
      reg_generica_update record;
      reg_generica_insert record;
      reg_generica_prod_prop record;
      reg_perc_total record;
      reg_perc record;
      reg_carga record;

      v_sequence numeric;
      v_co_uf_ibge varchar;
      v_co_uf_ibge_like varchar;
      v_ppi varchar;
      v_codsequencial varchar;


      v_vl_medio_proprio numeric;
      v_vl_medio_referenciado numeric;
      v_qt_fisico numeric;
      v_vl_distribuicao numeric;

      v_vl_medio_producao_propria numeric;
      v_vl_medio_producao_referenciada numeric;

begin

  v_co_uf_ibge = substr(p_co_ppi,2,2);
  v_ppi = substr(p_co_ppi,Length(p_co_ppi)-3,4);
  v_co_uf_ibge_like = v_co_uf_ibge||'%';

  delete from dbsisppi.tb_leito_espec_h_munic
  where substr(co_seq_leito_espec_h_munic,17,4) = v_ppi;

  ALTER SEQUENCE "dbsisppi"."sq_leitoesphmun_coseqleiesphmu"
  INCREMENT 1  MINVALUE 1
  MAXVALUE 9223372036854775807  RESTART 1
  CACHE 1  NO CYCLE;


-- (3,94 sec)
  for reg_com_forma   in
      select distinct
      d.tp_complexidade, d.co_financiamento
      from dbsisppi.tb_destaque d
      where d.co_ppi = p_co_ppi
      and d.co_financiamento <> 99
      and d.co_financiamento <> 98
      and d.tp_complexidade = 2
  loop

      --  carga para os que tem produo propria  -- 2,20 -- 1626
     for reg_generica in
        select
        d.co_seq_destaque,
        b.co_municipio_ibge_res,
        sum(b.qt_procedimento_aprovado) as fisico,
        sum(b.vl_procedimento_aprovado) as financeiro,
        sum(b.vl_procedimento_aprovado) / sum(b.qt_procedimento_aprovado) as vm
        from dbsisppi.tb_base_gerada_sih b
        inner join dbsisppi.tb_destaque d
        on b.co_especialidade = d.co_especialidade
        and b.co_leito = d.co_leito
        and b.co_financiamento = d.co_financiamento
        and b.tp_complexidade = d.tp_complexidade
        and b.co_ppi = d.co_ppi
        where b.co_financiamento = reg_com_forma.co_financiamento
        and b.tp_complexidade = reg_com_forma.tp_complexidade
        and b.co_ppi = p_co_ppi

        and b.co_municipio_ibge_mov like v_co_uf_ibge_like
        and b.co_municipio_ibge_res like v_co_uf_ibge_like

        and b.qt_procedimento_aprovado > 0
        group by  d.co_seq_destaque, b.co_municipio_ibge_res
      loop


        if (parametrizacao_zero) then
         -- v_vl_medio_proprio = 0;
          v_qt_fisico = 0;
        else
        --  v_vl_medio_proprio = reg_generica.vm;
          v_qt_fisico = reg_generica.fisico;
        end if;

        select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_leitoesphmun_coseqleiesphmu',reg_generica.co_municipio_ibge_res) into v_sequence;

        INSERT INTO dbsisppi.tb_leito_espec_h_munic
         (co_seq_leito_espec_h_munic,
         co_destaque,
         vl_distribuicao,
         vl_medio_proprio,
         vl_medio_referenciado,
         qt_fisico_producao,
         qt_fisico,
         vl_distribuicao_producao,
         qt_fisico_producao_propria,
         vl_medio_producao_propria,
         qt_fisico_producao_referenciad,
         vl_medio_producao_referenciada
         ) VALUES (
         v_sequence, -- co_seq_leito_espec_h
         reg_generica.co_seq_destaque, --co_destaque
         0,  -- vl_distribuicao -- rotina a parte
         0, -- v_vl_medio_proprio  vl_medio_proprio
         0, -- vl_medio_referenciado -- rotina a parte
         reg_generica.fisico, -- qt_fisico_producao
         v_qt_fisico, -- qt_fisico
         0, -- vl_distribuicao_producao -- rotina a parte
         0, -- reg_generica.fisico, -- qt_fisico_producao_propria
         0, -- reg_generica.vm, -- vl_medio_producao_propria
         0, -- qt_fisico_producao_referenciad -- rotina a parte
         0 -- vl_medio_producao_referenciada -- rotina a parte
         );

      end loop;

      -- atualiza os que tem produao referenciada    -- 1,45
      for reg_generica_update in
          select
          d.co_seq_destaque,
          b.co_municipio_ibge_mov,
          sum(b.qt_procedimento_aprovado) as fisico,
          sum(b.vl_procedimento_aprovado) as financeiro,
          sum(b.vl_procedimento_aprovado) / sum(b.qt_procedimento_aprovado) as vm
          from dbsisppi.tb_base_gerada_sih b
          inner join dbsisppi.tb_destaque d
          on b.co_especialidade = d.co_especialidade
          and b.co_leito = d.co_leito
          and b.co_financiamento = d.co_financiamento
          and b.tp_complexidade = d.tp_complexidade
          and b.co_ppi = d.co_ppi
          where b.co_financiamento = reg_com_forma.co_financiamento
          and b.tp_complexidade = reg_com_forma.tp_complexidade
          and b.co_ppi = p_co_ppi

          and b.co_municipio_ibge_mov like v_co_uf_ibge_like
          and b.co_municipio_ibge_res like v_co_uf_ibge_like
          and b.co_municipio_ibge_res <> b.co_municipio_ibge_mov

          and b.qt_procedimento_aprovado > 0
          group by d.co_seq_destaque, b.co_municipio_ibge_mov

      loop

        if (parametrizacao_zero) then
          v_vl_medio_referenciado = 0;
          v_qt_fisico = 0;
        else
          v_vl_medio_referenciado = reg_generica_update.vm;
          v_qt_fisico = reg_generica_update.fisico;
        end if;


         update dbsisppi.tb_leito_espec_h_munic set
         -- qt_fisico_producao = qt_fisico_producao + reg_generica_update.fisico,
         -- qt_fisico = qt_fisico + v_qt_fisico,
         vl_medio_referenciado = v_vl_medio_referenciado,
         vl_medio_producao_referenciada = reg_generica_update.vm,
         qt_fisico_producao_referenciad = reg_generica_update.fisico
         where co_destaque = reg_generica_update.co_seq_destaque
         and substr(co_seq_leito_espec_h_munic,8,6) = reg_generica_update.co_municipio_ibge_mov;

      end loop;

     -- carga para os que tem produo referenciada
      for reg_generica_insert in
          select
          d.co_seq_destaque,
          b.co_municipio_ibge_mov,
          sum(b.qt_procedimento_aprovado) as fisico,
          sum(b.vl_procedimento_aprovado) as financeiro,
          sum(b.vl_procedimento_aprovado) / sum(b.qt_procedimento_aprovado) as vm
          from dbsisppi.tb_base_gerada_sih b
          inner join dbsisppi.tb_destaque d
          on b.co_especialidade = d.co_especialidade
          and b.co_leito = d.co_leito
          and b.co_financiamento = d.co_financiamento
          and b.tp_complexidade = d.tp_complexidade
          and b.co_ppi = d.co_ppi
          where b.co_financiamento = reg_com_forma.co_financiamento
          and b.tp_complexidade = reg_com_forma.tp_complexidade
          and b.co_ppi = p_co_ppi

          and b.co_municipio_ibge_mov like v_co_uf_ibge_like
          and b.co_municipio_ibge_res like v_co_uf_ibge_like
          and b.co_municipio_ibge_res <> b.co_municipio_ibge_mov

          and b.qt_procedimento_aprovado > 0
          and d.co_seq_destaque||b.co_municipio_ibge_mov not in
          (
          select
          m.co_destaque||substr(m.co_seq_leito_espec_h_munic,8,6)
          from dbsisppi.tb_leito_espec_h_munic m
          inner join dbsisppi.tb_destaque d
          on m.co_destaque = d.co_seq_destaque
          where d.co_financiamento = reg_com_forma.co_financiamento
          and d.tp_complexidade = reg_com_forma.tp_complexidade
          and d.co_ppi = p_co_ppi
          )
          group by d.co_seq_destaque, b.co_municipio_ibge_mov
      loop

        if (parametrizacao_zero) then
          v_vl_medio_referenciado = 0;
          v_qt_fisico = 0;
        else
          v_vl_medio_referenciado = reg_generica_insert.vm;
          v_qt_fisico = reg_generica_insert.fisico;
        end if;

        select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_leitoesphmun_coseqleiesphmu',reg_generica_insert.co_municipio_ibge_mov) into v_sequence;

        INSERT INTO dbsisppi.tb_leito_espec_h_munic
         (co_seq_leito_espec_h_munic,
         co_destaque,
         vl_distribuicao,
         vl_medio_proprio,
         vl_medio_referenciado,
         qt_fisico_producao,
         qt_fisico,
         vl_distribuicao_producao,
         qt_fisico_producao_propria,
         vl_medio_producao_propria,
         qt_fisico_producao_referenciad,
         vl_medio_producao_referenciada
         ) VALUES (
         v_sequence, -- co_seq_leito_espec_h
         reg_generica_insert.co_seq_destaque, --co_destaque
         0,  -- vl_distribuicao -- rotina a parte
         0, -- vl_medio_proprio
         v_vl_medio_referenciado, -- vl_medio_referenciado -- rotina a parte
         0, -- reg_generica_insert.fisico, -- qt_fisico_producao
         0, -- v_qt_fisico, -- qt_fisico
         0, -- vl_distribuicao_producao -- rotina a parte
         0, -- qt_fisico_producao_propria
         0, -- vl_medio_producao_propria
         reg_generica_insert.fisico, -- qt_fisico_producao_referenciad -- rotina a parte
         reg_generica_insert.vm -- vl_medio_producao_referenciada -- rotina a parte
         );


      end loop;

    -- carga para os que tem produo propria
    for reg_generica_prod_prop in
        select
        em.co_seq_leito_espec_h_munic,
        d.co_seq_destaque,
        b.co_municipio_ibge_mov,
        sum(b.qt_procedimento_aprovado) as fisico,
        sum(b.vl_procedimento_aprovado) as financeiro,
        sum(b.vl_procedimento_aprovado) / sum(b.qt_procedimento_aprovado) as vm
        from dbsisppi.tb_base_gerada_sih b
        inner join dbsisppi.tb_destaque d
        on b.co_especialidade = d.co_especialidade
        and b.co_leito = d.co_leito
        and b.co_financiamento = d.co_financiamento
        and b.tp_complexidade = d.tp_complexidade
        and b.co_ppi = d.co_ppi
        left outer join dbsisppi.tb_leito_espec_h_munic em
        on d.co_seq_destaque = em.co_destaque
        and b.co_municipio_ibge_mov = substr(em.co_seq_leito_espec_h_munic,8,6)
        where b.co_financiamento = reg_com_forma.co_financiamento
        and b.tp_complexidade = reg_com_forma.tp_complexidade
        and b.co_ppi = p_co_ppi
        and b.co_municipio_ibge_mov like v_co_uf_ibge_like
        and b.co_municipio_ibge_res like v_co_uf_ibge_like
        and b.co_municipio_ibge_mov = b.co_municipio_ibge_res
        and b.qt_procedimento_aprovado > 0
        group by  d.co_seq_destaque, b.co_municipio_ibge_mov, em.co_seq_leito_espec_h_munic
        loop

            if (parametrizacao_zero) then
              v_vl_medio_proprio = 0;
            else
              v_vl_medio_proprio = reg_generica_prod_prop.vm;
            end if;


           if (reg_generica_prod_prop.co_seq_leito_espec_h_munic is not null ) then
              update dbsisppi.tb_leito_espec_h_munic set
              vl_medio_proprio = v_vl_medio_proprio,
              vl_medio_producao_propria = reg_generica_prod_prop.vm,
              qt_fisico_producao_propria = reg_generica_prod_prop.fisico
              where co_seq_leito_espec_h_munic = reg_generica_prod_prop.co_seq_leito_espec_h_munic;

           else

            select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_leitoesphmun_coseqleiesphmu',reg_generica_prod_prop.co_municipio_ibge_mov) into v_sequence;

            INSERT INTO dbsisppi.tb_leito_espec_h_munic
             (co_seq_leito_espec_h_munic,
             co_destaque,
             vl_distribuicao,
             vl_medio_proprio,
             vl_medio_referenciado,
             qt_fisico_producao,
             qt_fisico,
             vl_distribuicao_producao,
             qt_fisico_producao_propria,
             vl_medio_producao_propria,
             qt_fisico_producao_referenciad,
             vl_medio_producao_referenciada
             ) VALUES (
             v_sequence, -- co_seq_leito_espec_h
             reg_generica_prod_prop.co_seq_destaque, --co_destaque
             0,  -- vl_distribuicao -- rotina a parte
             v_vl_medio_proprio, -- vl_medio_proprio
             0, -- vl_medio_referenciado -- rotina a parte
             0, -- reg_generica_insert.fisico, -- qt_fisico_producao
             0, -- v_qt_fisico, -- qt_fisico
             0, -- vl_distribuicao_producao -- rotina a parte
             reg_generica_prod_prop.fisico, -- qt_fisico_producao_propria
             reg_generica_prod_prop.vm, -- vl_medio_producao_propria
             0, -- qt_fisico_producao_referenciad -- rotina a parte
             0 -- vl_medio_producao_referenciada -- rotina a parte
             );

           end if;


        end loop;

  end loop;


  -- atualiza o percentual   -- 2,94 sec
  for reg_perc_total in
      select
      d.co_financiamento,
      d.tp_complexidade,
      substr(l.co_seq_leito_espec_h_munic,8,6) as munic,
      sum (l.qt_fisico_producao) as fisico
      from dbsisppi.tb_leito_espec_h_munic l
      inner join dbsisppi.tb_destaque d
      on l.co_destaque = d.co_seq_destaque
      where d.co_ppi = p_co_ppi
      and d.co_financiamento <> 99
      and d.co_financiamento <> 98
      and l.qt_fisico_producao > 0
      group by d.co_financiamento, d.tp_complexidade,
      substr(l.co_seq_leito_espec_h_munic,8,6)

  loop

      for reg_perc in
        select l.co_seq_leito_espec_h_munic,
        (l.qt_fisico_producao * 100 / reg_perc_total.fisico) as perc
        from dbsisppi.tb_leito_espec_h_munic l
        inner join dbsisppi.tb_destaque d
        on l.co_destaque = d.co_seq_destaque
        where d.co_ppi = p_co_ppi
        and substr(l.co_seq_leito_espec_h_munic,8,6) = reg_perc_total.munic
        and d.co_financiamento = reg_perc_total.co_financiamento
        and d.tp_complexidade =  reg_perc_total.tp_complexidade
      loop

        if (parametrizacao_zero) then
             update dbsisppi.tb_leito_espec_h_munic
             set vl_distribuicao_producao = cast(reg_perc.perc as double precision)
             where co_seq_leito_espec_h_munic = reg_perc.co_seq_leito_espec_h_munic;
        else
             update dbsisppi.tb_leito_espec_h_munic
             set vl_distribuicao_producao = cast(reg_perc.perc as double precision),
             vl_distribuicao = cast(reg_perc.perc as double precision)
             where co_seq_leito_espec_h_munic = reg_perc.co_seq_leito_espec_h_munic;

        end if;

      end loop;

  end loop;


  -- Atualiza os destacados
  for reg_generica in
    select d.co_seq_destaque, d.co_financiamento, d.tp_complexidade,
    substr(l.co_seq_leito_espec_h_munic,8,6) as munic,
    l.vl_distribuicao, l.vl_distribuicao,
    l.vl_medio_proprio, l.vl_medio_referenciado,
    l.qt_fisico_producao, l.vl_distribuicao_producao,
    l.qt_fisico_producao_propria, l.vl_medio_producao_propria,
    l.qt_fisico_producao_referenciad, l.vl_medio_producao_referenciada,
    l.qt_fisico, d.co_leito
    from  dbsisppi.tb_destaque d
    inner join  dbsisppi.tb_leito_espec_h_munic l
    on d.co_seq_destaque = l.co_destaque
    where d.st_destacado = 'N'
    and d.co_ppi = p_co_ppi
    and d.co_financiamento <> 99
    and d.co_financiamento <> 98
  loop

        for reg_generica_update in
           select l.co_seq_leito_espec_h_munic, l.qt_fisico,
           qt_fisico_producao_propria, vl_medio_producao_propria,
           qt_fisico_producao_referenciad, vl_medio_producao_referenciada,
           vl_distribuicao, vl_medio_proprio,  vl_medio_referenciado
           from  dbsisppi.tb_destaque d
           inner join  dbsisppi.tb_leito_espec_h_munic  l
           on d.co_seq_destaque = l.co_destaque
           inner join dbsisppi.tb_especialidade_ppi es
           on d.co_especialidade = es.co_especialidade
           where d.co_leito = reg_generica.co_leito
           and (es.no_especialidade = 'CIRURGIA GERAL'
                or es.no_especialidade = 'CLINICA GERAL'
               )
           and d.st_destacado = 'S'
           and d.co_financiamento = reg_generica.co_financiamento
           and d.tp_complexidade = reg_generica.tp_complexidade
           and substr(l.co_seq_leito_espec_h_munic,8,6) = reg_generica.munic
           and d.co_ppi = p_co_ppi
        loop

         if reg_generica.qt_fisico_producao_propria + reg_generica_update.qt_fisico_producao_propria > 0 then
             v_vl_medio_producao_propria=
                      ((reg_generica.qt_fisico_producao_propria * reg_generica.vl_medio_producao_propria)+
                        (reg_generica_update.qt_fisico_producao_propria * reg_generica_update.vl_medio_producao_propria)
                       )/(reg_generica.qt_fisico_producao_propria + reg_generica_update.qt_fisico_producao_propria);
          else
             v_vl_medio_producao_propria = 0;
          end if;

          if reg_generica.qt_fisico_producao_referenciad + reg_generica_update.qt_fisico_producao_referenciad > 0 then
            v_vl_medio_producao_referenciada=
                  ((reg_generica.qt_fisico_producao_referenciad * reg_generica.vl_medio_producao_referenciada)+
                    (reg_generica_update.qt_fisico_producao_referenciad * reg_generica_update.vl_medio_producao_referenciada)
                   )/(reg_generica.qt_fisico_producao_referenciad + reg_generica_update.qt_fisico_producao_referenciad);
          else
            v_vl_medio_producao_referenciada= 0;
          end if;


          if reg_generica.qt_fisico + reg_generica_update.qt_fisico > 0 then
             v_vl_medio_proprio= ((reg_generica.qt_fisico * reg_generica.vl_medio_proprio)+
                                   (reg_generica_update.qt_fisico * reg_generica_update.vl_medio_proprio)
                                  )/(reg_generica.qt_fisico + reg_generica_update.qt_fisico);
          else
             v_vl_medio_proprio = 0;
          end if;

          if reg_generica.qt_fisico_producao_referenciad + reg_generica_update.qt_fisico_producao_referenciad > 0 then
             v_vl_medio_referenciado= ((reg_generica.qt_fisico_producao_referenciad * reg_generica.vl_medio_producao_referenciada)+
                                        (reg_generica_update.qt_fisico_producao_referenciad * reg_generica_update.vl_medio_producao_referenciada)
                                       )/(reg_generica.qt_fisico_producao_referenciad + reg_generica_update.qt_fisico_producao_referenciad);

          else
             v_vl_medio_referenciado = 0;
          end if;


        end loop;


        update  dbsisppi.tb_leito_espec_h_munic set
        qt_fisico = qt_fisico + reg_generica.qt_fisico
        ,vl_distribuicao = vl_distribuicao + reg_generica.vl_distribuicao
        ,vl_medio_proprio = v_vl_medio_proprio
        ,vl_medio_referenciado = v_vl_medio_referenciado
        ,qt_fisico_producao = qt_fisico_producao + reg_generica.qt_fisico_producao
        ,vl_distribuicao_producao = vl_distribuicao_producao + reg_generica.vl_distribuicao_producao
        ,qt_fisico_producao_propria = qt_fisico_producao_propria + reg_generica.qt_fisico_producao_propria
        ,vl_medio_producao_propria = v_vl_medio_producao_propria
        ,qt_fisico_producao_referenciad = qt_fisico_producao_referenciad + reg_generica.qt_fisico_producao_referenciad
        ,vl_medio_producao_referenciada = v_vl_medio_producao_referenciada
        where co_seq_leito_espec_h_munic =  reg_generica_update.co_seq_leito_espec_h_munic;

  end loop;


   -- carga para os que nao tem producao
      for reg_carga in
         select de.co_seq_destaque,m.co_municipio_ibge
         from dbgeral.tb_municipio m,
         dbsisppi.tb_destaque de
         where m.co_uf_ibge = v_co_uf_ibge
         and m.co_municipio_ibge <> '530010'
         and m.st_registro_ativo = 'S'
         and m.st_municipio <> ''
         and de.tp_complexidade = 2
         and de.co_ppi = p_co_ppi
         and de.co_seq_destaque||m.co_municipio_ibge not in (
            select
            m.co_destaque||substr(m.co_seq_leito_espec_h_munic,8,6)
            from dbsisppi.tb_leito_espec_h_munic m
            inner join dbsisppi.tb_destaque d
            on m.co_destaque = d.co_seq_destaque
            where d.co_ppi = p_co_ppi
         )

      loop


            select nextval('dbsisppi.sq_leitoesphmun_coseqleiesphmu') into v_codsequencial;

            if Length(v_codsequencial) = 1 then
               v_codsequencial = '0000000'||v_codsequencial;
            else
            if Length(v_codsequencial) = 2 then
               v_codsequencial = '000000'||v_codsequencial;
            else
            if Length(v_codsequencial) = 3 then
               v_codsequencial = '00000'||v_codsequencial;
            else
            if Length(v_codsequencial) = 4 then
               v_codsequencial = '0000'||v_codsequencial;
            else
            if Length(v_codsequencial) = 5 then
               v_codsequencial = '000'||v_codsequencial;
            else
            if Length(v_codsequencial) = 6 then
               v_codsequencial = '00'||v_codsequencial;
            else
            if Length(v_codsequencial) = 7 then
               v_codsequencial = '0'||v_codsequencial;
            end if;
            end if;
            end if;
            end if;
            end if;
            end if;
            end if;

            v_sequence = 2||v_co_uf_ibge||'0000'||reg_carga.co_municipio_ibge||'000'||v_ppi||v_codsequencial;

            INSERT INTO dbsisppi.tb_leito_espec_h_munic
             (co_seq_leito_espec_h_munic,
             co_destaque,
             vl_distribuicao,vl_medio_proprio,vl_medio_referenciado,
             qt_fisico_producao,qt_fisico,vl_distribuicao_producao,
             qt_fisico_producao_propria,vl_medio_producao_propria,
             qt_fisico_producao_referenciad,vl_medio_producao_referenciada
             ) VALUES (
             v_sequence, -- co_seq_leito_espec_h
             reg_carga.co_seq_destaque, --co_destaque
             0,0,0,0,0,0,0,0,0,0);


      end loop;

  return 1;
  end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangencia_a" (p_co_ppi varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;
  ppi varchar;
begin

  ppi = substr(p_co_ppi,length(p_co_ppi)-3,4);

  for reg_abrangencia in
        select
        ee.co_param_alta_comp_a,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_a ee,
        dbsisppi.tb_encaminhador_a ea
        where ee.co_seq_espec_executor_a = ea.co_espec_executor_a
        and substr(ee.co_seq_espec_executor_a,17,4) = ppi

    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangciaa_coseqabrangciaa',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_a (
                  co_seq_abrangencia_a,
                  co_param_alta_comp_a,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia) values
              (v_sequence, reg_abrangencia.co_param_alta_comp_a,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia);

    end loop;


   for reg_abrangencia in

        select a.co_seq_abrangencia_a,
           a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_a aa
        where aa.co_param_alta_comp_a = a.co_param_alta_comp_a
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_a a
        where a.qt_frequencia > 0
        and substr(a.co_seq_abrangencia_a,17,4) = ppi

    loop

      update dbsisppi.tb_abrangencia_a set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_a = reg_abrangencia.co_seq_abrangencia_a;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangencia_h" (p_co_ppi varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;
  ppi varchar;
begin
    ppi = substr(p_co_ppi,length(p_co_ppi)-3,4);

    select * from dbsisppi."FG_FormataZeroEsquerda"(ppi,'4') into ppi;

  for reg_abrangencia in
        select
        ee.co_leito_espec_h,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_h ee,
        dbsisppi.tb_encaminhador_h ea,
        dbsisppi.tb_leito_espec_h p
        where ee.co_seq_espec_executor_h = ea.co_espec_executor_h
        and p.co_seq_leito_espec_h = ee.co_leito_espec_h
        and substr(p.co_seq_leito_espec_h,17,4) = ppi

    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangciah_coseqabrangciah',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_h (
                  co_seq_abrangencia_h,
                  co_leito_espec_h,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia,
                  qt_fisico_distribuido) values
              (v_sequence, reg_abrangencia.co_leito_espec_h,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia,0);

    end loop;


    for reg_abrangencia in

        select a.co_seq_abrangencia_h,
        a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_h aa
        where aa.co_leito_espec_h = a.co_leito_espec_h
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_h a,
        dbsisppi.tb_leito_espec_h p
        where a.co_leito_espec_h = p.co_seq_leito_espec_h
        and a.qt_frequencia > 0
        and substr(p.co_seq_leito_espec_h,17,4) = ppi

    loop

      update dbsisppi.tb_abrangencia_h set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_h = reg_abrangencia.co_seq_abrangencia_h;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangencia_uti" (p_co_ppi varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;
  v_dt_comp_financ_amb varchar;

begin
  select p.dt_comp_proc_unificado
  from dbsisppi.tb_param_cardapio p
  where p.co_ppi = p_co_ppi
  into v_dt_comp_financ_amb;

  for reg_abrangencia in
        select
        ee.co_leito_uti_h,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_uti ee,
        dbsisppi.tb_encaminhador_uti ea,
        dbsisppi.tb_leito_uti_h p
        where ee.co_seq_espec_executor_uti = ea.co_espec_executor_uti
        and p.co_seq_leito_uti_h = ee.co_leito_uti_h
        and p.co_ppi = p_co_ppi


    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangeuti_coseqabrangeuti',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_uti (
                  co_seq_abrangencia_uti,
                  co_leito_uti_h,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia,
                  qt_fisico_distribuido) values
              (v_sequence, reg_abrangencia.co_leito_uti_h,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia,0);

    end loop;


    for reg_abrangencia in

        select a.co_seq_abrangencia_uti,
        a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_uti aa
        where aa.co_leito_uti_h = a.co_leito_uti_h
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_uti a,
        dbsisppi.tb_leito_uti_h p
        where a.co_leito_uti_h = p.co_seq_leito_uti_h
        and a.qt_frequencia > 0
        and p.co_ppi = p_co_ppi


    loop

      update dbsisppi.tb_abrangencia_uti set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_uti = reg_abrangencia.co_seq_abrangencia_uti;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangenciaa_voltapre" (p_co_ppi varchar, p_param_alta_comp_a varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;

begin


  for reg_abrangencia in
        select
        ee.co_param_alta_comp_a,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_a ee,
        dbsisppi.tb_encaminhador_a ea,
        dbsisppi.tb_parametrizacao_alta_comp_a p
        where ee.co_seq_espec_executor_a = ea.co_espec_executor_a
        and p.co_seq_param_alta_comp_a = ee.co_param_alta_comp_a
        and p.co_ppi = p_co_ppi
        and p.co_seq_param_alta_comp_a = p_param_alta_comp_a


    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangciaa_coseqabrangciaa',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_a (
                  co_seq_abrangencia_a,
                  co_param_alta_comp_a,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia) values
              (v_sequence, reg_abrangencia.co_param_alta_comp_a,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia);

    end loop;


    for reg_abrangencia in

        select a.co_seq_abrangencia_a,
        a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_a aa
        where aa.co_param_alta_comp_a = a.co_param_alta_comp_a
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_a a,
        dbsisppi.tb_parametrizacao_alta_comp_a p
        where a.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
        and a.qt_frequencia > 0
        and p.co_ppi = p_co_ppi


    loop

      update dbsisppi.tb_abrangencia_a set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_a = reg_abrangencia.co_seq_abrangencia_a;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangenciah_voltapreliminar" (p_co_ppi varchar, p_co_leito_especialidade varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;
  ppi varchar;

begin
    ppi = substr(p_co_ppi,length(p_co_ppi)-3,4);
    select * from dbsisppi."FG_FormataZeroEsquerda"(ppi,'4') into ppi;

  for reg_abrangencia in
        select
        ee.co_leito_espec_h,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_h ee,
        dbsisppi.tb_encaminhador_h ea,
        dbsisppi.tb_leito_espec_h p
        where ee.co_seq_espec_executor_h = ea.co_espec_executor_h
        and p.co_seq_leito_espec_h = ee.co_leito_espec_h
        and substr(p.co_seq_leito_espec_h,17,4) = ppi
        and ee.co_leito_espec_h = p_co_leito_especialidade
    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangciah_coseqabrangciah',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_h (
                  co_seq_abrangencia_h,
                  co_leito_espec_h,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia,
                  qt_fisico_distribuido) values
              (v_sequence, reg_abrangencia.co_leito_espec_h,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia,0);

    end loop;


    for reg_abrangencia in

        select a.co_seq_abrangencia_h,
        a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_h aa
        where aa.co_leito_espec_h = a.co_leito_espec_h
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_h a,
        dbsisppi.tb_leito_espec_h p
        where a.co_leito_espec_h = p.co_seq_leito_espec_h
        and a.qt_frequencia > 0
        and substr(p.co_seq_leito_espec_h,17,4) = ppi

    loop

      update dbsisppi.tb_abrangencia_h set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_h = reg_abrangencia.co_seq_abrangencia_h;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_abrangenciauti_voltapre" (p_co_ppi varchar, p_co_leito_especialidade varchar) RETURNS boolean AS
$body$
declare
  reg_abrangencia record;
  v_sequence numeric;
  v_dt_comp_financ_amb varchar;

begin
  for reg_abrangencia in
        select
        ee.co_leito_uti_h,
        ee.co_municipio_ibge_mov,
        ea.co_municipio_ibge_res,
        ea.qt_populacao,
        ea.qt_frequencia
        from dbsisppi.tb_espec_executor_uti ee,
        dbsisppi.tb_encaminhador_uti ea,
        dbsisppi.tb_leito_uti_h p
        where ee.co_seq_espec_executor_uti = ea.co_espec_executor_uti
        and p.co_seq_leito_uti_h = ee.co_leito_uti_h
        and p.co_seq_leito_uti_h = p_co_leito_especialidade
        and p.co_ppi = p_co_ppi

    loop
      select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_abrangeuti_coseqabrangeuti',reg_abrangencia.co_municipio_ibge_mov) into v_sequence;

      insert into dbsisppi.tb_abrangencia_uti (
                  co_seq_abrangencia_uti,
                  co_leito_uti_h,
                  co_municipio_ibge_mov,
                  co_municipio_ibge_res,
                  qt_populacao,
                  qt_frequencia,
                  qt_fisico_distribuido) values
              (v_sequence, reg_abrangencia.co_leito_uti_h,
            reg_abrangencia.co_municipio_ibge_mov,
            reg_abrangencia.co_municipio_ibge_res,
            reg_abrangencia.qt_populacao,
            reg_abrangencia.qt_frequencia,0);

    end loop;


    for reg_abrangencia in

        select a.co_seq_abrangencia_uti,
        a.qt_frequencia * 100 /
        (select sum(aa.qt_frequencia)
        from dbsisppi.tb_abrangencia_uti aa
        where aa.co_leito_uti_h = a.co_leito_uti_h
        and aa.co_municipio_ibge_res = a.co_municipio_ibge_res) as perc
        from dbsisppi.tb_abrangencia_uti a,
        dbsisppi.tb_leito_uti_h p
        where a.co_leito_uti_h = p.co_seq_leito_uti_h
        and a.qt_frequencia > 0
        and p.co_ppi = p_co_ppi


    loop

      update dbsisppi.tb_abrangencia_uti set vl_perc = reg_abrangencia.perc
      where co_seq_abrangencia_uti = reg_abrangencia.co_seq_abrangencia_uti;

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_cons_perc_internacao_h_estado" (p_co_uf_ibge varchar, p_co_ppi varchar, parametrizacao_zero boolean) RETURNS boolean AS
$body$
DECLARE
  reg_producao record;
  reg_municipio record;
  v_qt_fisico numeric;
  v_vl_perc_prod numeric;
  v_vl_perc numeric;
  v_sequence_cons_perc_estado numeric;
  v_populacao numeric;

begin
  delete from dbsisppi.tb_cons_perc_internacao_h
  where co_ppi = p_co_ppi;


  for reg_producao in
        select
        d.tp_complexidade, d.co_financiamento,
        coalesce(sum(l.qt_fisico_producao),0) as FisicoProducao
        from dbsisppi.tb_leito_espec_h l,
        dbsisppi.tb_destaque d
        where l.co_destaque = d.co_seq_destaque
        and d.co_ppi = p_co_ppi
        and d.st_destacado = 'S'
        group by 1,2

    loop

        select * from dbsisppi."FG_RetornaPopulacaoEstado"(p_co_uf_ibge, p_co_ppi) into v_populacao;

        if (reg_producao.FisicoProducao > 0) then
          v_vl_perc_prod = (reg_producao.FisicoProducao / v_populacao) * 100;
        else
          v_vl_perc_prod = '0';
        end if;

        if (parametrizacao_zero) then
          v_qt_fisico = 0;
          v_vl_perc = 0;
        else
          v_qt_fisico = reg_producao.FisicoProducao;
          v_vl_perc = v_vl_perc_prod;
        end if;

        select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_conspercinth_coseqconsperc','0') into v_sequence_cons_perc_estado;

        insert into dbsisppi.tb_cons_perc_internacao_h
          (co_seq_cons_perc_int_h, co_ppi, tp_complexidade,
           co_financiamento, vl_perc, qt_fisico, vl_perc_prod,
           qt_fisico_prod, st_atualizar_perc_munic, st_atualizar_vl_medio)
           values( v_sequence_cons_perc_estado,
           cast(p_co_ppi as numeric),
           reg_producao.tp_complexidade, reg_producao.co_financiamento,
           v_vl_perc, v_qt_fisico, v_vl_perc_prod,
           reg_producao.FisicoProducao,'N','N');

    end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_cons_perc_internacao_h_municipio" (p_co_uf_ibge varchar, p_co_ppi varchar, parametrizacao_zero boolean) RETURNS boolean AS
$body$
DECLARE
      reg_producao record;

      v_sequence_cons_perc_municipio  numeric;
      v_qt_fisico numeric;
      v_vl_perc_prod numeric;
      v_vl_perc numeric;
      v_populacao numeric;
 begin

   -- select * from dbsisppi."FG_RetornaPopulacaoEstado"(p_co_uf_ibge, p_co_ppi) into v_populacao;

     for reg_producao in

        select
        b.co_municipio_ibge_res,
        d.co_financiamento,
        d.tp_complexidade,
        trunc(coalesce(sum(b.qt_procedimento_aprovado),0)) as FisicoProducao
        from dbsisppi.tb_destaque d
        inner join dbsisppi.tb_base_gerada_sih b
        on d.co_financiamento = b.co_financiamento
        and d.co_especialidade = b.co_especialidade
        and d.tp_complexidade = b.tp_complexidade
        and d.co_leito = b.co_leito
        and d.CO_PPI = b.co_ppi
        and d.CO_PPI = p_co_ppi
        and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
        and substr(b.co_municipio_ibge_mov,1,2) = substr(p_co_ppi,2,2)
        group by 1,2,3
     loop

       if (reg_producao.FisicoProducao > 0) then

          select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_producao.co_municipio_ibge_res,p_co_ppi) into v_populacao;

          v_vl_perc_prod = (reg_producao.FisicoProducao / v_populacao) * 100;
        else
          v_vl_perc_prod = '0';
        end if;

        if (parametrizacao_zero) then
          v_qt_fisico = 0;
          v_vl_perc = 0;
        else
          v_qt_fisico = reg_producao.FisicoProducao;
          v_vl_perc = v_vl_perc_prod;
        end if;

        select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_conspercinth_coseqconsperc',reg_producao.co_municipio_ibge_res) into v_sequence_cons_perc_municipio;

 --*****************************************************************************
 --  {Insere os dados na tabela}
 --*****************************************************************************
           insert into dbsisppi.tb_cons_perc_internacao_h
                  (co_seq_cons_perc_int_h,
                  co_ppi,
                  tp_complexidade,
                  co_financiamento,
                  vl_perc,
                  qt_fisico,
                  vl_perc_prod,
                  qt_fisico_prod)
           values(
                  v_sequence_cons_perc_municipio,
                  cast(p_co_ppi as numeric),
                  reg_producao.tp_complexidade,
                  reg_producao.co_financiamento,
                  v_vl_perc,
                  v_qt_fisico,
                  v_vl_perc_prod,
                  reg_producao.FisicoProducao);

      end loop;
     return 1;
 end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_encaminhador_a" (p_co_uf_ibge varchar, p_co_ppi varchar) RETURNS boolean AS
$body$
declare
 reg_executor record;
 reg_encaminhador record;
 v_sequence_encaminhador_a numeric;
 v_populacao numeric;

 v_controle varchar;
 v_codigo_param numeric;

 v_fisco_prod numeric;
 v_divisor_trs numeric;

begin
  for reg_executor in
    select e.co_seq_espec_executor_a,
    e.co_municipio_ibge_mov, p.co_financiamento,
    p.co_alta_comp_amb_mod
    from dbsisppi.tb_espec_executor_a e
    inner join dbsisppi.tb_parametrizacao_alta_comp_a p
    on e.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
    where p.co_ppi = p_co_ppi
    and p.co_alta_comp_amb_mod <> 1

  loop
      for reg_encaminhador in
        select b.co_municipio_ibge_res, b.co_habilitacao,
        sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico
        from dbsisppi.tb_base_gerada_sia b
        inner join dbsisppi.rl_altacompambmodal_procedimen mp
        on b.co_procedimento = mp.co_procedimento
        and b.co_ppi = mp.co_ppi
        where  b.co_financiamento = reg_executor.co_financiamento
        and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
        and b.co_ppi = p_co_ppi
        and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
        and b.qt_procedimento_aprovado > 0
        and mp.co_alta_comp_amb_mod = reg_executor.co_alta_comp_amb_mod
        group by 1,2, mp.vl_divisor_trs
      loop

           if (reg_executor.co_alta_comp_amb_mod = '36') and (reg_encaminhador.co_habilitacao <> '2202') then

           else
            if (reg_executor.co_alta_comp_amb_mod = '37') and (reg_encaminhador.co_habilitacao <> '2201') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '39') and (reg_encaminhador.co_habilitacao <> '0303') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '40') and (reg_encaminhador.co_habilitacao <> '0302') then

            else

                  v_fisco_prod = reg_encaminhador.fisico;

                  if (reg_executor.co_alta_comp_amb_mod = 43) then

                          select distinct mp.vl_divisor_oncologia_trs
                          from dbsisppi.rl_altacompamb_modalidade am
                          inner join dbsisppi.rl_altacompambmodal_procedimen mp
                          on am.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
                          where am.co_modalidade = 43
                          into v_divisor_trs;

                    v_fisco_prod = v_fisco_prod/v_divisor_trs;
                  end if;

                  select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminhadora_coseqencamina',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_a;

                  select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

                  insert into dbsisppi.tb_encaminhador_a ( co_seq_encaminhador_a, co_espec_executor_a, co_municipio_ibge_res, qt_populacao, qt_frequencia)
                  values (v_sequence_encaminhador_a, reg_executor.co_seq_espec_executor_a, reg_encaminhador.co_municipio_ibge_res, cast(v_populacao as numeric), v_fisco_prod);

            end if;

            end if;

            end if;

           end if;

      end loop;
  end loop;
return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_encaminhadora_voltapre" (p_co_uf_ibge varchar, p_co_ppi varchar, p_param_alta_comp_a varchar, p_bolsa boolean) RETURNS boolean AS
$body$
declare
 reg_executor record;
 reg_encaminhador record;
 v_sequence_encaminhador_a numeric;
 v_populacao numeric;

 v_controle varchar;
 v_codigo_param numeric;

 v_fisco_prod numeric;
 v_divisor_trs numeric;
begin
 if not (p_bolsa) then

     for reg_executor in
        select e.co_seq_espec_executor_a,
        e.co_municipio_ibge_mov, p.co_financiamento,
        p.co_alta_comp_amb_mod
        from dbsisppi.tb_espec_executor_a e
        inner join dbsisppi.tb_parametrizacao_alta_comp_a p
        on e.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
        where p.co_ppi = p_co_ppi
        and e.co_param_alta_comp_a = p_param_alta_comp_a
      loop
          for reg_encaminhador in
            select b.co_municipio_ibge_res,b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where  b.co_financiamento = reg_executor.co_financiamento
            and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_executor.co_alta_comp_amb_mod
            group by 1,2, mp.vl_divisor_trs
          loop

       if (reg_executor.co_alta_comp_amb_mod = '36') and (reg_encaminhador.co_habilitacao <> '2202') then
          else
            if (reg_executor.co_alta_comp_amb_mod = '37') and (reg_encaminhador.co_habilitacao <> '2201') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '39') and (reg_encaminhador.co_habilitacao <> '0303') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '40') and (reg_encaminhador.co_habilitacao <> '0302') then

            else

            v_fisco_prod = reg_encaminhador.fisico;

            if (reg_executor.co_alta_comp_amb_mod = 43) then

                    select distinct mp.vl_divisor_oncologia_trs
                    from dbsisppi.rl_altacompamb_modalidade am
                    inner join dbsisppi.rl_altacompambmodal_procedimen mp
                    on am.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
                    where am.co_modalidade = 43
                    into v_divisor_trs;

              v_fisco_prod = v_fisco_prod/v_divisor_trs;
            end if;

                select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminhadora_coseqencamina',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_a;

                select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

                insert into dbsisppi.tb_encaminhador_a ( co_seq_encaminhador_a, co_espec_executor_a, co_municipio_ibge_res, qt_populacao, qt_frequencia)
                values (v_sequence_encaminhador_a, reg_executor.co_seq_espec_executor_a, reg_encaminhador.co_municipio_ibge_res, cast(v_populacao as numeric), v_fisco_prod);

                end if;

              end if;

            end if;

           end if;
        end loop;
      end loop;

  end if;
  return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_espec_executor_a" (p_co_uf_ibge varchar, p_co_ppi varchar) RETURNS boolean AS
$body$
declare
  reg_generica record;
  reg_executor record;
  reg_bolsa record;
  v_sequence_executor_a numeric;
   v_fisico numeric;

   v_valor_medio numeric;
   v_fisco_prod numeric;

   v_divisor_trs numeric;

begin


  for reg_generica in
    select p.co_seq_param_alta_comp_a, p.qt_fisico_proposto,
    m.co_alta_comp_amb,p.co_financiamento, p.co_alta_comp_amb_mod,
    co_modalidade
    from dbsisppi.tb_parametrizacao_alta_comp_a p
    inner join dbsisppi.rl_altacompamb_modalidade m
    on p.co_alta_comp_amb_mod = m.co_seq_alta_comp_amb_mod
    where p.co_ppi = p_co_ppi
    and m.co_alta_comp_amb <> 1
    and m.co_modalidade <>   1

  loop

       for reg_executor in
            select b.co_municipio_ibge_mov,  b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,
            coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on  b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where b.co_financiamento = reg_generica.co_financiamento
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_generica.co_alta_comp_amb_mod
            group by 1,2,mp.vl_divisor_trs

          loop

           if (reg_generica.co_alta_comp_amb_mod = '36') and (reg_executor.co_habilitacao <> '2202') then

           else
            if (reg_generica.co_alta_comp_amb_mod = '37') and (reg_executor.co_habilitacao <> '2201') then

            else
            if (reg_generica.co_alta_comp_amb_mod = '39') and (reg_executor.co_habilitacao <> '0303') then

            else
            if (reg_generica.co_alta_comp_amb_mod = '40') and (reg_executor.co_habilitacao <> '0302') then

            else

               v_valor_medio = 0;

               if (reg_executor.fisico > 0) then
                   v_valor_medio = reg_executor.financeiro / reg_executor.fisico;
               end if;

               v_fisco_prod = reg_executor.fisico;

                if (reg_generica.co_alta_comp_amb = '9') and (reg_generica.co_modalidade = 43) then

                        select distinct mp.vl_divisor_oncologia_trs
                        from dbsisppi.rl_altacompamb_modalidade am
                        inner join dbsisppi.rl_altacompambmodal_procedimen mp
                        on am.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
                        where am.co_modalidade = 43
                        into v_divisor_trs;

                  v_fisco_prod = v_fisco_prod/v_divisor_trs;
                end if;


               select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexeca_coseqespecexeca',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_a;

                insert into dbsisppi.tb_espec_executor_a (
                   co_seq_espec_executor_a, co_param_alta_comp_a, co_municipio_ibge_mov,
                   vl_medio_producao, qt_fisico_producao, vl_medio, qt_fisico )
                values (v_sequence_executor_a, reg_generica.co_seq_param_alta_comp_a,
                    reg_executor.co_municipio_ibge_mov, v_valor_medio,
                    v_fisco_prod, v_valor_medio, 0);

            end if;

            end if;

            end if;

           end if;

         end loop;

   end loop;


  for reg_generica in
    select p.co_seq_param_alta_comp_a,
    m.co_alta_comp_amb, p.co_financiamento,
    (case co_alta_comp_amb_mod

      when 42 then 47
      when 43 then 48

      when 39 then 44
      when 40 then 45
      when 41 then 46

    end) as co_alta_comp_amb_mod
    from dbsisppi.tb_parametrizacao_alta_comp_a p
    inner join dbsisppi.rl_altacompamb_modalidade m
    on p.co_alta_comp_amb_mod = m.co_seq_alta_comp_amb_mod
    where p.co_ppi = p_co_ppi
    and m.co_modalidade in (42,43, 39,40,41)

  loop

        if (reg_generica.co_alta_comp_amb_mod = '47') or (reg_generica.co_alta_comp_amb_mod = '48') then

        for reg_executor in

            select b.co_municipio_ibge_mov, b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,
            coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on  b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where b.co_financiamento = reg_generica.co_financiamento
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_generica.co_alta_comp_amb_mod
            group by 1,2,mp.vl_divisor_trs

          loop

             v_valor_medio = 0;

             select a.qt_fisico_producao
             from dbsisppi.tb_parametrizacao_alta_comp_a p,
             dbsisppi.tb_espec_executor_a a
             where a.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
             and a.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and p.co_seq_param_alta_comp_a =  reg_generica.co_seq_param_alta_comp_a
             into v_fisco_prod;

             if (v_fisco_prod > 0) then
                 v_valor_medio = reg_executor.financeiro / v_fisco_prod;
             end if;


             update dbsisppi.tb_espec_executor_a set
             vl_medio_producao = v_valor_medio,
             vl_medio = v_valor_medio
             where co_param_alta_comp_a = reg_generica.co_seq_param_alta_comp_a
             and co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov;


         end loop;
        else

            for reg_executor in

            select b.co_municipio_ibge_mov, b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,
            coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on  b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where b.co_financiamento = reg_generica.co_financiamento
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_generica.co_alta_comp_amb_mod
            and ( b.tp_registro = 'A' or b.tp_registro = 'F')
            group by 1,2,mp.vl_divisor_trs


          loop


            if (reg_generica.co_alta_comp_amb_mod = '44') and (reg_executor.co_habilitacao <> '0303') then

            else
            if (reg_generica.co_alta_comp_amb_mod = '45') and (reg_executor.co_habilitacao <> '0302') then

            else

             v_valor_medio = 0;

             select a.qt_fisico_producao
             from dbsisppi.tb_parametrizacao_alta_comp_a p,
             dbsisppi.tb_espec_executor_a a
             where a.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
             and a.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and p.co_seq_param_alta_comp_a =  reg_generica.co_seq_param_alta_comp_a
             into v_fisco_prod;

             if (v_fisco_prod > 0) then
                 v_valor_medio = reg_executor.financeiro / v_fisco_prod;
             end if;


             update dbsisppi.tb_espec_executor_a set
             vl_medio_producao = v_valor_medio,
             vl_medio = v_valor_medio
             where co_param_alta_comp_a = reg_generica.co_seq_param_alta_comp_a
             and co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov;


          end if;

          end if;

         end loop;

        end if;

   end loop;

-- bolsa
  for reg_bolsa in
    select p.co_seq_param_alta_comp_a,
    p.co_financiamento, p.co_alta_comp_amb_mod
    from dbsisppi.rl_altacompamb_modalidade   m,
    dbsisppi.tb_parametrizacao_alta_comp_a p
    where p.co_alta_comp_amb_mod = m.co_seq_alta_comp_amb_mod
    and m.co_alta_comp_amb = 1
    and m.co_modalidade =   1
    and p.co_ppi = p_co_ppi

  loop

    for reg_executor in
          select b.co_municipio_ibge_mov,
          coalesce(sum(b.qt_procedimento_aprovado),0) as fisico,
          coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as valor_medio
          from dbsisppi.tb_base_gerada_sia b
          inner join dbsisppi.rl_altacompambmodal_procedimen mp
          on  b.co_procedimento = mp.co_procedimento
          and b.co_ppi = mp.co_ppi
          where  b.co_financiamento = reg_bolsa.co_financiamento
          and b.co_ppi = p_co_ppi
          and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
          and b.qt_procedimento_aprovado > 0
          and mp.co_alta_comp_amb_mod = reg_bolsa.co_alta_comp_amb_mod
          group by 1
    loop

            select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexeca_coseqespecexeca',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_a;

          insert into dbsisppi.tb_espec_executor_a (
             co_seq_espec_executor_a, co_param_alta_comp_a, co_municipio_ibge_mov,
             vl_medio_producao, qt_fisico_producao, vl_medio, qt_fisico )
          values (v_sequence_executor_a, reg_bolsa.co_seq_param_alta_comp_a,
              reg_executor.co_municipio_ibge_mov, reg_executor.valor_medio,
              reg_executor.fisico, reg_executor.valor_medio, 0);

    end loop;
 end loop;


    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_espec_executor_h" (p_co_uf_ibge varchar, p_co_ppi varchar) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_executor record;
      reg_encaminhador record;
      v_alta_complexidade integer = 3;
      v_sequence_executor_h numeric;
      v_sequence_encaminhador_h numeric;
      v_populacao  numeric;


begin


  --************************************************************************
  -- SELECT GENRICO PARA O EXECUTOR E ENCAMINHADOR
  --************************************************************************
  for reg_generica in
    select e.co_seq_leito_espec_h,
    de.co_financiamento,
    de.co_leito,
    de.co_especialidade
    from  dbsisppi.tb_leito_espec_h e,
          dbsisppi.tb_destaque de
    where substr(e.co_seq_leito_espec_h, 8, 6) = '000000'
    and substr(e.co_seq_leito_espec_h, 2, 2) = p_co_uf_ibge
    and de.co_ppi = p_co_ppi
    and de.tp_complexidade = v_alta_complexidade
    and e.co_destaque = de.co_seq_destaque
   loop
           --************************************************************************
           -- EXECUTOR - SELECT E INSERT PARA O EXECUTOR
           --************************************************************************
           for reg_executor in
             select b.co_municipio_ibge_mov,
             coalesce(sum(b.qt_procedimento_aprovado),0) as FisicoProducao,
             coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as vl_medio_producao
             from  dbsisppi.tb_base_gerada_sih  b
             where b.tp_complexidade = v_alta_complexidade
             and b.co_financiamento = reg_generica.co_financiamento
             and b.co_leito = reg_generica.co_leito
             and b.co_especialidade = reg_generica.co_especialidade
             and b.co_ppi =p_co_ppi
             and substr(b.co_municipio_ibge_mov,1,2) = p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.qt_procedimento_aprovado > 0
             group by  b.co_municipio_ibge_mov
           loop

               select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexech_coseqespecexech',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_h;

               INSERT INTO dbsisppi.TB_ESPEC_EXECUTOR_H  (
               CO_SEQ_ESPEC_EXECUTOR_H,
               CO_LEITO_ESPEC_H,
               CO_MUNICIPIO_IBGE_MOV,
               VL_MEDIO_PRODUCAO,
               QT_FISICO_PRODUCAO,
               VL_MEDIO,
               QT_FISICO
               )  VALUES
               (v_sequence_executor_h,
               reg_generica.co_seq_leito_espec_h,
               reg_executor.co_municipio_ibge_mov,
               reg_executor.vl_medio_producao,
               reg_executor.FisicoProducao,
               reg_executor.vl_medio_producao,
               0);

           --************************************************************************
           -- ENCAMINHADOR - SELECT E INSERT PARA O ENCAMINHADOR
           --************************************************************************
           for reg_encaminhador in
             select b.co_municipio_ibge_res,
             coalesce(sum(b.qt_procedimento_aprovado),0) as FisicoProducao,
             coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as vl_medio_producao
             from   dbsisppi.tb_base_gerada_sih  b
             where b.tp_complexidade = v_alta_complexidade
             and b.co_financiamento = reg_generica.co_financiamento
             and b.co_leito = reg_generica.co_leito
             and b.co_especialidade =reg_generica.co_especialidade
             and b.co_ppi = p_co_ppi
             and substr(b.co_municipio_ibge_res,1,2) = p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and b.qt_procedimento_aprovado > 0
             group by b.co_municipio_ibge_res

           loop

             select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminhadorh_coseqencaminh',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_h;
             select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

             INSERT INTO dbsisppi.TB_ENCAMINHADOR_H (
             CO_SEQ_ENCAMINHADOR_H,
             CO_ESPEC_EXECUTOR_H,
             CO_MUNICIPIO_IBGE_RES,
             QT_POPULACAO,
             QT_FREQUENCIA)  VALUES
             (v_sequence_encaminhador_h,
             v_sequence_executor_h,
             reg_encaminhador.co_municipio_ibge_res,
             cast(v_populacao as numeric),
             reg_encaminhador.FisicoProducao);

           end loop;
           end loop;
  end loop;
  return 1;
  end;
$body$
LANGUAGE 'plpgsql' VOLATILE RETURNS NULL ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_espec_executor_uti" (p_co_uf_ibge varchar, p_co_ppi varchar) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_executor record;
      reg_encaminhador record;
      v_alta_complexidade integer = 2;
      v_sequence_executor_uti numeric;
      v_sequence_encaminhador_uti numeric;
      v_populacao  numeric;

	  v_dt_comp_financ_amb varchar;
  begin

    select p.dt_comp_proc_unificado
    from dbsisppi.tb_param_cardapio p
    where p.co_ppi = p_co_ppi
    into v_dt_comp_financ_amb;

  --************************************************************************
  -- SELECT GENRICO PARA O EXECUTOR E ENCAMINHADOR
  --************************************************************************
  for reg_generica in
    select h.co_seq_leito_uti_h, h.co_tipo_leito,
    h.co_financiamento, h.tp_identificador
    from   dbsisppi.tb_leito_uti_h   h
    where substr(h.co_seq_leito_uti_h,8,6) = '000000'
    and substr(h.co_seq_leito_uti_h,2,2) = p_co_uf_ibge
    and h.co_ppi = p_co_ppi
    order by h.co_tipo_leito
    loop
           --************************************************************************
           -- EXECUTOR - SELECT E INSERT PARA O EXECUTOR
           --************************************************************************
           for reg_executor in
             select b.co_municipio_ibge_mov,
             coalesce(sum(b.qt_fisico_uti),0) as FisicoProducao,
             coalesce(sum(b.vl_uti)/sum(b.qt_fisico_uti),0) as vl_medio_producao
             from  dbsisppi.tb_base_gerada_sih_uti   b
             where b.co_financiamento = reg_generica.co_financiamento
                   and b.co_tipo_leito = reg_generica.co_tipo_leito
                   and b.co_ppi = p_co_ppi
                   and substr(b.co_municipio_ibge_mov,1,2) = p_co_uf_ibge
                   and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
                   and b.tp_identificador = reg_generica.tp_identificador
                   and b.qt_fisico_uti > 0
                   group by  b.co_municipio_ibge_mov

           loop

               select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexecuti_coseqespexeuti',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_uti;

               INSERT INTO dbsisppi.tb_espec_executor_uti  (
                co_seq_espec_executor_uti,
                co_leito_uti_h,
                co_municipio_ibge_mov,
                vl_medio_producao,
                qt_fisico_producao,
                vl_medio,
                qt_fisico,
                tp_identificador
               )  VALUES
               (v_sequence_executor_uti,
               reg_generica.co_seq_leito_uti_h,
               reg_executor.co_municipio_ibge_mov,
               cast(reg_executor.vl_medio_producao as numeric),
               reg_executor.FisicoProducao,
               cast(reg_executor.vl_medio_producao as numeric),
               0,
               reg_generica.tp_identificador);


           --************************************************************************
           -- ENCAMINHADOR - SELECT E INSERT PARA O ENCAMINHADOR
           --************************************************************************
           for reg_encaminhador in
             select b.co_municipio_ibge_res,
             coalesce(sum(b.qt_fisico_uti),0) as FisicoProducao
             from dbsisppi.tb_base_gerada_sih_uti   b
             where b.co_financiamento = reg_generica.co_financiamento
             and   b.co_tipo_leito = reg_generica.co_tipo_leito
             and b.co_ppi = p_co_ppi
             and substr(b.co_municipio_ibge_res,1,2) =  p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and b.tp_identificador = reg_generica.tp_identificador
             group by  b.co_municipio_ibge_res

           loop

              select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminuti_coseqencaminhuti',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_uti;

			  select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

             INSERT INTO dbsisppi.tb_encaminhador_uti(
              co_seq_encaminhador_uti ,
              co_espec_executor_uti,
              co_municipio_ibge_res,
              qt_populacao,
              qt_frequencia,
              tp_identificador)
             VALUES
             (v_sequence_encaminhador_uti,
             v_sequence_executor_uti,
             reg_encaminhador.co_municipio_ibge_res,
             cast(v_populacao as numeric),
             reg_encaminhador.FisicoProducao,
             reg_generica.tp_identificador);

           end loop;
           end loop;
  end loop;
  return 1;
  end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_especexecutora_voltapre" (p_co_uf_ibge varchar, p_co_ppi varchar, p_param_alta_comp_a varchar, p_bolsa boolean) RETURNS boolean AS
$body$
declare
  reg_generica record;
  reg_executor record;
  v_sequence_executor_a numeric;
  v_populacao numeric;
  v_fisico numeric;

  v_valor_medio numeric;
  v_fisco_prod numeric;

  v_divisor_trs numeric;

  producao integer;

begin



 delete from dbsisppi.tb_espec_executor_a
 where co_param_alta_comp_a = p_param_alta_comp_a;

 delete from dbsisppi.tb_abrangencia_a
 where co_param_alta_comp_a = p_param_alta_comp_a;


 select c.st_parametrizacao_preenchida
        from dbsisppi.tb_configurar_ppi_estadual c
        where c.co_ppi = p_co_ppi
        into producao;


 if not (p_bolsa) then

         for reg_executor in
          select p.co_seq_param_alta_comp_a, b.co_municipio_ibge_mov,rl.co_alta_comp_amb,
          rl.co_modalidade, b.co_habilitacao, mp.co_alta_comp_amb_mod,
          p.qt_fisico_proposto,
          sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,

          coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro

          from dbsisppi.tb_parametrizacao_alta_comp_a p
          inner join dbsisppi.rl_altacompamb_modalidade rl
          on rl.co_seq_alta_comp_amb_mod = p.co_alta_comp_amb_mod
          and substr(p.co_seq_param_alta_comp_a,8,6) = '000000'
          and substr(p.co_seq_param_alta_comp_a,2,2) = p_co_uf_ibge
          inner join dbsisppi.rl_altacompambmodal_procedimen mp
          on rl.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
          and mp.co_ppi = p_co_ppi
          inner join dbsisppi.tb_base_gerada_sia b
          on  b.qt_procedimento_aprovado > 0
          and p.co_financiamento = b.co_financiamento
          and b.co_ppi = p_co_ppi
          and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
          and b.co_procedimento = mp.co_procedimento
          where substr(p.co_seq_param_alta_comp_a,2,2) = p_co_uf_ibge
          and p.co_seq_param_alta_comp_a = p_param_alta_comp_a
          group by 1,2,3,4,5,6,7, mp.vl_divisor_trs

          loop


           if (reg_executor.co_alta_comp_amb_mod = '36') and (reg_executor.co_habilitacao <> '2202') then

           else
            if (reg_executor.co_alta_comp_amb_mod = '37') and (reg_executor.co_habilitacao <> '2201') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '39') and (reg_executor.co_habilitacao <> '0303') then

            else
            if (reg_executor.co_alta_comp_amb_mod = '40') and (reg_executor.co_habilitacao <> '0302') then

            else

             v_valor_medio = 0;

             if (reg_executor.fisico > 0)  then
                 v_valor_medio = reg_executor.financeiro / reg_executor.fisico;
             end if;

               v_fisco_prod = reg_executor.fisico;

              if (reg_executor.co_alta_comp_amb = '9') and (reg_executor.co_modalidade = 43) then

                      select distinct mp.vl_divisor_oncologia_trs
                      from dbsisppi.rl_altacompamb_modalidade am
                      inner join dbsisppi.rl_altacompambmodal_procedimen mp
                      on am.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
                      where am.co_modalidade = 43
                      into v_divisor_trs;

                v_fisco_prod = v_fisco_prod/v_divisor_trs;
              end if;


                select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexeca_coseqespecexeca',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_a;


             if (reg_executor.co_alta_comp_amb = '3') and (producao = 1) then
              insert into dbsisppi.tb_espec_executor_a ( co_seq_espec_executor_a, co_param_alta_comp_a, co_municipio_ibge_mov, vl_medio_producao, qt_fisico_producao, vl_medio, qt_fisico )
              values (v_sequence_executor_a, reg_executor.co_seq_param_alta_comp_a, reg_executor.co_municipio_ibge_mov, v_valor_medio, v_fisco_prod, v_valor_medio, v_fisco_prod);
             else
              insert into dbsisppi.tb_espec_executor_a ( co_seq_espec_executor_a, co_param_alta_comp_a, co_municipio_ibge_mov, vl_medio_producao, qt_fisico_producao, vl_medio, qt_fisico )
              values (v_sequence_executor_a, reg_executor.co_seq_param_alta_comp_a, reg_executor.co_municipio_ibge_mov, v_valor_medio, v_fisco_prod, v_valor_medio, 0);
             end if;

            end if;

            end if;

            end if;

           end if;


          end loop;


  for reg_generica in
    select p.co_seq_param_alta_comp_a,
    m.co_alta_comp_amb, p.co_financiamento,
    (case co_alta_comp_amb_mod

      when 42 then 47
      when 43 then 48

      when 39 then 44
      when 40 then 45
      when 41 then 46

    end) as co_alta_comp_amb_mod
    from dbsisppi.tb_parametrizacao_alta_comp_a p
    inner join dbsisppi.rl_altacompamb_modalidade m
    on p.co_alta_comp_amb_mod = m.co_seq_alta_comp_amb_mod
    where p.co_ppi = p_co_ppi
    and m.co_modalidade in (42,43, 39,40,41)
    and p.co_seq_param_alta_comp_a = p_param_alta_comp_a

  loop
        if (reg_generica.co_alta_comp_amb_mod = '47') or (reg_generica.co_alta_comp_amb_mod = '48') then
       for reg_executor in

            select b.co_municipio_ibge_mov, b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,
            coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on  b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where b.co_financiamento = reg_generica.co_financiamento
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_generica.co_alta_comp_amb_mod
           group by 1,2,mp.vl_divisor_trs


          loop

           /* if (reg_generica.co_alta_comp_amb_mod = '44') and (reg_executor.co_habilitacao <> '0303') then

            else
            if (reg_generica.co_alta_comp_amb_mod = '45') and (reg_executor.co_habilitacao <> '0302') then

            else
           */
               v_valor_medio = 0;

               select a.qt_fisico_producao
               from dbsisppi.tb_parametrizacao_alta_comp_a p,
               dbsisppi.tb_espec_executor_a a
               where a.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
               and a.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
               and p.co_seq_param_alta_comp_a =  reg_generica.co_seq_param_alta_comp_a
               into v_fisco_prod;

               if (v_fisco_prod > 0) then
                   v_valor_medio = reg_executor.financeiro / v_fisco_prod;
               end if;


               update dbsisppi.tb_espec_executor_a set
               vl_medio_producao = v_valor_medio,
               vl_medio = v_valor_medio
               where co_param_alta_comp_a = reg_generica.co_seq_param_alta_comp_a
               and co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov;

          /* end if;

          end if; */

         end loop;
         else
                 for reg_executor in

            select b.co_municipio_ibge_mov, b.co_habilitacao,
            sum(coalesce(b.qt_procedimento_aprovado, 0)) /  coalesce(mp.vl_divisor_trs,1) as fisico,
            coalesce(sum(b.vl_procedimento_aprovado),0) as financeiro
            from dbsisppi.tb_base_gerada_sia b
            inner join dbsisppi.rl_altacompambmodal_procedimen mp
            on  b.co_procedimento = mp.co_procedimento
            and b.co_ppi = mp.co_ppi
            where b.co_financiamento = reg_generica.co_financiamento
            and b.co_ppi = p_co_ppi
            and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
            and b.qt_procedimento_aprovado > 0
            and mp.co_alta_comp_amb_mod = reg_generica.co_alta_comp_amb_mod
            and ( b.tp_registro = 'A' or b.tp_registro = 'F')
            group by 1,2,mp.vl_divisor_trs


          loop

            if (reg_generica.co_alta_comp_amb_mod = '44') and (reg_executor.co_habilitacao <> '0303') then

            else
            if (reg_generica.co_alta_comp_amb_mod = '45') and (reg_executor.co_habilitacao <> '0302') then

            else

               v_valor_medio = 0;

               select a.qt_fisico_producao
               from dbsisppi.tb_parametrizacao_alta_comp_a p,
               dbsisppi.tb_espec_executor_a a
               where a.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
               and a.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
               and p.co_seq_param_alta_comp_a =  reg_generica.co_seq_param_alta_comp_a
               into v_fisco_prod;

               if (v_fisco_prod > 0) then
                   v_valor_medio = reg_executor.financeiro / v_fisco_prod;
               end if;


               update dbsisppi.tb_espec_executor_a set
               vl_medio_producao = v_valor_medio,
               vl_medio = v_valor_medio
               where co_param_alta_comp_a = reg_generica.co_seq_param_alta_comp_a
               and co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov;

           end if;

          end if;

         end loop;

         end if;
   end loop;


  end if;

  if (p_bolsa) then

          for reg_executor in
           select p.co_seq_param_alta_comp_a, b.co_municipio_ibge_mov,
           coalesce(sum(b.qt_procedimento_aprovado),0) as fisico,
           coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as valor_medio
           from dbsisppi.tb_parametrizacao_alta_comp_a p
           inner join dbsisppi.rl_altacompamb_modalidade rl
           on rl.co_seq_alta_comp_amb_mod = p.co_alta_comp_amb_mod
           and substr(p.co_seq_param_alta_comp_a,8,6) = '000000'
           and substr(p.co_seq_param_alta_comp_a,2,2) = p_co_uf_ibge
           inner join dbsisppi.rl_altacompambmodal_procedimen mp
           on rl.co_seq_alta_comp_amb_mod = mp.co_alta_comp_amb_mod
           and mp.co_ppi = p_co_ppi
           inner join dbsisppi.tb_base_gerada_sia b
           on b.qt_procedimento_aprovado > 0
           and p.co_financiamento = b.co_financiamento
           and b.co_ppi = p_co_ppi
           and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
           and b.co_procedimento = mp.co_procedimento
           where substr(p.co_seq_param_alta_comp_a,2,2) = p_co_uf_ibge
           and p.co_seq_param_alta_comp_a = p_param_alta_comp_a
           group by 1,2

          loop

            select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexeca_coseqespecexeca',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_a;

            insert into dbsisppi.tb_espec_executor_a ( co_seq_espec_executor_a, co_param_alta_comp_a, co_municipio_ibge_mov, vl_medio_producao, qt_fisico_producao, vl_medio, qt_fisico )
            values (v_sequence_executor_a, reg_executor.co_seq_param_alta_comp_a, reg_executor.co_municipio_ibge_mov, reg_executor.valor_medio, reg_executor.fisico, reg_executor.valor_medio, 0);

          end loop;

  end if;

  return 1;

end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_especexecutorh_voltapreliminar" (p_co_uf_ibge varchar, p_co_ppi varchar, p_co_leito_especialidade varchar) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_executor record;
      reg_encaminhador record;
      v_alta_complexidade integer = 3;
      v_sequence_executor_h numeric;
      v_sequence_encaminhador_h numeric;
      v_populacao  numeric;
      v_co_Leito_Especialidade varchar;
  begin

  --************************************************************************
  -- SELECT GENRICO PARA O EXECUTOR E ENCAMINHADOR
  --************************************************************************


  delete from dbsisppi.tb_espec_executor_h  where co_leito_espec_h = p_Co_Leito_Especialidade;
  delete from dbsisppi.tb_abrangencia_h  where co_leito_espec_h = p_Co_Leito_Especialidade;

  for reg_generica in
    select e.co_seq_leito_espec_h,
    de.co_financiamento,
    de.co_leito,
    de.co_especialidade
    from  dbsisppi.tb_leito_espec_h e,
          dbsisppi.tb_destaque de
    where substr(e.co_seq_leito_espec_h, 8, 6) = '000000'
    and substr(e.co_seq_leito_espec_h, 2, 2) = p_co_uf_ibge
    and de.co_ppi = p_co_ppi
    and de.tp_complexidade = v_alta_complexidade
    and e.co_destaque = de.co_seq_destaque
    and e.co_seq_leito_espec_h = p_Co_Leito_Especialidade

  loop
           --************************************************************************
           -- EXECUTOR - SELECT E INSERT PARA O EXECUTOR
           --************************************************************************
           for reg_executor in
             select b.co_municipio_ibge_mov,
             coalesce(sum(b.qt_procedimento_aprovado),0) as FisicoProducao,
             coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as vl_medio_producao
             from  dbsisppi.tb_base_gerada_sih  b
             where b.tp_complexidade = v_alta_complexidade
             and b.co_financiamento = reg_generica.co_financiamento
             and b.co_leito = reg_generica.co_leito
             and b.co_especialidade = reg_generica.co_especialidade
             and b.co_ppi =p_co_ppi
             and substr(b.co_municipio_ibge_mov,1,2) = p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.qt_procedimento_aprovado > 0
             group by  b.co_municipio_ibge_mov
           loop

               select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexech_coseqespecexech',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_h;

               INSERT INTO dbsisppi.TB_ESPEC_EXECUTOR_H  (
               CO_SEQ_ESPEC_EXECUTOR_H,
               CO_LEITO_ESPEC_H,
               CO_MUNICIPIO_IBGE_MOV,
               VL_MEDIO_PRODUCAO,
               QT_FISICO_PRODUCAO,
               VL_MEDIO,
               QT_FISICO
               )  VALUES
               (v_sequence_executor_h,
               reg_generica.co_seq_leito_espec_h,
               reg_executor.co_municipio_ibge_mov,
               reg_executor.vl_medio_producao,
               reg_executor.FisicoProducao,
               reg_executor.vl_medio_producao,
               0);

           --************************************************************************
           -- ENCAMINHADOR - SELECT E INSERT PARA O ENCAMINHADOR
           --************************************************************************
           for reg_encaminhador in
             select b.co_municipio_ibge_res,
             coalesce(sum(b.qt_procedimento_aprovado),0) as FisicoProducao,
             coalesce(sum(b.vl_procedimento_aprovado)/sum(b.qt_procedimento_aprovado),0) as vl_medio_producao,
             coalesce(sum(b.vl_procedimento_aprovado),0) as Financeiro
             from   dbsisppi.tb_base_gerada_sih  b
             where b.tp_complexidade = v_alta_complexidade
             and b.co_financiamento = reg_generica.co_financiamento
             and b.co_leito = reg_generica.co_leito
             and b.co_especialidade =reg_generica.co_especialidade
             and b.co_ppi = p_co_ppi
             and substr(b.co_municipio_ibge_res,1,2) = p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and b.qt_procedimento_aprovado > 0
             group by b.co_municipio_ibge_res

           loop

             select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminhadorh_coseqencaminh',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_h;
             select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

             INSERT INTO dbsisppi.TB_ENCAMINHADOR_H (
             CO_SEQ_ENCAMINHADOR_H,
             CO_ESPEC_EXECUTOR_H,
             CO_MUNICIPIO_IBGE_RES,
             QT_POPULACAO,
             QT_FREQUENCIA)  VALUES
             (v_sequence_encaminhador_h,
             v_sequence_executor_h,
             reg_encaminhador.co_municipio_ibge_res,
             cast(v_populacao as numeric),
             reg_encaminhador.FisicoProducao);

           end loop;
           end loop;
  end loop;
  return 1;
  end;
$body$
LANGUAGE 'plpgsql' VOLATILE RETURNS NULL ON NULL INPUT SECURITY INVOKER;




CREATE OR REPLACE FUNCTION "dbsisppi"."cargatb_especexecutoruti_voltapre" (p_co_uf_ibge varchar, p_co_ppi varchar, p_co_leito_especialidade varchar) RETURNS boolean AS
$body$
DECLARE
      reg_generica record;
      reg_executor record;
      reg_encaminhador record;
      v_alta_complexidade integer = 2;
      v_sequence_executor_uti numeric;
      v_sequence_encaminhador_uti numeric;
      v_populacao  numeric;

  begin

  delete from dbsisppi.tb_espec_executor_uti  where co_leito_uti_h = p_co_leito_especialidade;
  delete from dbsisppi.tb_abrangencia_uti  where co_leito_uti_h = p_co_leito_especialidade;

  --************************************************************************
  -- SELECT GENRICO PARA O EXECUTOR E ENCAMINHADOR
  --************************************************************************
  for reg_generica in
    select u.co_seq_leito_uti_h,
    u.co_financiamento,
    u.co_tipo_leito,
    u.tp_identificador
    from  dbsisppi.tb_leito_uti_h u
    where substr(u.co_seq_leito_uti_h,8,6) = '000000'
    and substr(u.co_seq_leito_uti_h,2,2) = p_co_uf_ibge
    and u.co_ppi  = p_co_ppi
    and u.co_seq_leito_uti_h = p_co_leito_especialidade

  loop
           --************************************************************************
           -- EXECUTOR - SELECT E INSERT PARA O EXECUTOR
           --************************************************************************
           for reg_executor in
             select b.co_municipio_ibge_mov,
             coalesce(sum(b.qt_fisico_uti),0) as FisicoProducao,
             coalesce(sum(b.vl_uti)/sum(b.qt_fisico_uti),0) as vl_medio_producao
             from  dbsisppi.tb_base_gerada_sih_uti   b
             where b.co_financiamento = reg_generica.co_financiamento
                   and b.co_tipo_leito = reg_generica.co_tipo_leito
                   and b.co_ppi =p_co_ppi
                   and substr(b.co_municipio_ibge_mov,1,2) = p_co_uf_ibge
                   and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
                   and b.tp_identificador = reg_generica.tp_identificador
                   group by  b.co_municipio_ibge_mov

           loop

               select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_especexecuti_coseqespexeuti',reg_executor.co_municipio_ibge_mov) into v_sequence_executor_uti;

               INSERT INTO dbsisppi.tb_espec_executor_uti  (
                co_seq_espec_executor_uti,
                co_leito_uti_h,
                co_municipio_ibge_mov,
                vl_medio_producao,
                qt_fisico_producao,
                vl_medio,
                qt_fisico,
                tp_identificador


               )  VALUES
               (v_sequence_executor_uti,
               reg_generica.co_seq_leito_uti_h,
               reg_executor.co_municipio_ibge_mov,
               cast(reg_executor.vl_medio_producao as numeric),
               reg_executor.FisicoProducao,
               cast(reg_executor.vl_medio_producao as numeric),
               0,
               reg_generica.tp_identificador);


           --************************************************************************
           -- ENCAMINHADOR - SELECT E INSERT PARA O ENCAMINHADOR
           --************************************************************************
           for reg_encaminhador in
             select b.co_municipio_ibge_res,
             coalesce(sum(b.qt_fisico_uti),0) as FisicoProducao
             from dbsisppi.tb_base_gerada_sih_uti   b
             where b.co_financiamento = reg_generica.co_financiamento
             and   b.co_tipo_leito = reg_generica.co_tipo_leito
             and b.co_ppi = p_co_ppi
             and substr(b.co_municipio_ibge_res,1,2) =  p_co_uf_ibge
             and substr(b.co_municipio_ibge_res,1,2) = substr(p_co_ppi,2,2)
             and b.co_municipio_ibge_mov = reg_executor.co_municipio_ibge_mov
             and b.tp_identificador = reg_generica.tp_identificador
             group by  b.co_municipio_ibge_res

           loop

              select * from dbsisppi."FG_BuscaCodigoSequencial"(p_co_ppi,'sq_encaminuti_coseqencaminhuti',reg_encaminhador.co_municipio_ibge_res) into v_sequence_encaminhador_uti;

			  select * from dbsisppi."FG_RetornaPopulacaoMunicipio"(reg_encaminhador.co_municipio_ibge_res,p_co_ppi) into v_populacao;

             INSERT INTO dbsisppi.tb_encaminhador_uti(
              co_seq_encaminhador_uti ,
              co_espec_executor_uti,
              co_municipio_ibge_res,
              qt_populacao,
              qt_frequencia,
              tp_identificador)
             VALUES
             (v_sequence_encaminhador_uti,
             v_sequence_executor_uti,
             reg_encaminhador.co_municipio_ibge_res,
             cast(v_populacao as numeric),
             reg_encaminhador.FisicoProducao,
             reg_generica.tp_identificador);

           end loop;
           end loop;
  end loop;
  return 1;
  end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."carga_tb_leito_espec_h_municipio_atualiza" (p_co_ppi varchar, complexidade varchar, formafinan varchar, tipo integer) RETURNS boolean AS
$body$
DECLARE
  reg_generica record;
  reg_munic record;
  reg_perc record;

  v_uf varchar;

  v_qt_fisico numeric;
begin
   -- Tipo
   -- 1 Tela - Percentual de Participao por Tipo/Especialidade do leito
   -- 2 Tela - Valor Mdio por Tipo/Especialidade do leito
   for reg_generica in
     select de.co_seq_destaque,de.co_especialidade,
     de.co_financiamento, de.co_leito, de.tp_complexidade,
     de.st_destacado,e.vl_medio, e.vl_distribuicao
     from dbsisppi.tb_leito_espec_h e,
     dbsisppi.tb_destaque de
     where e.co_destaque = de.co_seq_destaque
     and de.co_ppi = p_co_ppi
     and de.tp_complexidade = complexidade
     and de.co_financiamento = formafinan
   loop
    if (tipo = 1) then
      update dbsisppi.tb_leito_espec_h_munic
        set vl_distribuicao = reg_generica.vl_distribuicao,
        qt_fisico = 0
        where co_destaque = reg_generica.co_seq_destaque;
    else
      update dbsisppi.tb_leito_espec_h_munic
        set vl_medio_proprio = reg_generica.vl_medio,
        vl_medio_referenciado = reg_generica.vl_medio
        where co_destaque = reg_generica.co_seq_destaque;

    end if;

   end loop;


   if (tipo = 1) then

     v_uf = substr(p_co_ppi, 2, 2);


     for reg_munic in
       select substr(co_seq_cons_perc_int_h, 8, 6) as munic,
              sum(a.qt_fisico) as qt_fisico
       from dbsisppi.tb_cons_perc_internacao_h a
       where a.co_financiamento = formafinan
       and a.tp_complexidade = complexidade
       and substr(co_seq_cons_perc_int_h, 2, 2) = v_uf
       and substr(co_seq_cons_perc_int_h, 8, 6) <> '000000'
       and a.co_ppi = p_co_ppi
       group by substr(co_seq_cons_perc_int_h, 8, 6)
     loop

         for reg_perc in

            select l.co_seq_leito_espec_h_munic, l.vl_distribuicao
            from dbsisppi.tb_leito_espec_h_munic l
            inner join dbsisppi.tb_destaque d
            on l.co_destaque = d.co_seq_destaque
            where substr(l.co_seq_leito_espec_h_munic, 8, 6) = reg_munic.munic
            and l.vl_distribuicao > 0
            and d.co_financiamento = formafinan
            and d.tp_complexidade = complexidade
            and d.co_ppi = p_co_ppi

         loop

            v_qt_fisico = trunc((reg_munic.qt_fisico * reg_perc.vl_distribuicao) / 100);

            update dbsisppi.tb_leito_espec_h_munic
            set qt_fisico = v_qt_fisico
            where co_seq_leito_espec_h_munic = reg_perc.co_seq_leito_espec_h_munic;

         end loop;


     end loop;


   end if;


   return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."carga_tb_leito_espec_h_municipio_vl_medio" (p_co_ppi varchar, complexidade varchar, formafinan varchar) RETURNS boolean AS
$body$
DECLARE
   reg_generica record;
   v_qtd_municipio integer;
   v_valor_medio numeric;
begin


   for reg_generica in
     select e.co_seq_leito_espec_h, de.co_seq_destaque
     from dbsisppi.tb_leito_espec_h e,
     dbsisppi.tb_destaque de
     where e.co_destaque = de.co_seq_destaque
     and de.co_ppi = p_co_ppi
     and de.tp_complexidade = complexidade
     and de.co_financiamento = formafinan
   loop


         select

             (sum((lm.qt_fisico_producao_propria *
                case lm.vl_medio_proprio
                when 0 then lm.vl_medio_referenciado
                else lm.vl_medio_proprio
                end +
                 lm.qt_fisico_producao_referenciad *
                 case lm.vl_medio_referenciado
                  when 0 then lm.vl_medio_proprio
                  else lm.vl_medio_referenciado
                  end))
               /
              sum (
                  lm.qt_fisico_producao_propria +
                  lm.qt_fisico_producao_referenciad
               )) as final

         from dbsisppi.tb_leito_espec_h_munic lm
         where lm.co_destaque =  reg_generica.co_seq_destaque
         and  (lm.qt_fisico_producao_propria + lm.qt_fisico_producao_referenciad) > 0
         and lm.vl_medio_proprio + lm.vl_medio_referenciado > 0

         into v_valor_medio;

     update dbsisppi.tb_leito_espec_h set
     vl_medio_municipal = v_valor_medio
     where co_seq_leito_espec_h = reg_generica.co_seq_leito_espec_h;

   end loop;

   return 1;

end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_h" (p_co_ppi varchar, p_co_financiamento varchar, p_tp_complexidade varchar, p_qt_fisico_param numeric, p_qt_populacaoestado numeric) RETURNS boolean AS
$body$
declare
  reg_carga record;
begin

   for reg_carga in
          select h.co_seq_espec_executor_h,

            trunc (
              sum (
                   (e.qt_populacao *
                     round (
                             (
                             p_qt_fisico_param
                             *
                             l.vl_distribuicao
                            ) / 100
                          )
                       /
                     p_qt_populacaoestado
                    ) / 100 *  a.vl_perc
                   )
                  )  as pcFisico

            from dbsisppi.tb_espec_executor_h h,
            dbsisppi.tb_leito_espec_h l,
            dbsisppi.tb_destaque d,
            dbsisppi.tb_encaminhador_h e,
            dbsisppi.tb_abrangencia_h a
            where h.co_leito_espec_h = l.co_seq_leito_espec_h
            and l.co_destaque = d.co_seq_destaque
            and d.co_ppi = p_co_ppi
            and d.co_financiamento = p_co_financiamento
            and d.tp_complexidade = p_tp_complexidade
            and l.tp_abrangencia = 1
            and h.co_seq_espec_executor_h = e.co_espec_executor_h
            and a.co_leito_espec_h = h.co_leito_espec_h
            and a.co_municipio_ibge_res = e.co_municipio_ibge_res
            and a.co_municipio_ibge_mov = h.co_municipio_ibge_mov
            group by  h.co_seq_espec_executor_h

          loop

            update dbsisppi.tb_espec_executor_h set
            qt_fisico = reg_carga.pcFisico
            where co_seq_espec_executor_h = reg_carga.co_seq_espec_executor_h;

         end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_a" (p_co_ppi varchar, p_co_financiamento varchar, p_co_alta_comp_amb varchar, p_co_modalidade varchar, p_qt_populacaoestado numeric) RETURNS boolean AS
$body$
declare
  reg_carga record;

  v_qt_fisico numeric;
  producao integer;
begin


     if (p_co_alta_comp_amb = '3') then

        select c.st_parametrizacao_preenchida
        from dbsisppi.tb_configurar_ppi_estadual c
        where c.co_ppi = p_co_ppi
        into producao;

         for reg_carga in

            select
            e.co_seq_espec_executor_a, e.qt_fisico_producao
            from dbsisppi.tb_espec_executor_a e
            inner join dbsisppi.tb_parametrizacao_alta_comp_a p
            on e.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
            inner join dbsisppi.rl_altacompamb_modalidade am
            on p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
            where am.co_alta_comp_amb = p_co_alta_comp_amb
            and am.co_modalidade = p_co_modalidade
            and p.co_ppi = p_co_ppi
            and p.co_financiamento = p_co_financiamento
          loop


            if (producao = 1) then
                update dbsisppi.tb_espec_executor_a set
                qt_fisico = reg_carga.qt_fisico_producao
                where co_seq_espec_executor_a = reg_carga.co_seq_espec_executor_a;
           else
                update dbsisppi.tb_espec_executor_a set
                qt_fisico = 0
                where co_seq_espec_executor_a = reg_carga.co_seq_espec_executor_a;
           end if;



         end loop;

      else



        for reg_carga in
          select ee.co_seq_espec_executor_a,

            trunc (
              sum (
                   (e.qt_populacao *
                     p.qt_fisico_proposto
                       /
                     p_qt_populacaoestado
                    ) / 100 *  a.vl_perc
                   )
                  )  as pcFisico

            from dbsisppi.tb_espec_executor_a ee,
            dbsisppi.tb_parametrizacao_alta_comp_a p,
            dbsisppi.rl_altacompamb_modalidade am,
            dbsisppi.tb_encaminhador_a e,
            dbsisppi.tb_abrangencia_a a
            where ee.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
            and p.co_ppi = p_co_ppi
            and p.co_financiamento = p_co_financiamento
            and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
            and am.co_alta_comp_amb = p_co_alta_comp_amb
            and am.co_modalidade = p_co_modalidade
            and p.tp_abrangencia = 1
            and ee.co_seq_espec_executor_a = e.co_espec_executor_a
            and a.co_param_alta_comp_a = ee.co_param_alta_comp_a
            and a.co_municipio_ibge_res = e.co_municipio_ibge_res
            and a.co_municipio_ibge_mov = ee.co_municipio_ibge_mov
            group by  ee.co_seq_espec_executor_a

          loop

            update dbsisppi.tb_espec_executor_a set
            qt_fisico = reg_carga.pcFisico
            where co_seq_espec_executor_a = reg_carga.co_seq_espec_executor_a;

         end loop;

         end if;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_uti" (p_co_ppi varchar, p_co_financiamento varchar, p_qt_populacaoestado numeric) RETURNS boolean AS
$body$
declare
  reg_carga record;
begin

        for reg_carga in
         select h.co_seq_espec_executor_uti,

             trunc (
              sum (
                   (e.qt_populacao *
                     l.qt_fisico_cib
                       /
                   p_qt_populacaoestado
                    ) / 100 *  a.vl_perc
                   )
                  )  as pcFisico

            from dbsisppi.tb_espec_executor_uti h,
            dbsisppi.tb_leito_uti_h l,
            dbsisppi.tb_encaminhador_uti e,
            dbsisppi.tb_abrangencia_uti a
            where h.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 1
            and h.co_seq_espec_executor_uti = e.co_espec_executor_uti
            and a.co_leito_uti_h = h.co_leito_uti_h
            and a.co_municipio_ibge_res = e.co_municipio_ibge_res
            and a.co_municipio_ibge_mov = h.co_municipio_ibge_mov
            group by  h.co_seq_espec_executor_uti

          loop

            update dbsisppi.tb_espec_executor_uti set
            qt_fisico = reg_carga.pcFisico
            where co_seq_espec_executor_uti = reg_carga.co_seq_espec_executor_uti;

         end loop;

    return 1;
end;
$body$
LANGUAGE 'plpgsql' VOLATILE CALLED ON NULL INPUT SECURITY INVOKER;



CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_h_tipo2" (p_co_ppi varchar, p_co_financiamento varchar, p_tp_complexidade varchar, p_qt_fisico_param numeric, p_co_leito varchar) RETURNS boolean AS
$body$
declare
  reg_carga record;
  param numeric;
  abrang numeric;
  fisico numeric;
  v_co_espec_executor_h varchar;
begin

   for reg_carga in

    select h.co_seq_espec_executor_h,
    ((
     select
    h4.qt_fisico * 100 /
    (
    select
      case sum(h3.qt_fisico)
       when 0 then 1
       else
       sum(h3.qt_fisico)
       end
    from dbsisppi.tb_espec_executor_h h3,
    dbsisppi.tb_leito_espec_h l,
    dbsisppi.tb_destaque d
    where h3.co_leito_espec_h =l.co_seq_leito_espec_h
    and l.co_destaque = d.co_seq_destaque
    and d.co_ppi = p_co_ppi
    and d.co_financiamento = p_co_financiamento
    and d.tp_complexidade = p_tp_complexidade
    and l.tp_abrangencia = 2
    and h4.co_leito_espec_h = h3.co_leito_espec_h
    ) as perc
    from dbsisppi.tb_espec_executor_h h4,
    dbsisppi.tb_leito_espec_h l,
    dbsisppi.tb_destaque d
    where h4.co_leito_espec_h =l.co_seq_leito_espec_h
    and l.co_destaque = d.co_seq_destaque
    and d.co_ppi = p_co_ppi
    and d.co_financiamento = p_co_financiamento
    and d.tp_complexidade = p_tp_complexidade
    and l.tp_abrangencia = 2
    and h4.co_seq_espec_executor_h = h.co_seq_espec_executor_h
    )) as percentual,

    cast((
    (
    select h2.qt_fisico * 100 /
    (
    select
     case sum(h1.qt_fisico)
       when 0 then 1
       else
       sum(h1.qt_fisico)
       end
    from dbsisppi.tb_espec_executor_h h1,
    dbsisppi.tb_leito_espec_h l,
    dbsisppi.tb_destaque d
    where h1.co_leito_espec_h =l.co_seq_leito_espec_h
    and l.co_destaque = d.co_seq_destaque
    and d.co_ppi = p_co_ppi
    and d.co_financiamento = p_co_financiamento
    and d.tp_complexidade = p_tp_complexidade
    and l.tp_abrangencia = 2
    and h2.co_leito_espec_h = h1.co_leito_espec_h
    ) as perc
    from dbsisppi.tb_espec_executor_h h2,
    dbsisppi.tb_leito_espec_h l,
    dbsisppi.tb_destaque d
    where h2.co_leito_espec_h =l.co_seq_leito_espec_h
    and l.co_destaque = d.co_seq_destaque
    and d.co_ppi = p_co_ppi
    and d.co_financiamento = p_co_financiamento
    and d.tp_complexidade = p_tp_complexidade
    and l.tp_abrangencia = 2
    and h2.co_seq_espec_executor_h = h.co_seq_espec_executor_h
    )
    *
    (p_qt_fisico_param * l.vl_distribuicao/100)
    )/100
    as numeric(12,0))as pcFisico
    from dbsisppi.tb_espec_executor_h h,
    dbsisppi.tb_leito_espec_h l,
    dbsisppi.tb_destaque d
    where h.co_leito_espec_h =l.co_seq_leito_espec_h
    and l.co_destaque = d.co_seq_destaque
    and d.co_ppi = p_co_ppi
    and d.co_financiamento = p_co_financiamento
    and d.tp_complexidade = p_tp_complexidade
    and l.tp_abrangencia = 2
    and h.co_leito_espec_h = p_co_leito
    group by  h.co_seq_espec_executor_h,l.vl_distribuicao

    loop
      update dbsisppi.tb_espec_executor_h set
      qt_fisico = reg_carga.pcFisico,
      vl_perc =  reg_carga.percentual
      where co_seq_espec_executor_h = reg_carga.co_seq_espec_executor_h;

   end loop;



      select cast((p_qt_fisico_param * l.vl_distribuicao/100) as numeric(12,0))
      from dbsisppi.tb_leito_espec_h l
      where l.co_seq_leito_espec_h = p_co_leito
      into param;


      select sum(e.qt_fisico)
      from dbsisppi.tb_espec_executor_h e
      where e.co_leito_espec_h = p_co_leito
      into abrang;

 if abrang > param then

    select e.co_seq_espec_executor_h, e.qt_fisico
    from dbsisppi.tb_espec_executor_h e
    where e.co_leito_espec_h = p_co_leito
    order by e.qt_fisico desc limit 1
    into v_co_espec_executor_h, fisico;

    update dbsisppi.tb_espec_executor_h set
    qt_fisico = fisico - (abrang-param),
    vl_perc = (fisico - (abrang-param)) * 100 / param
    where co_seq_espec_executor_h = v_co_espec_executor_h;

 end if;



    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_a_tipo2" (p_co_ppi varchar, p_co_financiamento varchar, p_co_alta_comp_amb varchar, p_co_modalidade varchar, p_co_param_alta_comp_a varchar) RETURNS boolean AS
$body$
declare
  reg_carga record;
  param numeric;
  abrang numeric;
  fisico numeric;
  v_co_seq_espec_executor_a varchar;
begin
     for reg_carga in

      select ee.co_seq_espec_executor_a,
      (select
      (ee2.qt_fisico * 100)/
      (
      select
       case sum(ee1.qt_fisico)
       when 0 then 1
       else
       sum(ee1.qt_fisico)
       end
      from dbsisppi.tb_espec_executor_a ee1,
      dbsisppi.tb_parametrizacao_alta_comp_a p,
      dbsisppi.rl_altacompamb_modalidade am
      where ee1.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
      and p.co_ppi = p_co_ppi
      and p.co_financiamento = p_co_financiamento
      and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
      and am.co_alta_comp_amb = p_co_alta_comp_amb
      and am.co_modalidade = p_co_modalidade
      and ee2.co_param_alta_comp_a = ee1.co_param_alta_comp_a
      )
      from dbsisppi.tb_espec_executor_a ee2,
      dbsisppi.tb_parametrizacao_alta_comp_a p,
      dbsisppi.rl_altacompamb_modalidade am
      where ee2.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
      and p.co_ppi = p_co_ppi
      and p.co_financiamento = p_co_financiamento
      and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
      and am.co_alta_comp_amb = p_co_alta_comp_amb
      and am.co_modalidade = p_co_modalidade
      and ee2.co_seq_espec_executor_a =ee.co_seq_espec_executor_a
      ) as percentual,

      cast((
      (
      select
      (ee2.qt_fisico * 100)/
      (
      select
       case sum(ee1.qt_fisico)
       when 0 then 1
       else
       sum(ee1.qt_fisico)
       end
      from dbsisppi.tb_espec_executor_a ee1,
      dbsisppi.tb_parametrizacao_alta_comp_a p,
      dbsisppi.rl_altacompamb_modalidade am
      where ee1.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
      and p.co_ppi = p_co_ppi
      and p.co_financiamento = p_co_financiamento
      and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
      and am.co_alta_comp_amb = p_co_alta_comp_amb
      and am.co_modalidade = p_co_modalidade
      and ee2.co_param_alta_comp_a = ee1.co_param_alta_comp_a
      )
      from dbsisppi.tb_espec_executor_a ee2,
      dbsisppi.tb_parametrizacao_alta_comp_a p,
      dbsisppi.rl_altacompamb_modalidade am
      where ee2.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
      and p.co_ppi = p_co_ppi
      and p.co_financiamento = p_co_financiamento
      and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
      and am.co_alta_comp_amb = p_co_alta_comp_amb
      and am.co_modalidade = p_co_modalidade
      and ee2.co_seq_espec_executor_a =ee.co_seq_espec_executor_a
      )
      * p.qt_fisico_proposto)/100
      as numeric(12,0))as pcFisico
      from dbsisppi.tb_espec_executor_a ee,
      dbsisppi.tb_parametrizacao_alta_comp_a p,
      dbsisppi.rl_altacompamb_modalidade am
      where ee.co_param_alta_comp_a = p.co_seq_param_alta_comp_a
      and p.co_ppi = p_co_ppi
      and p.co_financiamento = p_co_financiamento
      and p.co_alta_comp_amb_mod = am.co_seq_alta_comp_amb_mod
      and am.co_alta_comp_amb = p_co_alta_comp_amb
      and am.co_modalidade = p_co_modalidade
      and ee.co_param_alta_comp_a = p_co_param_alta_comp_a
      group by  ee.co_seq_espec_executor_a,p.qt_fisico_proposto

     loop

        update dbsisppi.tb_espec_executor_a set
        qt_fisico = reg_carga.pcFisico,
        vl_perc  = reg_carga.percentual
        where co_seq_espec_executor_a = reg_carga.co_seq_espec_executor_a;

     end loop;


      select sum(p.qt_fisico_proposto)
      from dbsisppi.tb_parametrizacao_alta_comp_a p
      where p.co_seq_param_alta_comp_a = p_co_param_alta_comp_a
      into param;


      select sum(e.qt_fisico)
      from dbsisppi.tb_espec_executor_a e
      where e.co_param_alta_comp_a = p_co_param_alta_comp_a
      into abrang;

     if abrang > param then

        select e.co_seq_espec_executor_a, e.qt_fisico
        from dbsisppi.tb_espec_executor_a e
        where e.co_param_alta_comp_a = p_co_param_alta_comp_a
        order by e.qt_fisico desc limit 1
        into v_co_seq_espec_executor_a, fisico;

        update dbsisppi.tb_espec_executor_a set
        qt_fisico = fisico - (abrang-param),
        vl_perc = (fisico - (abrang-param)) * 100 / param
        where co_seq_espec_executor_a = v_co_seq_espec_executor_a;

     end if;


    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;

CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_uti_tipo2" (p_co_ppi varchar, p_co_financiamento varchar, p_co_leito varchar) RETURNS boolean AS
$body$
declare
  reg_carga record;
  param numeric;
  abrang numeric;
  fisico numeric;
  v_co_espec_executor_uti varchar;
begin

        for reg_carga in

            select h.co_seq_espec_executor_uti,
            (
            select
            (h2.qt_fisico * 100)/
            (
            select
            case sum(h1.qt_fisico)
            when 0 then 1
            else
            sum(h1.qt_fisico)
            end
            from dbsisppi.tb_espec_executor_uti h1,
            dbsisppi.tb_leito_uti_h l
            where h1.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 2
            and h1.qt_fisico > 0
            and h2.co_leito_uti_h = h1.co_leito_uti_h
            )
            from dbsisppi.tb_espec_executor_uti h2,
            dbsisppi.tb_leito_uti_h l
            where h2.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 2
            and h2.co_seq_espec_executor_uti = h.co_seq_espec_executor_uti
            ) as percentual,

            cast ((
            select
            (h2.qt_fisico * 100)/
            (
            select
            case sum(h1.qt_fisico)
            when 0 then 1
            else
            sum(h1.qt_fisico)
            end
            from dbsisppi.tb_espec_executor_uti h1,
            dbsisppi.tb_leito_uti_h l
            where h1.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 2
            and h1.qt_fisico > 0
            and h2.co_leito_uti_h = h1.co_leito_uti_h
            )
            from dbsisppi.tb_espec_executor_uti h2,
            dbsisppi.tb_leito_uti_h l
            where h2.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 2
            and h2.co_seq_espec_executor_uti = h.co_seq_espec_executor_uti
            )
            * l.qt_fisico_cib / 100
            as numeric(12,0))  as pcFisico
            from dbsisppi.tb_espec_executor_uti h,
            dbsisppi.tb_leito_uti_h l
            where h.co_leito_uti_h = l.co_seq_leito_uti_h
            and l.co_ppi = p_co_ppi
            and l.co_financiamento = p_co_financiamento
            and l.tp_abrangencia = 2
            and h.co_leito_uti_h = p_co_leito
            group by  h.co_seq_espec_executor_uti,l.qt_fisico_cib

       loop

            update dbsisppi.tb_espec_executor_uti set
             qt_fisico = reg_carga.pcFisico,
            vl_perc =  reg_carga.percentual
            where co_seq_espec_executor_uti = reg_carga.co_seq_espec_executor_uti;

         end loop;



      select l.qt_fisico_cib
      from dbsisppi.tb_leito_uti_h l
      where l.co_seq_leito_uti_h = p_co_leito
      into param;


      select sum(e.qt_fisico)
      from dbsisppi.tb_espec_executor_uti e
      where e.co_leito_uti_h = p_co_leito
      into abrang;

 if abrang > param then

    select e.co_seq_espec_executor_uti, e.qt_fisico
    from dbsisppi.tb_espec_executor_uti e
    where e.co_leito_uti_h = p_co_leito
    order by e.qt_fisico desc limit 1
    into v_co_espec_executor_uti, fisico;

    update dbsisppi.tb_espec_executor_uti set
    qt_fisico = fisico - (abrang-param),
    vl_perc = (fisico - (abrang-param)) * 100 / param
    where co_seq_espec_executor_uti = v_co_espec_executor_uti;

 end if;

    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;


CREATE OR REPLACE FUNCTION "dbsisppi"."fg_atualiza_abrangencia_agregado_tipo2" (p_co_ppi varchar, p_co_financiamento varchar, p_co_agregado varchar) RETURNS boolean AS
$body$
declare
  reg_carga record;
  param numeric;
  abrang numeric;
  fisico numeric;
  v_co_agregado varchar;
  v_co_seq_executor_agregado varchar;
begin

        for reg_carga in

              select h.co_seq_executor_agregado,
              (
              select
              (h2.qt_fisico * 100)/
              (
              select
              case sum(h1.qt_fisico)
               when 0 then 1
               else
               sum(h1.qt_fisico)
               end
              from dbsisppi.tb_executor_agregado h1,
              dbsisppi.tb_parametro_agregado l
              where h1.co_agregado = l.co_agregado
              and h1.co_financiamento = l.co_financiamento
              and l.co_ppi = p_co_ppi
              and l.co_financiamento = p_co_financiamento
               and l.co_identificador ='0000000000000'
              and h1.qt_fisico > 0
              and h2.co_agregado = h1.co_agregado
              )
              from dbsisppi.tb_executor_agregado h2,
              dbsisppi.tb_parametro_agregado l
              where h2.co_agregado = l.co_agregado
              and h2.co_financiamento = l.co_financiamento
              and l.co_ppi = p_co_ppi
              and l.co_financiamento = p_co_financiamento
               and l.co_identificador ='0000000000000'
              and h2.co_seq_executor_agregado = h.co_seq_executor_agregado
              ) as percentual,

              cast ((
              select
              (h2.qt_fisico * 100)/
              (
              select
              case sum(h1.qt_fisico)
               when 0 then 1
               else
               sum(h1.qt_fisico)
               end
              from dbsisppi.tb_executor_agregado h1,
              dbsisppi.tb_parametro_agregado l
              where h1.co_agregado = l.co_agregado
              and h1.co_financiamento = l.co_financiamento
              and l.co_ppi = p_co_ppi
              and l.co_financiamento = p_co_financiamento
               and l.co_identificador ='0000000000000'
              and h1.qt_fisico > 0
              and h2.co_agregado = h1.co_agregado
              )
              from dbsisppi.tb_executor_agregado h2,
              dbsisppi.tb_parametro_agregado l
              where h2.co_agregado = l.co_agregado
              and h2.co_financiamento = l.co_financiamento
              and l.co_ppi = p_co_ppi
              and l.co_financiamento = p_co_financiamento
               and l.co_identificador ='0000000000000'
              and h2.co_seq_executor_agregado = h.co_seq_executor_agregado
              )
              * (l.qt_fisico_agregado + l.qt_fisico_estrategica) / 100
              as numeric(12,0))  as pcFisico
              from dbsisppi.tb_executor_agregado h,
              dbsisppi.tb_parametro_agregado l
              where h.co_agregado = l.co_agregado
              and h.co_financiamento = l.co_financiamento
              and l.co_ppi = p_co_ppi
              and l.co_financiamento = p_co_financiamento
               and l.co_identificador ='0000000000000'
              and h.co_agregado = p_co_agregado
              group by  h.co_seq_executor_agregado,l.qt_fisico_agregado,l.qt_fisico_estrategica


       loop

           update dbsisppi.tb_executor_agregado set
           qt_fisico = reg_carga.pcFisico,
           vl_perc =  reg_carga.percentual
           where co_seq_executor_agregado = reg_carga.co_seq_executor_agregado
           and co_financiamento = p_co_financiamento;

      end loop;



      select sum(p.qt_fisico_agregado + p.qt_fisico_estrategica)
      from dbsisppi.tb_parametro_agregado p
      where p.co_agregado = p_co_agregado
      and p.co_financiamento = p_co_financiamento
      and p.co_identificador ='0000000000000'
      into param;


      select sum(e.qt_fisico)
      from dbsisppi.tb_executor_agregado e
      where e.co_agregado = p_co_agregado
      and e.co_financiamento = p_co_financiamento
      into abrang;

    if abrang > param then

        select e.co_seq_executor_agregado, e.qt_fisico
        from dbsisppi.tb_executor_agregado e
        where e.co_agregado = p_co_agregado
        and e.co_financiamento = p_co_financiamento
        order by e.qt_fisico desc limit 1
        into v_co_seq_executor_agregado, fisico;

        update dbsisppi.tb_executor_agregado set
        qt_fisico = fisico - (abrang-param),
        vl_perc = (fisico - (abrang-param)) * 100 / param
        where co_seq_executor_agregado = v_co_seq_executor_agregado
         and co_financiamento = p_co_financiamento  ;

    end if;

    return 1;
end;
$body$
LANGUAGE 'plpgsql'
VOLATILE
CALLED ON NULL INPUT
SECURITY INVOKER;